/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  thes *  benefitting.  We hope that y*******/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"


/*
* Local functions.
*/ void talk_channel args( ( CHAR_DATA *ch, char *argument, int channel, const char *verb ) );
bool is_in		args( (char *, char *) );
bool all_in		args( (char *, char *) );
char * socialc		args( ( CHAR_DATA *ch, char *argument, char *you, char *them ) );
char * socialv		args( ( CHAR_DATA *ch, char *argument, char *you, char *them ) );
char * socialn		args( ( CHAR_DATA *ch, char *argument, char *you, char *them ) );

void game_in_play(CHAR_DATA *ch, char *argument);

/* Trace's Bounty code */
void do_bounty( CHAR_DATA *ch, char *argument )
{
	char arg1 [MAX_INPUT_LENGTH];
	char arg2 [MAX_INPUT_LENGTH];
	char buf[MAX_STRING_LENGTH];
	CHAR_DATA *victim;

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );

	if(IS_NPC(ch))return;

	if ( arg1[0] == '\0' || arg2[0] == '\0' )
	{
		send_to_char( "Place a bounty on who's head?\n\rSyntax:  Bounty <victim> <amount>\n\r", ch );
		return;
	}

	if ( ( victim = get_char_world( ch, arg1 ) ) == NULL)
	{
		send_to_char( "They are currently not logged in!", ch );
		return;
	}

	if (IS_NPC(victim))
	{
		send_to_char( "You cannot put a bounty on NPCs!", ch );
		return;
	}
	if( victim == ch)
	{
		stc( "Not on yourself\n\r",ch);
		return;
	}

	if (victim->level >= 7)
	{
		send_to_char( "You can't put a bounty on an immortal.",ch);
		return;
	}

	if ( is_number( arg2 ) )
	{
		int amount;
		amount   = atoi(arg2);
		if( amount < 100 )
		{
			stc( "Needs to be at least 100 QPs, less than that you gotta be kidding.\n\r",ch);
			return;
		}
		if (ch->pcdata->quest < amount)
		{
			send_to_char( "You don't have that many QPs!", ch );
			return;
		}
		ch->pcdata->quest -= amount;
		victim->pcdata->bounty +=amount;
		sprintf( buf, "You have placed a %d QP bounty on %s.\n\r",amount,victim->name );
		send_to_char(buf,ch);
		sprintf(buf, "%s now has a bounty of %d QPs on their head.\n\r",victim->name, victim->pcdata->bounty );
		do_info(ch, buf);
		return;
	}
}



/*
* Generic channel function.
*/
void talk_channel( CHAR_DATA *ch, char *argument, int channel, const char *verb )
{
	char buf[MAX_STRING_LENGTH];
	char buf2[MAX_STRING_LENGTH];
	DESCRIPTOR_DATA *d;
	int pos;
	bool ignored;
	int position;
	//   if ( IS_NPC(ch) && ch->desc == NULL )
  //      return;

	if (RTIMER(ch->in_room, RTIMER_SILENCE) != 0)
	{
		send_to_char("Something prevents you from speaking in this room.\n\r", ch);
		return;
	}
	if ( argument[0] == '\0' )
	{
		sprintf( buf, "%s what?\n\r", verb );
		buf[0] = UPPER(buf[0]);
		return;
	}

	if ( IS_HEAD(ch, LOST_TONGUE) )
	{
		sprintf( buf, "You can't %s without a tongue!\n\r", verb );
		send_to_char( buf, ch );
		return;
	}

	if ( IS_EXTRA(ch, GAGGED) )
	{
		sprintf( buf, "You can't %s with a gag on!\n\r", verb );
		send_to_char( buf, ch );
		return;
	}

	if ( !IS_NPC(ch) && IS_SET(ch->act, PLR_SILENCE) )
	{
		sprintf( buf, "You can't %s.\n\r", verb );
		send_to_char( buf, ch );
		return;
	}

	REMOVE_BIT(ch->deaf, channel);

	switch ( channel )
	{
	default:

		if (ch->flag4==1)
		{
			sprintf( buf, "You whine '11%s#n'.\n\r",  argument );
			send_to_char( buf, ch );

			sprintf( buf, "$n #Pwhines#n '#1$t#n'." );
			sprintf( buf2, "$n #Pwhines#n '#1$t#n'."  );

		}
		else if (channel == CHANNEL_FLAME)  {
			sprintf( buf, "You %s '#C%s#n'.\n\r", verb, argument );
			send_to_char( buf, ch );

			sprintf( buf, "$n %ss '#C$t#n'.",     verb );
			sprintf( buf2, "$n %ss '#C$t#n'.",     verb );

		}
		else if (channel == CHANNEL_CHAT)
		{
			sprintf( buf, "You %s '#1%s#n'.\n\r", verb, argument );
			send_to_char( buf, ch );

			if (ch->trust > 6) {
				sprintf( buf, "#y(#G*#y)#C$n#y(#G*#y)#n '#R$t#n'.");
				sprintf( buf2,"#y(#G*#y)#C$n#y(#G*#y)#n '#R$t#n'.");
			}
			else {
				sprintf( buf, "$n %ss '#R$t#n'.",     verb );
				sprintf( buf2, "$n %ss '#R$t#n'.",     verb );
			}
		}

		else
		    {
			sprintf( buf, "You %s '#1%s#n'.\n\r", verb, argument );
			send_to_char( buf, ch );

			sprintf( buf, "$n %ss '#1$t#n'.",     verb );
			sprintf( buf2, "$n %ss '#1$t#n'.",     verb );

		}
		break;
	case CHANNEL_IMMTALK:
		sprintf( buf, "#y.:#P%s#y:.#C $t.#n",ch->pcdata->switchname );
		sprintf( buf2, "#y.:#P%s#y:.#C $t.#n",ch->pcdata->switchname );
		position	= ch->position;
		ch->position	= POS_STANDING;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position	= position;
		break;

	case CHANNEL_ANGEL:
		sprintf( buf, "#o[#7$n#o]#C '$t'.#n" );
		sprintf( buf2, "#o[#7$n#o]#C '$t'.#n" );
		position        = ch->position;
		ch->position    = POS_STANDING;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position    = position;
		break;

	case CHANNEL_PRAY:
		sprintf( buf, "#o[#R$n#o]#C '$t'.#n" );
		sprintf( buf2, "#o[#R$n#o]#C '$t'.#n" );
		position	= ch->position;
		ch->position	= POS_STANDING;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position	= position;
		break;
 
	case CHANNEL_RADIO:
		sprintf( buf, "#G*#C*#G*#C*#o$n#C*#G*#C*#G*#r '$t'.#n" );
		sprintf( buf2, "#G*#C*#G*#C*#o$n#C*#G*#C*#G*#r '$t'.#n" );
		position	= ch->position;
		ch->position	= POS_STANDING;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position	= position;
		break;
 
	case CHANNEL_MAGETALK: 
		sprintf( buf, "#c{{#7$n#c}}#R '$t'.#n" );
		sprintf( buf2, "#c{{#7$n#c}}#R '$t'.#n" );
		position	= ch->position;
		ch->position	= POS_STANDING;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position	= position;
		break;

	case CHANNEL_TELEPATH: /*dragons*/
		sprintf( buf, "#G*#C(>#R$n#C<)#G* #C'$t'.#n" );
		sprintf( buf2,"#G*#C(>#R$n#C<)#G* #C'$t'.#n");
		position    = ch->position;
		ch->position    = POS_STANDING;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position    = position;
		break;

	case CHANNEL_COMMUNICATE:
		sprintf( buf, "#p{#y-#p}#G$n#p{#y-#p} #C'$t'.#n");
		sprintf( buf2,"#p{#y-#p}#G$n#p{#y-#p} #C'$t'.#n");
		position   = ch->position;
		ch->position = POS_STANDING;
		act( buf,ch,argument,NULL,TO_CHAR);
		ch->position = position;
		break;

	case CHANNEL_HOWL:
		sprintf( buf, "#y((#L$n#y))#C '$t'.#n" );
		sprintf( buf2, "#y((#L$n#y))#C '$t'.#n" );
		position	= ch->position;
		ch->position	= POS_STANDING;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position	= position;
		break;

	case CHANNEL_MIKTALK:
		sprintf(buf, "#C***#y$n#C*** '$t'.#n" );
		sprintf(buf2, "#C***#y$n#C*** '$t'.#n" );
		position = ch->position;
		act(buf, ch, argument, NULL, TO_CHAR);
		ch->position = position;
		break;

	case CHANNEL_HIGHTALK:
		sprintf( buf, "#C-=#R$n#C=-  '$t'.#n" );
		sprintf(buf2, "#C-=#R$n#C=-  '$t'.#n" );
		position = ch->position;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position = position;
		break;

	case CHANNEL_KNIGHTTALK:
		sprintf( buf, "#l.x.#7$n#l.x.#C '$t'.#n");
		sprintf( buf2, "#l.x.#7$n#l.x.#C '$t'.#n");
		position        = ch->position;
		ch->position    = POS_STANDING;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position    = position;
		break;

	case CHANNEL_TANTALK:
		sprintf( buf, "#y{#R$n#y}#C '$t'.#n");
		sprintf( buf2,"#y{#R$n#y}#C '$t'.#n");
		position        = ch->position;
		ch->position    = POS_STANDING;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position    = position;
		break;

	case CHANNEL_AMAZTALK:
		sprintf( buf, "#G_#g=$n#g=#G_ '$t'.#n");
		sprintf( buf2,"#G_#g=$n#g=#G_ '$t'.#n");
		position	= ch->position;
		ch->position	= POS_STANDING;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position	= position;
		break;

	case CHANNEL_FORCETALK:
		sprintf( buf, "#L|#l=#L|$n#L|#l=#L|#C '$t'.#n");
		sprintf( buf2,"#L|#l=#L|$n#L|#l=#L|#C '$t'.#n");
		position	= ch->position;
		ch->position	= POS_STANDING;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position	= position;
		break;

	case CHANNEL_LICHTALK:
		sprintf( buf, "#G>*<#7$n#G>*<#C '$t'.#n");
		sprintf( buf2,"#G>*<#7$n#G>*<#C '$t'.#n");
		position        = ch->position;
		ch->position    = POS_STANDING;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position    = position;
		break;

	case CHANNEL_SIGN:
		sprintf( buf, "#P.o0#c$n#P0o.#C '$t'.#n");
		sprintf( buf2, "#P.o0#c$n#P0o.#C '$t'.#n");
		position        = ch->position;
		ch->position    = POS_STANDING;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position    = position;
		break;

	case CHANNEL_MOAN:
		sprintf( buf, "#o(#7@#n@#o<#l$n#o>#n@#7@#o)#r '$t'.#n");
		sprintf(buf2, "#o(#7@#n@#o<#l$n#o>#n@#7@#o)#r '$t'.#n");
		position        = ch->position;
		ch->position = POS_STANDING;
		act(buf, ch, argument, NULL, TO_CHAR);
		ch->position = position;
		break;

	case CHANNEL_KTALK:
		sprintf( buf, "#c(#l(#r>#o%s#r<#l)#c)#n '$t'.#n", ch->pcdata->switchname);
		sprintf(buf2, "#c(#l(#r>#o%s#r<#l)#c)#n '$t'.#n", ch->pcdata->switchname);
		position = ch->position;
		ch->position = POS_STANDING;
		act(buf, ch, argument, NULL, TO_CHAR);
		ch->position = position;
		break;

	case CHANNEL_MONK:
		sprintf( buf, "#o.#7x#o[#l$n#o]#7x#o. #C '$t'.#n" );
		sprintf( buf2, "#o.#7x#o[#l$n#o]#7x#o. #C '$t'.#n" );
		position        = ch->position;
		ch->position    = POS_STANDING;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position    = position;
		break;

	case CHANNEL_VAMPTALK:
		if (!IS_NPC(ch) && (ch->pcdata->stats[UNI_GEN] == 1 || IS_SET(ch->special, SPC_ANARCH)))
		{
			sprintf( buf, "#R<<#y$n#R>>#C $t.#n" );
			sprintf( buf2, "#R<<#y$n#R>>#C $t.#n" );
		}
		else if (!IS_NPC(ch) && ch->pcdata->stats[UNI_GEN] == 2)
		{
			sprintf( buf, "#R<<#y$n#R>>#C $t.#n" );
			sprintf( buf2, "#R<<#y$n#R>>#C $t.#n" );
		}
		else
		    {
			sprintf( buf, "#R<<#y$n#R>>#C $t.#n" );
			sprintf( buf2, "#R<<#y$n#R>>#C $t.#n" );
		}

		position	= ch->position;
		ch->position	= POS_STANDING;
		act( buf, ch, argument, NULL, TO_CHAR );
		ch->position	= position;
		break;
	}

	for ( d = descriptor_list; d != NULL; d = d->next )
	{
		CHAR_DATA *och;
		CHAR_DATA *vch;

		och = d->original ? d->original : d->character;
		vch = d->character;

		ignored = FALSE;

		if ( d->connected == CON_PLAYING
			    &&   vch != ch
			    &&  !IS_SET(och->deaf, channel) )
		{
			for (pos = 0; pos < MAX_FORGET; pos++) {
				if (och->pcdata->forget[pos] == NULL) break;
				if (!str_cmp(ch->name, och->pcdata->forget[pos]))
					ignored = TRUE;
			}
			if (ignored) continue;

			if ( channel == CHANNEL_IMMTALK && !IS_IMMORTAL(och) )
				continue;
			if (channel== CHANNEL_MIKTALK && (!IS_NPC(och) && !IS_CLASS(och, CLASS_NINJA) && !IS_IMMORTAL(och)))
				continue;
			if ( channel == CHANNEL_HIGHTALK && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_HIGHLANDER) && !IS_IMMORTAL(och)))
				continue;
			if (channel == CHANNEL_KTALK && (!IS_NPC(och) &&
				    !IS_IMMORTAL(och) && ch->pcdata->kingdom != och->pcdata->kingdom))
				continue;
			if ( channel == CHANNEL_SIGN && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_DROW) && !IS_IMMORTAL(och)))
				continue;
			if ( channel == CHANNEL_MONK && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_MONK) && !IS_IMMORTAL(och)))
				continue;
			if (channel == CHANNEL_COMMUNICATE && (!IS_NPC(och) &&
				    !IS_IMMORTAL(och) && !IS_CLASS(och,CLASS_CYBORG)))
				continue;
			if ( channel == CHANNEL_VAMPTALK && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_VAMPIRE) && !IS_IMMORTAL(och)))
				continue;
			if ( channel == CHANNEL_MAGETALK && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_MAGE) && !IS_IMMORTAL(och)))
				continue;
			if ( channel == CHANNEL_PRAY && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_DEMON) && !IS_IMMORTAL(och)))
				continue;
			if ( channel == CHANNEL_ANGEL && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_ANGEL) && !IS_IMMORTAL(och)))
				continue;
			if ( channel == CHANNEL_KNIGHTTALK && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_UNDEAD_KNIGHT) && !IS_IMMORTAL(och)))
				continue;
			if ( channel == CHANNEL_AMAZTALK && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_AMAZON) && !IS_IMMORTAL(och)))
				continue;
			if ( channel == CHANNEL_FORCETALK && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_JEDI) && !IS_IMMORTAL(och)))
				continue;
			if ( channel == CHANNEL_LICHTALK && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_POWER_LICH) && !IS_IMMORTAL(och)))
				continue;
			if ( channel == CHANNEL_MOAN && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_XOMBI) && !IS_IMMORTAL(och)))
				continue;
			if ( channel == CHANNEL_TANTALK && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_TANARRI) && !IS_IMMORTAL(och)))
				continue;
			if ( channel == CHANNEL_RADIO && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_UNISOL) && !IS_IMMORTAL(och)))
				continue;
			if ( channel == CHANNEL_TELEPATH && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_SHAPESHIFTER) && !IS_IMMORTAL(och)))
				continue;
			if ( channel == CHANNEL_HOWL && (!IS_NPC(och) &&
				    !IS_CLASS(och, CLASS_WEREWOLF) && !IS_POLYAFF(och,POLY_WOLF)
				    && !IS_IMMORTAL(och)))
			{
				if ((och->in_room) && (ch->in_room))
				{
					if ((och->in_room == ch->in_room))
					{
						act("$n throws back $s head and howls loudly.", ch , argument , och, TO_VICT);
						continue;
					}
					else if ((och->in_room->area == ch->in_room->area ))
					{
						act("You hear a loud howl nearby.", ch , NULL , och, TO_VICT);
						continue;
					}
					else
					    {
						act("You hear a loud howl in the distance.", ch , NULL , och, TO_VICT);
						continue;
					}
				}
			}

			if ( channel == CHANNEL_YELL
				    &&   vch->in_room->area != ch->in_room->area )
				continue;

			position		= vch->position;
			if ( channel != CHANNEL_SHOUT && channel != CHANNEL_YELL )
				vch->position	= POS_STANDING;

			/*	    if(!IS_NPC(vch) && IS_IMMORTAL(vch) ){
			if( str_cmp(ch->name,ch->pcdata->switchname) )
			strcat(buf2,ch->pcdata->switchname);
			}
			*/
			if (!IS_NPC(vch) && IS_CLASS(vch, CLASS_VAMPIRE))
			{
				act( buf2, ch, argument, vch, TO_VICT );
				vch->position	= position;
				continue;
			}
			if (!IS_NPC(vch) && IS_CLASS(vch, CLASS_SHAPESHIFTER))
			{
				act( buf2, ch, argument, vch, TO_VICT );
				vch->position	= position;
				continue;
			}
			if (!IS_NPC(vch) && IS_CLASS(vch, CLASS_WEREWOLF))
			{
				act( buf2, ch, argument, vch, TO_VICT );
				vch->position	= position;
				continue;
			}
			if (!IS_NPC(vch) && IS_CLASS(vch, CLASS_MONK))
			{
				act( buf2, ch, argument, vch, TO_VICT );
				vch->position   = position;
				continue;
			}
			if (!IS_NPC(vch) && (IS_CLASS(vch, CLASS_DEMON)||IS_IMMORTAL(vch)))
			{
				act( buf2, ch, argument, vch, TO_VICT );
				vch->position	= position;
				continue;
			}
			if (!IS_NPC(vch) && (IS_CLASS(vch,CLASS_MAGE)||IS_IMMORTAL(vch)))
			{
				act( buf2, ch, argument, vch, TO_VICT );
				vch->position	= position;
				continue;
			}
			if (!IS_NPC(vch) && (IS_CLASS(vch, CLASS_HIGHLANDER)||IS_IMMORTAL(vch))) {
				act(buf2, ch, argument, vch, TO_VICT);
				vch->position = position;
				continue;
			}
			act( buf, ch, argument, vch, TO_VICT );
			vch->position	= position;
		}
	}

	return;
}
/*
void do_auction( CHAR_DATA *ch, char *argument )
{
talk_channel( ch, argument, CHANNEL_AUCTION, "auction" );
return;
}
*/


void room_message(ROOM_INDEX_DATA *room, char *message)
{
	CHAR_DATA *rch;

	if ( (rch = room->people) == NULL) return;

	act(message, rch, NULL, NULL, TO_ROOM);
	act(message, rch, NULL, NULL, TO_CHAR);
}

void do_chat( CHAR_DATA *ch, char *argument )
{
	if (!IS_NPC(ch) && ch->mkill < 20 && ch->level < 3)
	{
		send_to_char("Because of abuse of the chat channel (spamming, etc) you need 20 mob kills to use chat.\n\r",ch);
		send_to_char("Getting 20 mob kills is not hard, most mobs in the newbie arena and mud school\n\r",ch);
		send_to_char("die when you touch them.\n\r",ch);
		return;
	}
	talk_channel( ch, argument, CHANNEL_CHAT, "chat" );
	return;
}

void do_flame( CHAR_DATA *ch, char *argument )  {
	talk_channel( ch, argument, CHANNEL_FLAME, "flame" );
	return;
}


/*
* Alander's new channels.
*/
void do_music( CHAR_DATA *ch, char *argument )
{
	talk_channel( ch, argument, CHANNEL_MUSIC, "music" );

	return;
}



void do_question( CHAR_DATA *ch, char *argument )
{
	talk_channel( ch, argument, CHANNEL_QUESTION, "question" );

	return;
}



void do_answer( CHAR_DATA *ch, char *argument )
{
	talk_channel( ch, argument, CHANNEL_QUESTION, "answer" );

	return;
}



void do_shout( CHAR_DATA *ch, char *argument )
{

	talk_channel( ch, argument, CHANNEL_SHOUT, "shout" );

	WAIT_STATE( ch, 12 );
	return;
}



void do_yell( CHAR_DATA *ch, char *argument )
{

	talk_channel( ch, argument, CHANNEL_YELL, "yell" );

	return;
}



void do_immtalk( CHAR_DATA *ch, char *argument )
{
	talk_channel( ch, argument, CHANNEL_IMMTALK, "immtalk" );
	return;
}

void do_monktalk( CHAR_DATA *ch, char *argument ) {
	if (IS_NPC(ch) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch, CLASS_MONK))) {
                do_rand_typo(ch,"");
		return;
	}
	talk_channel(ch, argument, CHANNEL_MONK, "monk");
	return;
}

void do_moan( CHAR_DATA *ch, char *argument ) {

	if (IS_NPC(ch) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch, CLASS_XOMBI))) {
                do_rand_typo(ch,"");
		return;
	}
	talk_channel(ch, argument, CHANNEL_MOAN, "moan");
	return;
}

void do_miktalk( CHAR_DATA *ch, char *argument ) {

	if (IS_NPC(ch) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch, CLASS_NINJA)))
	{
                do_rand_typo(ch,"");
		return;
	}
	talk_channel(ch, argument, CHANNEL_MIKTALK, "miktalk");
	return;
}

void do_hightalk( CHAR_DATA *ch, char *argument )
{

	if (IS_NPC(ch) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch,CLASS_HIGHLANDER)))
	{
                do_rand_typo(ch,"");
		return;
	}
	talk_channel( ch, argument, CHANNEL_HIGHTALK, "hightalk" );
	return;
}
void do_knighttalk( CHAR_DATA *ch, char *argument )
{

	if (IS_NPC(ch) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch,CLASS_UNDEAD_KNIGHT)))
	{
                do_rand_typo(ch,"");
		return;
	}
	talk_channel( ch, argument, CHANNEL_KNIGHTTALK, "sign" );
	return;
}

void do_sign( CHAR_DATA *ch, char *argument )
{

	if (IS_NPC(ch) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch,CLASS_DROW)))
	{
                do_rand_typo(ch,"");
		return;
	}
	talk_channel( ch, argument, CHANNEL_SIGN, "sign" );
	return;
}
void do_radio( CHAR_DATA *ch, char *argument )
{ 
	if (IS_NPC(ch) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch,CLASS_UNISOL))) 
	{
		do_rand_typo(ch,"");
		return;
	}
	talk_channel( ch, argument, CHANNEL_RADIO, "radio" );
	return;
} 
void do_ktalk( CHAR_DATA *ch, char *argument ) 
{
	if (IS_NPC(ch)) return;
	if (ch->pcdata->kingdom == 0) 
        {
                do_rand_typo(ch,"");
		return;
	}
	talk_channel(ch, argument, CHANNEL_KTALK, "ktalk" );
}


void do_vamptalk( CHAR_DATA *ch, char *argument )
{

	if (IS_NPC(ch) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch,CLASS_VAMPIRE)))

	{
                do_rand_typo(ch,"");
		return;
	}
	talk_channel( ch, argument, CHANNEL_VAMPTALK, "vamptalk" );
	return;
}

void do_magetalk( CHAR_DATA *ch, char *argument )
{
	if (IS_NPC( ch ) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch,CLASS_MAGE)))
	{
                do_rand_typo(ch,"");
		return;
	}
	talk_channel( ch, argument, CHANNEL_MAGETALK, "magetalk" );
	return;
}
void do_amaztalk( CHAR_DATA *ch, char *argument )
{
	if (IS_NPC( ch ) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch,CLASS_AMAZON)))
	{
                do_rand_typo(ch,"");
		return;
	}
	talk_channel( ch, argument, CHANNEL_AMAZTALK, "amaztalk");
	return;
}
void do_forcetalk( CHAR_DATA *ch, char *argument )
{
	if (IS_NPC( ch ) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch,CLASS_JEDI)))
	{
                do_rand_typo(ch,"");
		return;
	}
	talk_channel( ch, argument, CHANNEL_FORCETALK, "forcetalk");
	return;
}
void do_lichtalk( CHAR_DATA *ch, char *argument )
{
	if (IS_NPC( ch ) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch,CLASS_POWER_LICH)))
	{
                do_rand_typo(ch,"");
		return;
	}
	talk_channel( ch, argument, CHANNEL_LICHTALK, "lichtalk" );
	return;
}

void do_tantalk( CHAR_DATA *ch, char *argument )
{
	if (IS_NPC( ch ) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch,CLASS_TANARRI)))
	{
                do_rand_typo(ch,"");
		return;
	}
	talk_channel( ch, argument, CHANNEL_TANTALK, "tantalk" );
	return;
}


void do_monk( CHAR_DATA *ch, char *argument )
{
	if (IS_NPC( ch ) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch,CLASS_MONK)))
	{
                do_rand_typo(ch,"");
		return;
	}
	talk_channel( ch, argument, CHANNEL_MONK, "monk" );
	return;
}

void do_angeltalk(CHAR_DATA *ch, char *argument )
{
	if (IS_NPC( ch ) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch,CLASS_ANGEL)))
	{
                do_rand_typo(ch,"");
		return;
	}
	talk_channel( ch, argument, CHANNEL_ANGEL, "angel" );
	return;
}

void do_pray( CHAR_DATA *ch, char *argument )
{
	CHAR_DATA *victim;
	char buf [MAX_STRING_LENGTH];

	act("You mutter a few prayers.",ch,NULL,NULL,TO_CHAR);
	act("$n mutters a quick prayer.",ch,NULL,NULL,TO_ROOM);

	if (ch->in_room != NULL && ch->in_room->vnum == ROOM_VNUM_ALTAR &&
		    ch->class == 0 && ch->position != POS_FIGHTING)
	{
		send_to_char("You glow bright blue as you are restored.\n\r",ch);
		ch->hit  = ch->max_hit;
		ch->mana = ch->max_mana;
		ch->move = ch->max_move;
		ch->loc_hp[0] = 0;
		ch->loc_hp[1] = 0;
		ch->loc_hp[2] = 0;
		ch->loc_hp[3] = 0;
		ch->loc_hp[4] = 0;
		ch->loc_hp[5] = 0;
		ch->loc_hp[6] = 0;
		update_pos(ch);
	}
	if (IS_NPC(ch) ||(!IS_CLASS(ch,CLASS_DEMON) && !IS_IMMORTAL(ch)))
		return;

	if ( argument[0] == '\0' && IS_SET(ch->special, SPC_DEMON_LORD))
	{
		send_to_char("What do you wish to pray?\n\r",ch);
		return;
	}
	else if ( argument[0] == '\0' )
	{
		if (ch->pcdata->stats[CLASS_POINTS] < 1)
		{
			send_to_char("Nothing happens.\n\r",ch);
			return;
		}
		if ( ( victim = get_char_world(ch, ch->lord) ) == NULL )
		{
			send_to_char("Nothing happens.\n\r",ch);
			return;
		}
		act("You hear $n's prayers in your mind.",ch,NULL,victim,TO_VICT);
		send_to_char("You feel energy pour into your body.\n\r",victim);
		if (ch->pcdata->stats[CLASS_POINTS] == 1)
			sprintf(buf,"You receive a single point of energy.\n\r");
		else
		    sprintf(buf,"You receive %d points of energy.\n\r",
			ch->pcdata->stats[CLASS_POINTS]);
		send_to_char(buf,victim);
		act("$n is briefly surrounded by a halo of energy.",victim,NULL,NULL,TO_ROOM);
		victim->pcdata->stats[CLASS_POINTS] += ch->pcdata->stats[CLASS_POINTS];
		ch->pcdata->stats[CLASS_POINTS] = 0;
		return;
	}
	if (IS_SET(ch->deaf, CHANNEL_PRAY))
	{
		send_to_char("But you're not even on the channel!\n\r",ch);
		return;
	}

	talk_channel( ch, argument, CHANNEL_PRAY, "pray" );
	return;
}


void do_howl( CHAR_DATA *ch, char *argument )
{
	if (IS_NPC( ch ) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch,CLASS_WEREWOLF) && !IS_POLYAFF(ch, POLY_WOLF)))
	{
                do_rand_typo(ch,"");
		return;
	}
	talk_channel( ch, argument, CHANNEL_HOWL, "howls" );
	return;
}


void do_say( CHAR_DATA *ch, char *argument )
{
	char name   [80];
	char poly   [MAX_STRING_LENGTH];
	char speak  [10];
	char speaks [10];
	char endbit [2];
	char secbit [2];
        char fstbit [2];
	CHAR_DATA *to;
	bool is_ok;

	if (RTIMER(ch->in_room, RTIMER_SILENCE) != 0)
	{
		send_to_char("Something prevents you from speaking in this room.\n\r", ch);
		return;
	}
	if ( IS_HEAD(ch, LOST_TONGUE) )
	{
		send_to_char( "You can't speak without a tongue!\n\r", ch );
		return;
	}
	if ( IS_EXTRA(ch, GAGGED) )
	{
		send_to_char( "You can't speak with a gag on!\n\r", ch );
		return;
	}

	if (strlen(argument) > MAX_INPUT_LENGTH)
	{
		send_to_char( "Line too long.\n\r", ch );
		return;
	}

	if ( argument[0] == '\0' )
	{
		send_to_char( "Say what?\n\r", ch );
		return;
	}

	endbit[0] = argument[strlen(argument)-1];
	endbit[1] = '\0';

	if (strlen(argument) > 1) secbit[0] = argument[strlen(argument)-2];
	else secbit[0] = '\0';
	secbit[1] = '\0';

	if (strlen(argument) > 2) fstbit[0] = argument[strlen(argument)-3];
	else fstbit[0] = '\0';
	fstbit[1] = '\0';

	if (IS_BODY(ch,CUT_THROAT))
	{
		sprintf(speak,"rasp");
		sprintf(speaks,"rasps");
	}
	else if (!IS_NPC(ch) &&
		    (IS_SET(ch->special,SPC_WOLFMAN) || IS_POLYAFF(ch, POLY_WOLF)
		    || (IS_CLASS(ch, CLASS_VAMPIRE) && ch->pcdata->stats[UNI_RAGE] > 0)))
	{
		if (number_percent() > 50)
		{
			sprintf(speak,"growl");
			sprintf(speaks,"growls");
		}
		else
		    {
			sprintf(speak,"snarl");
			sprintf(speaks,"snarls");
		}
	}
	else if (!IS_NPC(ch) && IS_POLYAFF(ch, POLY_BAT))
	{
		sprintf(speak,"squeak");
		sprintf(speaks,"squeaks");
	}
	else if (!IS_NPC(ch) && IS_POLYAFF(ch, POLY_SERPENT))
	{
		sprintf(speak,"hiss");
		sprintf(speaks,"hisses");
	}
	else if (!IS_NPC(ch) && IS_POLYAFF(ch, POLY_FROG))
	{
		sprintf(speak,"croak");
		sprintf(speaks,"croaks");
	}
	else if (!IS_NPC(ch) && IS_POLYAFF(ch, POLY_RAVEN))
	{
		sprintf(speak,"squark");
		sprintf(speaks,"squarks");
	}
	else if (IS_NPC(ch) && ch->pIndexData->vnum == MOB_VNUM_FROG)
	{
		sprintf(speak,"croak");
		sprintf(speaks,"croaks");
	}
	else if (IS_NPC(ch) && ch->pIndexData->vnum == MOB_VNUM_RAVEN)
	{
		sprintf(speak,"squark");
		sprintf(speaks,"squarks");
	}
	else if (IS_NPC(ch) && ch->pIndexData->vnum == MOB_VNUM_CAT)
	{
		sprintf(speak,"purr");
		sprintf(speaks,"purrs");
	}
	else if (IS_NPC(ch) && ch->pIndexData->vnum == MOB_VNUM_DOG)
	{
		sprintf(speak,"bark");
		sprintf(speaks,"barks");
	}
	else if (!str_cmp(endbit,"!"))
	{
		sprintf(speak,"exclaim");
		sprintf(speaks,"exclaims");
	}
	else if (!str_cmp(endbit,"?"))
	{
		sprintf(speak,"ask");
		sprintf(speaks,"asks");
	}
	else if (secbit[0] != '\0' && str_cmp(secbit,".") && !str_cmp(endbit,"."))
	{
		sprintf(speak,"state");
		sprintf(speaks,"states");
	}
	else if (fstbit[0] != '\0' && !str_cmp(fstbit,".") && !str_cmp(secbit,".") && !str_cmp(endbit,"."))
	{
		sprintf(speak,"mutter");
		sprintf(speaks,"mutters");
	}
        else if (fstbit[0] != '\0' && (!str_cmp(fstbit,":") || !str_cmp(fstbit,"=")) && secbit[0] != '\0' && !str_cmp(secbit,"-") && !str_cmp(endbit,"P"))
        {
                sprintf(speak,"smirk");
                sprintf(speaks,"smirks");
        }
        else if (secbit[0] != '\0' && (!str_cmp(secbit,"=") || !str_cmp(secbit,":")) && !str_cmp(endbit,"P"))
        {
                sprintf(speak,"smirk");
                sprintf(speaks,"smirks");
        }
        else if (fstbit[0] != '\0' && (!str_cmp(fstbit,":") || !str_cmp(fstbit,"=")) && secbit[0] != '\0' && !str_cmp(secbit,"-") && !str_cmp(endbit,")"))
	{
                sprintf(speak,"smile");
                sprintf(speaks,"smiles");
	}
        else if (secbit[0] != '\0' && !str_cmp(secbit,":") && !str_cmp(endbit,")"))
        {
                sprintf(speak,"smile");
                sprintf(speaks,"smiles");
        }
        else if (fstbit[0] != '\0' && (!str_cmp(fstbit,":") || !str_cmp(fstbit,"=")) && secbit[0] != '\0' && !str_cmp(secbit,"-") && !str_cmp(endbit,">"))
        {
                sprintf(speak,"grin");
               sprintf(speaks,"grins");
        }
        else if (secbit[0] != '\0' && !str_cmp(secbit,":") && !str_cmp(endbit,">"))
        {
                sprintf(speak,"grin");
                sprintf(speaks,"grins");
        }
        else if (secbit[0] != '\0' && !str_cmp(secbit,":") && (!str_cmp(endbit,"(") || !str_cmp(endbit,"<")))
        {
                sprintf(speak,"frown");
                sprintf(speaks,"frowns");
        }
        else if (secbit[0] != '\0' && !str_cmp(secbit,";") && (!str_cmp(endbit,">") || !str_cmp(endbit,")") || !str_cmp(endbit,"P")))
        {
                sprintf(speak,"wink");
                sprintf(speaks,"winks");
        }

	else if (!IS_NPC(ch) && ch->pcdata->condition[COND_DRUNK] > 10)
	{
		sprintf(speak,"slur");
		sprintf(speaks,"slurs");
	}
	else
	    {
		sprintf(speak,"say");
		sprintf(speaks,"says");
	}
	sprintf(poly,"You %s '#3$T#n'.", speak);

	act( poly, ch, NULL, argument, TO_CHAR );

	sprintf(poly,"$n %s '#3$T#n'.", speaks);
	if (ch->in_room->vnum != ROOM_VNUM_IN_OBJECT)
	{
		act( poly, ch, NULL, argument, TO_ROOM );
		room_text( ch, strlower(argument) );
		return;
	}

	to = ch->in_room->people;
	for ( ; to != NULL; to = to->next_in_room )
	{
		is_ok = FALSE;

		if ( to->desc == NULL || !IS_AWAKE(to) )
			continue;

		if ( ch == to )
			continue;

		if (!IS_NPC(ch) && ch->pcdata->chobj != NULL &&
			    ch->pcdata->chobj->in_room != NULL &&
			    !IS_NPC(to) && to->pcdata->chobj != NULL &&
			    to->pcdata->chobj->in_room != NULL &&
			    ch->in_room == to->in_room)
			is_ok = TRUE;
		else is_ok = FALSE;

		if (!IS_NPC(ch) && ch->pcdata->chobj != NULL &&
			    ch->pcdata->chobj->in_obj != NULL &&
			    !IS_NPC(to) && to->pcdata->chobj != NULL &&
			    to->pcdata->chobj->in_obj != NULL &&
			    ch->pcdata->chobj->in_obj == to->pcdata->chobj->in_obj)
			is_ok = TRUE;
		else is_ok = FALSE;

		if (!is_ok) continue;

		if (IS_NPC(ch))
			sprintf(name, ch->short_descr);
		else if (!IS_NPC(ch) && IS_AFFECTED(ch,AFF_POLYMORPH))
			sprintf(name, ch->morph);
		else if (!IS_NPC(ch) && IS_AFFECTED(ch,AFF_SHIFT))
			sprintf(name, ch->morph);


		else
		    sprintf(name, ch->name);
		name[0]=UPPER(name[0]);
		sprintf(poly,"%s %s '%s'.\n\r", name,speaks,argument);
		send_to_char(poly,to);
	}

	room_text( ch, strlower(argument) );
	return;
}

void room_text( CHAR_DATA *ch, char *argument)
{
	CHAR_DATA     *vch;
	CHAR_DATA     *vch_next;
	CHAR_DATA     *mob;
	OBJ_DATA      *obj;
	ROOMTEXT_DATA *rt;
	bool           mobfound;
	bool           hop;

	char           arg  [MAX_INPUT_LENGTH];
	char           arg1 [MAX_INPUT_LENGTH];
	char           arg2 [MAX_INPUT_LENGTH];

	for ( rt = ch->in_room->roomtext; rt != NULL; rt = rt->next )
	{
		if (!strcmp(argument,rt->input)
			    || is_in(argument, rt->input)
			    || all_in(argument, rt->input))
		{
			if ( rt->name != NULL         && rt->name != '\0'
				    &&   str_cmp(rt->name,"all")  && str_cmp(rt->name,"|all*") )
				if (!is_in(ch->name, rt->name) ) continue;
			mobfound = TRUE;
			if (rt->mob != 0)
			{
				mobfound = FALSE;
				for ( vch = char_list; vch != NULL; vch = vch_next )
				{
					vch_next	= vch->next;
					if ( vch->in_room == NULL ) continue;
					if ( !IS_NPC(vch)         ) continue;
					if ( vch->in_room == ch->in_room
						    && vch->pIndexData->vnum == rt->mob )
					{
						mobfound = TRUE;
						break;
					}
				}
			}
			if (!mobfound) continue;
			hop = FALSE;
			switch(rt->type % RT_RETURN)
			{
			case RT_SAY:
				break;
			case RT_LIGHTS:
				do_changelight(ch,"");
				break;
			case RT_LIGHT:
				REMOVE_BIT(ch->in_room->room_flags, ROOM_DARK);
				break;
			case RT_DARK:
				SET_BIT(ch->in_room->room_flags, ROOM_DARK);
				break;
			case RT_OBJECT:
				if ( get_obj_index(rt->power) == NULL ) return;
				obj = create_object(get_obj_index(rt->power), ch->level);
				if (IS_SET(rt->type, RT_TIMER) ) obj->timer = 1;
				if (CAN_WEAR(obj,ITEM_TAKE)) obj_to_char(obj,ch);
				else obj_to_room(obj,ch->in_room);
				if (!str_cmp(rt->choutput,"copy"))
					act( rt->output, ch, obj, NULL, TO_CHAR );
				else
					act( rt->choutput, ch, obj, NULL, TO_CHAR );
				if (!IS_SET(rt->type, RT_PERSONAL) )
					act( rt->output, ch, obj, NULL, TO_ROOM );
				hop = TRUE;
				break;
			case RT_MOBILE:
				if ( get_mob_index(rt->power) == NULL ) return;
				mob = create_mobile(get_mob_index(rt->power));
				char_to_room(mob,ch->in_room);
				if (!str_cmp(rt->choutput,"copy"))
					act( rt->output, ch, NULL, mob, TO_CHAR );
				else
					act( rt->choutput, ch, NULL, mob, TO_CHAR );
				if (!IS_SET(rt->type, RT_PERSONAL) )
					act( rt->output, ch, NULL, mob, TO_ROOM );
				hop = TRUE;
				break;
			case RT_SPELL:
				(*skill_table[rt->power].spell_fun) ( rt->power, number_range(20,30), ch, ch );
				break;
			case RT_PORTAL:
				if ( get_obj_index(OBJ_VNUM_PORTAL) == NULL ) return;
				obj = create_object(get_obj_index(OBJ_VNUM_PORTAL), 0);
				obj->timer = 1;
				obj->value[0] = rt->power;
				obj->value[1] = 1;
				obj_to_room(obj,ch->in_room);
				break;
			case RT_TELEPORT:
				if ( get_room_index(rt->power) == NULL ) return;
				if (!str_cmp(rt->choutput,"copy"))
					act( rt->output, ch, NULL, NULL, TO_CHAR );
				else
					act( rt->choutput, ch, NULL, NULL, TO_CHAR );
				if (!IS_SET(rt->type, RT_PERSONAL) )
					act( rt->output, ch, NULL, NULL, TO_ROOM );
				char_from_room(ch);
				char_to_room(ch,get_room_index(rt->power));
				act("$n appears in the room.",ch,NULL,NULL,TO_ROOM);
				do_look(ch,"auto");
				hop = TRUE;
				break;
			case RT_ACTION:
				sprintf(arg,argument);
				argument = one_argument( arg, arg1 );
				argument = one_argument( arg, arg2 );
				if ( (mob = get_char_room(ch, arg2) ) == NULL ) continue;
				interpret( mob, rt->output );
				break;
			case RT_OPEN_LIFT:
				open_lift(ch);
				break;
			case RT_CLOSE_LIFT:
				close_lift(ch);
				break;
			case RT_MOVE_LIFT:
				move_lift(ch,rt->power);
				break;
			default:
				break;
			}
			if (hop && IS_SET(rt->type, RT_RETURN) ) return;
			else if (hop) continue;
			if (!str_cmp(rt->choutput,"copy") && !IS_SET(rt->type, RT_ACTION))
				act( rt->output, ch, NULL, NULL, TO_CHAR );
			else if (!IS_SET(rt->type, RT_ACTION))
				act( rt->choutput, ch, NULL, NULL, TO_CHAR );
			if (!IS_SET(rt->type, RT_PERSONAL) && !IS_SET(rt->type, RT_ACTION) )
				act( rt->output, ch, NULL, NULL, TO_ROOM );
			if (IS_SET(rt->type, RT_RETURN) ) return;
		}
	}
	return;
}

char *strlower(char *ip)
{
	static char buffer[MAX_INPUT_LENGTH];
	int pos;

	for (pos = 0; pos < (MAX_INPUT_LENGTH - 1) && ip[pos] != '\0'; pos++) {
		buffer[pos] = tolower(ip[pos]);
	}
	buffer[pos] = '\0';
	return buffer;
}

bool is_in(char *arg, char *ip)
{
	char *lo_arg;
	char cmp[MAX_INPUT_LENGTH];
	int fitted;

	if (ip[0] != '|')
		return FALSE;
	cmp[0] = '\0';
	lo_arg = strlower(arg);
	do {
		ip += strlen(cmp) + 1;
		fitted = sscanf(ip, "%[^*]", cmp);
		if (strstr(lo_arg, cmp) != NULL) {
			return TRUE;
		}
	}
	while (fitted > 0);
	return FALSE;
}

bool all_in(char *arg, char *ip)
{
	char *lo_arg;
	char cmp[MAX_INPUT_LENGTH];
	int fitted;

	if (ip[0] != '&')
		return FALSE;
	cmp[0] = '\0';
	lo_arg = strlower(arg);
	do {
		ip += strlen(cmp) + 1;
		fitted = sscanf(ip, "%[^*]", cmp);
		if (strstr(lo_arg, cmp) == NULL) {
			return FALSE;
		}
	}
	while (fitted > 0);
	return TRUE;
}

void do_tell( CHAR_DATA *ch, char *argument )
{
	char arg[MAX_INPUT_LENGTH];
	char poly [MAX_STRING_LENGTH];
	CHAR_DATA *victim;
	int position;

	if ( !IS_NPC(ch) && IS_SET(ch->act, PLR_SILENCE) )
	{
		send_to_char( "Your message didn't get through.\n\r", ch );
		return;
	}
	if (IS_EXTRA(ch, GAGGED))
	{
		send_to_char( "Your message didn't get through.\n\r", ch );
		return;
	}

	argument = one_argument( argument, arg );

	if ( arg[0] == '\0' || argument[0] == '\0' )
	{
		send_to_char( "Tell whom what?\n\r", ch );
		return;
	}

	/*
	* Can tell to PC's anywhere, but NPC's only in same room.
	* -- Furey
	*/
	if ( ( victim = get_char_world( ch, arg ) ) == NULL
		    || ( IS_NPC(victim) && victim->in_room != ch->in_room ) )
	{
		send_to_char( "They aren't here.\n\r", ch );
		return;
	}

	if ( !IS_IMMORTAL(ch) && !IS_AWAKE(victim) )
	{
		act( "$E can't hear you.", ch, 0, victim, TO_CHAR );
		return;
	}

	if ( !IS_NPC(victim) && victim->desc == NULL )
	{
		act( "$E is currently link dead.", ch, 0, victim, TO_CHAR );
		return;
	}

	if ( IS_SET(victim->deaf, CHANNEL_TELL) && !IS_IMMORTAL(ch) )
	{
		if (IS_NPC(victim) || IS_NPC(ch) || strlen(victim->pcdata->marriage) < 2
			    || str_cmp(ch->name, victim->pcdata->marriage))
		{
			act( "$E can't hear you.", ch, 0, victim, TO_CHAR );
			return;
		}
	}
	sprintf(poly,"You tell $N '#C$t#n'.");
	act(poly, ch, argument, victim, TO_CHAR );

	position		= victim->position;
	victim->position	= POS_STANDING;

	sprintf(poly,"$n tells you '#C$t#n'.");
	act( poly, ch, argument, victim, TO_VICT );

	victim->position	= position;
	victim->reply	= ch;

	return;
}



void do_whisper( CHAR_DATA *ch, char *argument )
{
	char arg[MAX_INPUT_LENGTH];
	CHAR_DATA *victim;

	if (IS_EXTRA(ch, GAGGED))
	{
		send_to_char( "Not with a gag on!\n\r", ch );
		return;
	}

	argument = one_argument( argument, arg );

	if ( arg[0] == '\0' || argument[0] == '\0' )
	{
		send_to_char( "Syntax: whisper <person> <message>\n\r", ch );
		return;
	}

	if ( ( victim = get_char_world( ch, arg ) ) == NULL
		    || ( victim->in_room != ch->in_room ) )
	{
		send_to_char( "They aren't here.\n\r", ch );
		return;
	}

	if ( !IS_AWAKE(victim) )
	{
		act( "$E cannot hear you.", ch, 0, victim, TO_CHAR );
		return;
	}

	if ( !IS_NPC(victim) && victim->desc == NULL )
	{
		act( "$E is currently link dead.", ch, 0, victim, TO_CHAR );
		return;
	}

	act( "You whisper to $N '$t'.", ch, argument, victim, TO_CHAR );
	act( "$n whispers to you '$t'.", ch, argument, victim, TO_VICT );
	act( "$n whispers something to $N.", ch, NULL, victim, TO_NOTVICT );

	return;
}



void do_reply( CHAR_DATA *ch, char *argument )
{
	char poly [MAX_STRING_LENGTH];
	CHAR_DATA *victim;
	int position;

	if ( !IS_NPC(ch) && IS_SET(ch->act, PLR_SILENCE) )
	{
		send_to_char( "Your message didn't get through.\n\r", ch );
		return;
	}
	if (IS_EXTRA(ch, GAGGED))
	{
		send_to_char( "Your message didn't get through.\n\r", ch );
		return;
	}

	if ( ( victim = ch->reply ) == NULL )
	{
		send_to_char( "They aren't here.\n\r", ch );
		return;
	}

	if ( !IS_IMMORTAL(ch) && !IS_AWAKE(victim) )
	{
		act( "$E can't hear you.", ch, 0, victim, TO_CHAR );
		return;
	}

	if ( !IS_NPC(victim) && victim->desc == NULL )
	{
		act( "$E is currently link dead.", ch, 0, victim, TO_CHAR );
		return;
	}
	sprintf(poly,"You reply to $N '#C$t#n'.");
	act( poly, ch, argument, victim, TO_CHAR );
	position		= victim->position;
	victim->position	= POS_STANDING;

	sprintf(poly,"$n replies to you '#C$t#n'.");
	act( poly, ch, argument, victim, TO_VICT );

	victim->position	= position;
	victim->reply	= ch;

	return;
}



void do_emote( CHAR_DATA *ch, char *argument )
{
	char buf[MAX_STRING_LENGTH];
	char *plast;

	char name   [80];
	char poly   [MAX_INPUT_LENGTH];
	CHAR_DATA *to;
	bool is_ok;


	if ( IS_HEAD(ch, LOST_TONGUE) || IS_HEAD(ch, LOST_HEAD) || IS_EXTRA(ch, GAGGED))
	{
		send_to_char( "You can't show your emotions.\n\r", ch );
		return;
	}

	if ( argument[0] == '\0' )

	{
		send_to_char( "Pose what?\n\r", ch );
		return;
	}

	for ( plast = argument; *plast != '\0'; plast++ )
		;

	strcpy( buf, argument );
	if ( isalpha(plast[-1]) )
		strcat( buf, "." );

	act( "$n $T", ch, NULL, buf, TO_CHAR );

	if (ch->in_room->vnum != ROOM_VNUM_IN_OBJECT)
	{
		act( "$n $T", ch, NULL, buf, TO_ROOM );
		return;
	}

	to = ch->in_room->people;
	for ( ; to != NULL; to = to->next_in_room )
	{
		is_ok = FALSE;

		if ( to->desc == NULL || !IS_AWAKE(to) )
			continue;

		if ( ch == to )
			continue;

		if (!IS_NPC(ch) && ch->pcdata->chobj != NULL &&
			    ch->pcdata->chobj->in_room != NULL &&
			    !IS_NPC(to) && to->pcdata->chobj != NULL &&
			    to->pcdata->chobj->in_room != NULL &&
			    ch->in_room == to->in_room)
			is_ok = TRUE;
		else is_ok = FALSE;

		if (!IS_NPC(ch) && ch->pcdata->chobj != NULL &&
			    ch->pcdata->chobj->in_obj != NULL &&
			    !IS_NPC(to) && to->pcdata->chobj != NULL &&
			    to->pcdata->chobj->in_obj != NULL &&
			    ch->pcdata->chobj->in_obj == to->pcdata->chobj->in_obj)
			is_ok = TRUE;
		else is_ok = FALSE;

		if (!is_ok) continue;

		if (IS_NPC(ch))
			sprintf(name, ch->short_descr);
		else if (!IS_NPC(ch) && IS_AFFECTED(ch,AFF_POLYMORPH))
			sprintf(name, ch->morph);
		else if (!IS_NPC(ch) && IS_AFFECTED(ch,AFF_SHIFT))
			sprintf(name, ch->morph);

		else
		    sprintf(name, ch->name);
		name[0]=UPPER(name[0]);
		sprintf(poly,"%s %s\n\r", name,buf);
		send_to_char(poly,to);
	}
	return;
}



void do_xemote( CHAR_DATA *ch, char *argument )
{
	char buf[MAX_STRING_LENGTH];
	char buf2[MAX_STRING_LENGTH];
	char oldarg[MAX_STRING_LENGTH];
	char *plast;

	char name   [80];
	char you    [80];
	char them   [80];
	char poly   [MAX_INPUT_LENGTH];
	char arg    [MAX_INPUT_LENGTH];
	CHAR_DATA *to;
	CHAR_DATA *victim;
	bool is_ok;

	argument = one_argument( argument, arg );


	if ( IS_HEAD(ch, LOST_TONGUE) || IS_HEAD(ch, LOST_HEAD) || IS_EXTRA(ch, GAGGED))
	{
		send_to_char( "You can't show your emotions.\n\r", ch );
		return;
	}

	if (strlen(argument) > MAX_INPUT_LENGTH)
	{
		send_to_char( "Line too long.\n\r", ch );
		return;
	}

	if ( argument[0] == '\0' || arg[0] == '\0' )
	{
		send_to_char( "Syntax: emote <person> <sentence>\n\r", ch );
		return;
	}

	if ( ( victim = get_char_room( ch, arg ) ) == NULL )
	{
		send_to_char( "They aren't here.\n\r", ch );
		return;
	}

	if (IS_NPC(ch)) strcpy(you, ch->short_descr);
	else strcpy(you, ch->name);
	if (IS_NPC(victim)) strcpy(you, victim->short_descr);
	else strcpy(you, victim->name);
	/*
	oldarg = argument;
	*/
	strcpy( oldarg,argument );
	strcpy( buf, argument );
	for ( plast = argument; *plast != '\0'; plast++ )
		;

	if ( isalpha(plast[-1]) )
		strcat( buf, "." );
	argument = socialc(ch, buf, you, them);

	strcpy( buf, argument );
	strcpy( buf2, "You ");
	buf[0] = LOWER(buf[0]);
	strcat( buf2, buf );
	capitalize( buf2 );
	act( buf2, ch, NULL, victim, TO_CHAR );

	if (ch->in_room->vnum != ROOM_VNUM_IN_OBJECT)
	{
		strcpy( buf, oldarg );
		for ( plast = argument; *plast != '\0'; plast++ )
			;
		if ( isalpha(plast[-1]) )
			strcat( buf, "." );

		argument = socialn(ch, buf, you, them);

		strcpy( buf, argument );
		strcpy( buf2, "$n ");
		buf[0] = LOWER(buf[0]);
		strcat( buf2, buf );
		capitalize( buf2 );
		act( buf2, ch, NULL, victim, TO_NOTVICT );

		strcpy( buf, oldarg );
		for ( plast = argument; *plast != '\0'; plast++ )
			;
		if ( isalpha(plast[-1]) )
			strcat( buf, "." );

		argument = socialv(ch, buf, you, them);

		strcpy( buf, argument );
		strcpy( buf2, "$n ");
		buf[0] = LOWER(buf[0]);
		strcat( buf2, buf );
		capitalize( buf2 );
		act( buf2, ch, NULL, victim, TO_VICT );
		return;
	}

	to = ch->in_room->people;
	for ( ; to != NULL; to = to->next_in_room )
	{
		is_ok = FALSE;

		if ( to->desc == NULL || !IS_AWAKE(to) )
			continue;

		if ( ch == to )
			continue;

		if (!IS_NPC(ch) && ch->pcdata->chobj != NULL &&
			    ch->pcdata->chobj->in_room != NULL &&
			    !IS_NPC(to) && to->pcdata->chobj != NULL &&
			    to->pcdata->chobj->in_room != NULL &&
			    ch->in_room == to->in_room)
			is_ok = TRUE;
		else is_ok = FALSE;

		if (!IS_NPC(ch) && ch->pcdata->chobj != NULL &&
			    ch->pcdata->chobj->in_obj != NULL &&
			    !IS_NPC(to) && to->pcdata->chobj != NULL &&
			    to->pcdata->chobj->in_obj != NULL &&
			    ch->pcdata->chobj->in_obj == to->pcdata->chobj->in_obj)
			is_ok = TRUE;
		else is_ok = FALSE;

		if (!is_ok) continue;

		if (IS_NPC(ch))
			sprintf(name, ch->short_descr);
		else if (!IS_NPC(ch) && IS_AFFECTED(ch,AFF_POLYMORPH))
			sprintf(name, ch->morph);
		else if (!IS_NPC(ch) && IS_AFFECTED(ch,AFF_SHIFT))
			sprintf(name, ch->morph);

		else
		    sprintf(name, ch->name);
		name[0]=UPPER(name[0]);
		sprintf(poly,"%s %s\n\r", name,buf);
		send_to_char(poly,to);
	}
	return;
}



void do_bug( CHAR_DATA *ch, char *argument )
{
	append_file( ch, BUG_FILE, argument );
	send_to_char( "Ok.  Thanks.\n\r", ch );
	return;
}
void do_quit( CHAR_DATA *ch, char *argument )
{
	DESCRIPTOR_DATA *d;
	char buf[MAX_STRING_LENGTH];
    OBJ_DATA *obj;
    OBJ_DATA *obj_next;
	CHAR_DATA *mount;

	if ( IS_NPC(ch) )
		return;

	if ( ch->position == POS_FIGHTING )
	{
		send_to_char( "No way! You are fighting.\n\r", ch );
		return;
	}

	if ( ch->position != POS_STANDING )
	{
		send_to_char( "Stand up kiddie.\n\r", ch );
		return;
	}

	if (ch->fight_timer >0) {
		send_to_char("Not until your fight timer expires.\n\r", ch );
		return;
	}

	save_char_obj_backup(ch);

	if (IS_SET(ch->extra, EXTRA_OSWITCH)) do_humanform(ch,"");
	if (ch->gladiator  != NULL)
		ch->gladiator       = NULL; /* set player to bet on to NULL */
	if (ch->challenger != NULL)
		ch->challenger = NULL;
	if (ch->challenged != NULL)
		ch->challenged = NULL;
	if (IS_SET(ch->act,PLR_CHALLENGER))
		REMOVE_BIT(ch->act,PLR_CHALLENGER);
	if (IS_SET(ch->act,PLR_CHALLENGED))
		REMOVE_BIT(ch->act,PLR_CHALLENGED);
	if ( (mount = ch->mount) != NULL ) do_dismount(ch,"");

	if (ch->pcdata->in_progress)
		free_note(ch->pcdata->in_progress);

	d = ch->desc;
    for (obj = ch->carrying; obj != NULL; obj = obj_next)
    {
        obj_next = obj->next_content;
        if (obj->wear_loc == WEAR_NONE)
            continue;
        if (!IS_NPC(ch) && ((obj->chobj != NULL && !IS_NPC(obj->chobj) &&
                obj->chobj->pcdata->obj_vnum != 0) || obj->item_type == ITEM_KEY))
            unequip_char(ch, obj);
    }

    for (obj = ch->carrying; obj != NULL; obj = obj_next)
    {
        obj_next = obj->next_content;
        if (obj->wear_loc == WEAR_NONE)
            continue;

        if (!IS_NPC(ch) && (obj->item_type == ITEM_KEY || obj->item_type == ITEM_CORPSE_NPC))
            unequip_char(ch, obj);
    }

	save_char_obj( ch );
	do_rand_quote(ch,"");
	if (ch->pcdata->obj_vnum != 0)
		act("$n slowly fades out of existance.",ch,NULL,NULL,TO_ROOM);
	else
		act("$n has left the game.",ch,NULL,NULL,TO_ROOM);

	if (IS_SET(ch->act, PLR_TAG))
	{
		REMOVE_BIT(ch->act, PLR_TAG);
		sprintf(buf, "TAG Game update:- %s has quit the TAG Game so no one is IT.\n\r",ch->name);
		do_info(ch,buf);
	}

	if (d != NULL)
		close_socket2( d, FALSE);

	if (ch->in_room != NULL) char_from_room(ch);
	char_to_room(ch, get_room_index(3));

	sprintf( log_buf,"%s has quit",ch->name);
	log_string(log_buf);

	if (IS_CLASS(ch, CLASS_DEMON))
	{
	  sprintf(buf,"#r%s#R exits as Satan calls for them.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (IS_CLASS(ch, CLASS_MAGE))
	{
	  sprintf(buf,"#CThe ebb in the flow of magic lessens as#R %s#C leaves.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (IS_CLASS(ch, CLASS_WEREWOLF))
	{
	  sprintf(buf,"#oThe moon waxes, and#R %s#o leaves awaiting its next rising.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (IS_CLASS(ch, CLASS_VAMPIRE))
	{
	  sprintf(buf,"#0The sun rises, and#R %s#0 returns to their coffin for the waking day.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (IS_CLASS(ch, CLASS_HIGHLANDER))
	{
	  sprintf(buf,"#R%s#C lowers their katana and quickly vanishes from sight.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (IS_CLASS(ch, CLASS_DROW))
	{
	  sprintf(buf,"#R%s#P takes Lloth's leave and returns to the shadows.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (IS_CLASS(ch, CLASS_MONK))
	{
	  sprintf(buf,"#7God allows#R %s#7 to take leave and rest.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (IS_CLASS(ch, CLASS_NINJA))
	{
	  sprintf(buf,"#R%s#0 lowers their dagger, and leaves as silently as they entered.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (IS_CLASS(ch, CLASS_POWER_LICH))
	{
	  sprintf(buf,"#oThe smell of rotting flesh dissipates as#R %s#o exits.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (IS_CLASS(ch, CLASS_SHAPESHIFTER))
	{
	  sprintf(buf,"#R%s#P returns to their natural form and leaves.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (IS_CLASS(ch, CLASS_TANARRI))
	{
	  sprintf(buf,"#r%s#R flees to heal their wounds from the#r B#Rlood#r W#Rars.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (IS_CLASS(ch, CLASS_ANGEL))
	{
	  sprintf(buf,"#7God calls#R %s#7 back to haven from the holy war.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (IS_CLASS(ch, CLASS_UNDEAD_KNIGHT))
	{
	  sprintf(buf,"#R%s#0 gallops out on their skeletal steed.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (IS_CLASS(ch, CLASS_CYBORG))
	{
	  sprintf(buf,"#R%s#p scatters away on mechanical legs.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (IS_CLASS(ch, CLASS_JEDI))
	{
	  sprintf(buf,"#CThe Force in the world is depleted as#R %s#C exits.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (IS_CLASS(ch, CLASS_AMAZON))
	{
	  sprintf(buf,"#GThe battlecries fade as#R %s#G returns to the jungle.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if(IS_CLASS(ch, CLASS_XOMBI))
	{
	  sprintf(buf,"#L%s#l returns to the grave after brain hunting.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if (ch->class != 0)
	{
	  sprintf(buf,"#2%s#7 has fled from the#p S#Ph#0a#7d#po#Pw#pG#7a#0m#Pe#ps#7.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	else if(ch->pcdata->obj_vnum == 0 && !IS_IMMORTAL(ch) && (ch->class == 0))
	{
	  sprintf(buf,"#2%s#7 has fled from the#p S#Ph#0a#7d#po#Pw#pG#7a#0m#Pe#ps#7.#n",ch->pcdata->switchname);
	  do_info(ch,buf);
	}
	if (ch->pcdata->chobj != NULL) extract_obj(ch->pcdata->chobj);
	extract_char(ch, TRUE);
	return;
}

struct quote_type
{
	char *      text;        /* Declare the Quote table... */
	char *      author;
};


#define MAX_QUOTES 23

const struct quote_type quote_table [MAX_QUOTES] =
{
	{
		"Extraordinary Claims require Extraordinary evidence.", "Carl Sagan" 	}
	, /* Quote No 1 */
	{
		"Do you feel lucky, punk?", "Clint Eastwood" 	}
	,
	{
		"Nothing is impossible just mathematically improbable, multiply that by infinity take it to the depths of forever and you will barely have a glimpse of my greatness. I am invincible, try your luck!" , "" 	}
	,
	{
		"Oblivion awaits all of us in one form or another.", "#4Pyriel#n" 	}
	,
	{
		"#7In the name of the Moon, I will Punish you.", "#LSailor #yMoon#n" 	}
	, /* Thats 4 quotes! */
	{
		"My thy blade stay sharp and thy heart forever dark!", "#3KaVir#n" 	}
	,
	{
		"There's more to living than only surviving.", "The Offspring" 	}
	,
	{
		"Smile and be happy.  #y:)","Pyriel" 	}
	,
	{
		"Blessed are the peacemakers, for they get mowed down by the crossfire.", "Void, submitted by Void." 	}
	,
	{
		"#0I#n L#0i#nk#0e#n G#0r#ne#0y#n.", "#0A#nl#0s#nt#0o#nr" 	}
	,
	{
		"It doesn't matter what you accomplish in life; the size of your funeral is going to be determined by the weather.", "Chuck Tanner"
	}
	,
	{
		"Everybody wants to go to heaven, but nobody wants to die.", "Unknown" 	}
	,
	{
		"Life don't run from nobody.  Life runs at people.", "Joe Frazier" 	}
	,
	{
		"Winning is not everything -- but making the effort to win is.", "Vince Lombardi" 	}
	,
	{
		"I never cease to amaze myself.  I say this humbly.", "Don King" 	}
	,
	{
		"#sI #slike #sm#su#sl#st#si#sp#sl#se #sc#so#sl#so#sr#ss :).", "#sP#sy#sr#si#se#sl" 	}
	,
	{
		"A well paid slave is a slave nonetheless.", "Curt Flood" 	}
	,
	{
		"It doesn't matter if you win or lose, until you lose.", "Anonymous" 	}
	,
	{
		"I'd love to be a procrastinator, but I never seem to get around to it.", "Chris Dundee" 	}
	,
	{
		"They thought lacrosse was what you find in la church.", "Robin Williams (a really cool dude)" 	}
	,
	{
		"You're never lost!  Because wherever you go, there you are!", "Lotsa people" 	}
	,
	{
		"On the day when the wagon comes, I just pray that you'll let me on.", "Violent J" 	}
	,
	{
		"It's better to regret having done something than having not done it.","Orbital - Satan" 	}

};

void do_rand_quote( CHAR_DATA *ch, char *argument )
{
	char buf[MAX_STRING_LENGTH];
	int number;

	number = number_range( 1, MAX_QUOTES) - 1;

	sprintf ( buf, "\n\r#4%s\n\r - #1%s#n\n\r",
		quote_table[number].text,
		quote_table[number].author);           /* NB Yellow quote, Red author */
	send_to_char ( buf, ch );
	return;
}
const char *typo_table [25] =
{
	"My tummy feels funny.",
	"Stop POKING ME!",
	"ARRRRGGHH!!!",
	"What!",
	"Yes?",
	"Your command?",
	"Yes Sire.",
	"Join the army they said...",
	"See the world they said...",
	"I'd rather be sailing!",
	"Aye Aye captain.",
	"Skipper.",
	"Aye sir.",
	"Stop rocking the boat...",
	"Your making me seasick...",
	"*bleeauccch*",
	"Even elder races get tired of waiting.",
	"Time is of the essence.",
	"You never touch the other elves that way.",
	"Goliath Online.",
	"System Checklist Initiated -",
	"Running Level 1 Diagnostic -",
	"USDA Approved -",
	"FDIC Insured -",
	"Checklist completed (#RSOB#l).",
};

void do_rand_typo(CHAR_DATA *ch, char *argument)
{
	char buf[MAX_STRING_LENGTH];
	int number;

	number = number_range(0,25);

	sprintf(buf, "#L%s#n\n\r", typo_table[number]);
	send_to_char(buf, ch);
	return;
}

void do_save( CHAR_DATA *ch, char *argument )
{
	if ( IS_NPC(ch) )
		return;

	if ( ch->level < 2 )
	{
		send_to_char( "You must kill at least 5 mobs before you can save.\n\r", ch );
		return;
	}
	check_leaderboard(ch,"");
	save_char_obj_backup( ch );
	save_char_obj( ch );
	send_to_char( "Saved.\n\r", ch );
	return;
}



void do_autosave( CHAR_DATA *ch, char *argument )
{
	if ( IS_NPC(ch) ) return;
	if ( ch->level < 2 ) return;
	save_char_obj( ch );
	return;
}



void do_follow( CHAR_DATA *ch, char *argument )
{
	char arg[MAX_INPUT_LENGTH];
	CHAR_DATA *victim;

	one_argument( argument, arg );


	if ( arg[0] == '\0' )
	{
		send_to_char( "Follow whom?\n\r", ch );
		return;
	}
	if ( ( victim = get_char_room( ch, arg ) ) == NULL )
	{
		send_to_char( "They aren't here.\n\r", ch );
		return;
	}
	/*
	if ( ch->played  6789;
	return;
	}
	*/
	if ( IS_AFFECTED(ch, AFF_CHARM) && ch->master != NULL )
	{
		act( "But you'd rather follow $N!", ch, NULL, ch->master, TO_CHAR );
		return;
	}
	if ( victim == ch )
	{
		if ( ch->master == NULL )
		{
			send_to_char( "You already follow yourself.\n\r", ch );
			return;
		}
		stop_follower( ch );
		return;
	}

	if ( ch->master != NULL )
		stop_follower( ch );

	add_follower( ch, victim );
	return;
}



void add_follower( CHAR_DATA *ch, CHAR_DATA *master )
{
	if ( ch->master != NULL )
	{
		bug( "Add_follower: non-null master.", 0 );
		return;
	}

	ch->master        = master;
	ch->leader        = NULL;

	if ( can_see( master, ch ) )
		act( "$n now follows you.", ch, NULL, master, TO_VICT );

	act( "You now follow $N.",  ch, NULL, master, TO_CHAR );

	return;
}



void stop_follower( CHAR_DATA *ch )
{
	if ( ch->master == NULL )
	{
		bug( "Stop_follower: null master.", 0 );
		return;
	}

	if ( IS_AFFECTED(ch, AFF_CHARM) )
	{
		REMOVE_BIT( ch->affected_by, AFF_CHARM );
		affect_strip( ch, gsn_charm_person );
	}

	if ( can_see( ch->master, ch ) )
		act( "$n stops following you.", ch, NULL, ch->master, TO_VICT );
	act( "You stop following $N.", ch, NULL, ch->master, TO_CHAR    );

	ch->master = NULL;
	ch->leader = NULL;
	return;
}



void die_follower( CHAR_DATA *ch )
{
	CHAR_DATA *fch;

	if ( ch->master != NULL )
		stop_follower( ch );

	ch->leader = NULL;

	for ( fch = char_list; fch != NULL; fch = fch->next )
	{
		if ( fch->master == ch )
			stop_follower( fch );
		if ( fch->leader == ch )
			fch->leader = fch;
	}

	return;
}



void do_order( CHAR_DATA *ch, char *argument )
{

	char arg[MAX_INPUT_LENGTH];
	CHAR_DATA *victim;
	CHAR_DATA *och;
	CHAR_DATA *och_next;
	bool found;
	bool fAll;

	argument = one_argument( argument, arg );

	if ( arg[0] == '\0' || argument[0] == '\0' )
	{
		send_to_char( "Order whom to do what?\n\r", ch );
		return;
	}

	if ( IS_AFFECTED( ch, AFF_CHARM ) )
	{
		send_to_char( "You feel like taking, not giving, orders.\n\r", ch );
		return;
	}

	if( IS_SET(ch->in_room->room_flags, ROOM_ORDER) || IS_SET(ch->in_room->room_flags, ROOM_SAFE))
	{
		stc( "You can't order things around here.\n\r",ch);
		return;
	}

	if ( !str_cmp( arg, "all" ) )
	{
		send_to_char("Ordering 'all' has been disabled.\n\r",ch);
		return;
	}
	else
	    {
		fAll   = FALSE;
		if ( ( victim = get_char_room( ch, arg ) ) == NULL )
		{
			send_to_char( "They aren't here.\n\r", ch );
			return;
		}

		if ( victim == ch )
		{
			send_to_char( "Aye aye, right away!\n\r", ch );
			return;
		}

		if ( (!IS_AFFECTED(victim, AFF_CHARM) || victim->master != ch) )

		{
			send_to_char( "Do it yourself!\n\r", ch );
			return;
		}

		if ( IS_CLASS(ch, CLASS_VAMPIRE) && IS_CLASS(victim, CLASS_VAMPIRE)
			    && ((ch->pcdata->stats[UNI_GEN] > 2) || ch->pcdata->kingdom != victim->pcdata->kingdom))
		{
			act( "$N ignores your order.", ch, NULL, victim, TO_CHAR );
			act( "You ignore $n's order.", ch, NULL, victim, TO_VICT );
			return;
		}

	}

	found = FALSE;
	for ( och = ch->in_room->people; och != NULL; och = och_next )
	{
		och_next = och->next_in_room;
		if ( och == ch ) continue;

		if ((IS_AFFECTED(och, AFF_CHARM)
			    &&   och->master == ch
			    && ( fAll || och == victim ) )
			    || (ch->pcdata->stats[UNI_GEN] == 2 && (fAll || och == victim) &&
			    ch->pcdata->kingdom == och->pcdata->kingdom))
		{
			found = TRUE;
			act( "$n orders you to '$t'.", ch, argument, och, TO_VICT );
			interpret( och, argument );
		}
		else if ( !IS_NPC(ch) && !IS_NPC(och) && (fAll || och == victim)
			    && IS_CLASS(ch, CLASS_VAMPIRE) && IS_CLASS(och, CLASS_VAMPIRE)
			    && ch->pcdata->stats[UNI_GEN] < och->pcdata->stats[UNI_GEN] &&
			    ch->pcdata->kingdom == och->pcdata->kingdom)
		{
			found = TRUE;
			act( "$n orders you to '$t'.", ch, argument, och, TO_VICT );
			interpret( och, argument );
		}
	}

	if ( found )

		send_to_char( "Ok.\n\r", ch );
	else
		send_to_char( "You have no followers here.\n\r", ch );
	WAIT_STATE( ch, 12 );
	return;
}



void do_command( CHAR_DATA *ch, char *argument )
{
	char arg1[MAX_INPUT_LENGTH];
	char arg2[MAX_INPUT_LENGTH];
	char buf[MAX_STRING_LENGTH];
	char buffy[MAX_STRING_LENGTH];
	CHAR_DATA *victim;
	int awe;


	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );

	if (IS_NPC(ch)) return;
	if (!IS_CLASS(ch, CLASS_VAMPIRE) && !IS_CLASS(ch, CLASS_UNDEAD_KNIGHT))
	{
                do_rand_typo(ch,"");
		return;
	}

	if (ch->power[DISC_VAMP_DOMI] < 1 && IS_CLASS(ch, CLASS_VAMPIRE))
	{
		send_to_char( "You must obtain at least level 1 in Dominate to use Command.\n\r", ch );
		return;
	}

	if (IS_CLASS(ch, CLASS_UNDEAD_KNIGHT) && ch->pcdata->powers[NECROMANCY] < 4)
	{
		send_to_char("You need level 4 necromancry to use command.\n\r",ch);
		return;
	}

	if (ch->spl[RED_MAGIC] < 1)
	{
		send_to_char( "Your mind is too weak.\n\r", ch );
		return;
	}

	if ( arg1[0] == '\0' || arg2[0] == '\0' )
	{
		send_to_char( "Command whom to do what?\n\r", ch );
		return;
	}

	if ( ( victim = get_char_room( ch, arg1 ) ) == NULL )
	{
		send_to_char( "They aren't here.\n\r", ch );
		return;
	}

	if( IS_SET(ch->in_room->room_flags, ROOM_ORDER) || IS_SET(ch->in_room->room_flags, ROOM_SAFE))
	{
		stc( "You can't order things around here.\n\r",ch);
		return;
	}

	if ( victim == ch )
	{
		send_to_char( "How can you command yourself??\n\r", ch );
		return;
	}

	if (ch->power[DISC_VAMP_DOMI] > 2)
		awe = 50;
	else if (ch->power[DISC_VAMP_DOMI] > 3)
		awe = 75;
	else if (ch->power[DISC_VAMP_DOMI] > 4)
		awe = 100;
	else awe = 25;

	if (IS_EXTRA(ch, EXTRA_AWE))
	{
		awe += 75;
	}

	if ( !IS_NPC(victim) && victim->level != 3 )
	{
		send_to_char( "You can only command other avatars.\n\r", ch );
		return;
	}

        if (is_safe(ch, victim))
        {
          stc("Either you or your victim are not attackable.\n\r",ch);
          return;
        }

        if (!str_cmp(arg2,"sacrifice")
         || !str_cmp(arg2,"password") 
         || !str_cmp(arg2,"gift") 
         || !str_cmp(arg2,"junk")
         || !str_cmp(arg2,"quit")
         || !str_cmp(arg2,"detox"))
        {
          stc("That command is forbidden to force another player to do!\n\r",ch);
          return;
        }

	if ( ch->power[DISC_VAMP_DOMI] > 1 )
	{
		sprintf( buffy, "%s %s", arg2, argument );
		if (IS_NPC(victim))
			sprintf( buf, "I think %s wants to %s",victim->short_descr,buffy);
		else if (!IS_NPC(victim) && IS_AFFECTED(victim, AFF_POLYMORPH))
			sprintf( buf, "I think %s wants to %s", victim->morph,buffy);
		else
		    sprintf( buf, "I think %s wants to %s", victim->name,buffy);
		do_say(ch,buf);
	}
	else
	    {
		if (IS_NPC(victim))
			sprintf( buf, "I think %s wants to %s", victim->short_descr, arg2 );
		else if (!IS_NPC(victim) && IS_AFFECTED(victim, AFF_POLYMORPH))
			sprintf( buf, "I think %s wants to %s", victim->morph, arg2 );
		else
		    sprintf( buf, "I think %s wants to %s", victim->name, arg2 );
		do_say(ch,buf);
	}

	if ( IS_NPC(victim) && ( victim->level >= awe * ch->spl[RED_MAGIC]* 2 || victim->level > 1500))
	{
		act("You shake off $N's suggestion.",victim,NULL,ch,TO_CHAR);
		act("$n shakes off $N's suggestion.",victim,NULL,ch,TO_NOTVICT);
		act("$n shakes off your suggestion.",victim,NULL,ch,TO_VICT);
		act("$s mind is too strong to overcome.",victim,NULL,ch,TO_VICT);
		return;
	}

	else if ( victim->spl[BLUE_MAGIC] >= (ch->spl[RED_MAGIC]/2) )
	{
		act("You shake off $N's suggestion.",victim,NULL,ch,TO_CHAR);
		act("$n shakes off $N's suggestion.",victim,NULL,ch,TO_NOTVICT);
		act("$n shakes off your suggestion.",victim,NULL,ch,TO_VICT);
		act("$s mind is too strong to overcome.",victim,NULL,ch,TO_VICT);
		return;
	}

	act("You blink in confusion.",victim,NULL,NULL,TO_CHAR);
	act("$n blinks in confusion.",victim,NULL,NULL,TO_ROOM);
	strcpy(buf,"Yes, you're right, I do...");
	do_say(victim,buf);
	if ( ch->power[DISC_VAMP_DOMI] > 1 )
        interpret( victim, buffy );
	else interpret( victim, arg2 );
	WAIT_STATE(ch, 4);
	return;

}



void do_group( CHAR_DATA *ch, char *argument )
{
	char buf[MAX_STRING_LENGTH];
	char arg[MAX_INPUT_LENGTH];
	CHAR_DATA *victim;

	one_argument( argument, arg );

	if ( arg[0] == '\0' )
	{
		CHAR_DATA *gch;
		CHAR_DATA *leader;


		leader = (ch->leader != NULL) ? ch->leader : ch;
		sprintf( buf, "%s's group:\n\r", PERS(leader, ch) );
		send_to_char( buf, ch );

		for ( gch = char_list; gch != NULL; gch = gch->next )
		{
			if ( is_same_group( gch, ch ) )
			{
				sprintf( buf,
					"[%-16s] %4d/%4d hp %4d/%4d mana %4d/%4d mv %5d xp\n\r",
					capitalize( PERS(gch, ch) ),
					gch->hit,   gch->max_hit,
					gch->mana,  gch->max_mana,
					gch->move,  gch->max_move,
					gch->exp    );
				send_to_char( buf, ch );
			}
		}
		return;
	}

	if ( ( victim = get_char_room( ch, arg ) ) == NULL )
	{
		send_to_char( "They aren't here.\n\r", ch );
		return;
	}

	if ( ch->master != NULL || ( ch->leader != NULL && ch->leader != ch ) )
	{
		send_to_char( "But you are following someone else!\n\r", ch );
		return;
	}

	if ( victim->master != ch && ch != victim )
	{
		act( "$N isn't following you.", ch, NULL, victim, TO_CHAR );
		return;
	}

	if ( is_same_group( victim, ch ) && ch != victim )
	{
		victim->leader = NULL;
		act( "$n removes $N from $s group.",   ch, NULL, victim, TO_NOTVICT );
		act( "$n removes you from $s group.",  ch, NULL, victim, TO_VICT    );
		act( "You remove $N from your group.", ch, NULL, victim, TO_CHAR    );
		return;
	}

	victim->leader = ch;
	act( "$N joins $n's group.", ch, NULL, victim, TO_NOTVICT );
	act( "You join $n's group.", ch, NULL, victim, TO_VICT    );
	act( "$N joins your group.", ch, NULL, victim, TO_CHAR    );
	return;
}

void do_gtell( CHAR_DATA *ch, char *argument )
{
	char buf[MAX_STRING_LENGTH];
	DESCRIPTOR_DATA *d;
	CHAR_DATA *gch;

	if ( argument[0] == '\0' )
	{
		send_to_char( "Tell your group what?\n\r", ch );
		return;
	}

	if ( IS_SET( ch->act, PLR_NO_TELL ) )
	{
		send_to_char( "Your message didn't get through!\n\r", ch );
		return;
	}

	/*
	* Note use of send_to_char, so gtell works on sleepers.
	*/
	sprintf( buf, "#G%s tells the group #R'#G%s#R'\n\r#n", ch->name, argument );
	//    for ( gch = char_list; gch != NULL; gch = gch->next )
    for ( d = descriptor_list; d != NULL; d = d->next )
	{
		if (d->character != NULL) gch = d->character;
		else continue;
		if ( is_same_group( gch, ch ) )
			send_to_char( buf, gch );
	}

	return;
}



/*
* It is very important that this be an equivalence relation:
* (1) A ~ A
* (2) if A ~ B then B ~ A
* (3) if A ~ B  and B ~ C, then A ~ C
*/
bool is_same_group( CHAR_DATA *ach, CHAR_DATA *bch )
{
	if ( ach->leader != NULL ) ach = ach->leader;
	if ( bch->leader != NULL ) bch = bch->leader;
	return ach == bch;
}

void do_changelight(CHAR_DATA *ch, char *argument )
{
	if (IS_SET(ch->in_room->room_flags, ROOM_DARK))
	{
		REMOVE_BIT(ch->in_room->room_flags, ROOM_DARK);
		act("The room is suddenly filled with light!",ch,NULL,NULL,TO_CHAR);
		act("The room is suddenly filled with light!",ch,NULL,NULL,TO_ROOM);
		return;
	}
	SET_BIT(ch->in_room->room_flags, ROOM_DARK);
	act("The lights in the room suddenly go out!",ch,NULL,NULL,TO_CHAR);
	act("The lights in the room suddenly go out!",ch,NULL,NULL,TO_ROOM);
	return;
}

void open_lift( CHAR_DATA *ch )
{
	ROOM_INDEX_DATA *location;
	int in_room;

	in_room  = ch->in_room->vnum;
	location = get_room_index(in_room);

	if (is_open(ch)) return;

	act("The doors open.",ch,NULL,NULL,TO_CHAR);
	act("The doors open.",ch,NULL,NULL,TO_ROOM);
	move_door(ch);
	if (is_open(ch)) act("The doors close.",ch,NULL,NULL,TO_ROOM);
	if (!same_floor(ch,in_room)) act("The lift judders suddenly.",ch,NULL,NULL,TO_ROOM);
	if (is_open(ch)) act("The doors open.",ch,NULL,NULL,TO_ROOM);
	move_door(ch);
	open_door(ch,FALSE);
	char_from_room(ch);
	char_to_room(ch,location);
	open_door(ch,TRUE);
	move_door(ch);
	open_door(ch,TRUE);
	thru_door(ch,in_room);
	char_from_room(ch);
	char_to_room(ch,location);
	return;
}


void close_lift( CHAR_DATA *ch )
{
	ROOM_INDEX_DATA *location;
	int in_room;

	in_room  = ch->in_room->vnum;
	location = get_room_index(in_room);

	if (!is_open(ch)) return;
	act("The doors close.",ch,NULL,NULL,TO_CHAR);
	act("The doors close.",ch,NULL,NULL,TO_ROOM);
	open_door(ch,FALSE);
	move_door(ch);
	open_door(ch,FALSE);
	char_from_room(ch);
	char_to_room(ch,location);
	return;
}

void move_lift( CHAR_DATA *ch, int to_room )
{
	ROOM_INDEX_DATA *location;
	int in_room;

	in_room  = ch->in_room->vnum;
	location = get_room_index(in_room);

	if (is_open(ch)) act("The doors close.",ch,NULL,NULL,TO_CHAR);
	if (is_open(ch)) act("The doors close.",ch,NULL,NULL,TO_ROOM);
	if (!same_floor(ch,to_room)) act("The lift judders suddenly.",ch,NULL,NULL,TO_CHAR);
	if (!same_floor(ch,to_room)) act("The lift judders suddenly.",ch,NULL,NULL,TO_ROOM);
	move_door(ch);
	open_door(ch,FALSE);
	char_from_room(ch);
	char_to_room(ch,location);
	open_door(ch,FALSE);
	thru_door(ch,to_room);
	return;
}

bool same_floor( CHAR_DATA *ch, int cmp_room )
{
	OBJ_DATA *obj;
	OBJ_DATA *obj_next;

	for ( obj = ch->in_room->contents; obj != NULL; obj = obj_next )
	{
		obj_next = obj->next_content;
		if ( obj->item_type != ITEM_PORTAL ) continue;
		if ( obj->pIndexData->vnum == 30001 ) continue;
		if ( obj->value[0] == cmp_room ) return TRUE;
		else return FALSE;
	}
	return FALSE;
}

bool is_open( CHAR_DATA *ch )
{
	OBJ_DATA *obj;
	OBJ_DATA *obj_next;

	for ( obj = ch->in_room->contents; obj != NULL; obj = obj_next )
	{
		obj_next = obj->next_content;
		if ( obj->item_type != ITEM_PORTAL ) continue;
		if ( obj->pIndexData->vnum == 30001 ) continue;
		if ( obj->value[2] == 0 ) return TRUE;
		else return FALSE;
	}
	return FALSE;
}

void move_door( CHAR_DATA *ch )
{
	OBJ_DATA *obj;
	OBJ_DATA *obj_next;
	ROOM_INDEX_DATA *pRoomIndex;

	for ( obj = ch->in_room->contents; obj != NULL; obj = obj_next )
	{
		obj_next = obj->next_content;
		if ( obj->item_type != ITEM_PORTAL ) continue;
		if ( obj->pIndexData->vnum == 30001 ) continue;
		pRoomIndex = get_room_index(obj->value[0]);
		char_from_room(ch);
		char_to_room(ch,pRoomIndex);
		return;
	}
	return;
}

void thru_door( CHAR_DATA *ch, int doorexit )
{
	OBJ_DATA *obj;
	OBJ_DATA *obj_next;

	for ( obj = ch->in_room->contents; obj != NULL; obj = obj_next )
	{
		obj_next = obj->next_content;
		if ( obj->item_type != ITEM_PORTAL ) continue;
		if ( obj->pIndexData->vnum == 30001 ) continue;
		obj->value[0] = doorexit;
		return;
	}
	return;
}

void open_door( CHAR_DATA *ch, bool be_open )
{
	OBJ_DATA *obj;
	OBJ_DATA *obj_next;

	for ( obj = ch->in_room->contents; obj != NULL; obj = obj_next )
	{
		obj_next = obj->next_content;
		if ( obj->item_type != ITEM_PORTAL ) continue;
		if ( obj->pIndexData->vnum == 30001 ) continue;
		if ( obj->value[2] == 0 && !be_open ) obj->value[2] = 3;
		else if ( obj->value[2] == 3 && be_open ) obj->value[2] = 0;
		return;
	}
	return;
}

char *socialc( CHAR_DATA *ch, char *argument, char *you, char *them )
{
	char buf  [MAX_STRING_LENGTH];
	char *pName;
	int iSyl;
	int length;

	struct spk_type
	    {
		char *	old;
		char *	new;
	};

	static const struct spk_type spk_table[] =
	    {
		{
			" ",		" "				}
		,
		{
			"you are",	"$E is"				}
		,
		{
			"you.",	"$M."				}
		,
		{
			"you,",	"$M,"				}
		,
		{
			"you ",	"$M "				}
		,
		{
			" you",	" $M"				}
		,
		{
			"your ",	"$S "				}
		,
		{
			" your",	" $S"				}
		,
		{
			"yours.",	"theirs."			}
		,
		{
			"yours,",	"theirs,"			}
		,
		{
			"yours ",	"theirs "			}
		,
		{
			" yours",	" theirs"			}
		,
		{
			"begins",	"begin"				}
		,
		{
			"caresses",	"caress"			}
		,
		{
			"gives",	"give"				}
		,
		{
			"glares",	"glare"				}
		,
		{
			"grins",	"grin"				}
		,
		{
			"licks",	"lick"				}
		,
		{
			"looks",	"look"				}
		,
		{
			"loves",	"love"				}
		,
		{
			"plunges",	"plunge"			}
		,
		{
			"presses",	"press"				}
		,
		{
			"pulls",	"pull"				}
		,
		{
			"runs",	"run"				}
		,
		{
			"slaps",	"slap"				}
		,
		{
			"slides",	"slide"				}
		,
		{
			"smashes",	"smash"				}
		,
		{
			"squeezes",	"squeeze"			}
		,
		{
			"stares",	"stare"				}
		,
		{
			"sticks",	"stick"				}
		,
		{
			"strokes",	"stroke"			}
		,
		{
			"tugs",	"tug"				}
		,
		{
			"thinks",	"think"				}
		,
		{
			"thrusts",	"thrust"			}
		,
		{
			"whistles",	"whistle"			}
		,
		{
			"wraps",	"wrap"				}
		,
		{
			"winks",	"wink"				}
		,
		{
			"wishes",	"wish"				}
		,
		{
			" winks",	" wink"				}
		,
		{
			" his",	" your"				}
		,
		{
			"his ",	"your "				}
		,
		{
			" her",	" your"				}
		,
		{
			"her ",	"your "				}
		,
		{
			" him",	" your"				}
		,
		{
			"him ",	"your "				}
		,
		{
			"the",	"the"				}
		,
		{
			" he",	" you"				}
		,
		{
			"he ",	"you "				}
		,
		{
			" she",	" you"				}
		,
		{
			"she ",	"you "				}
		,
		{
			"a", "a" 		}
		, {
			"b", "b" 		}
		, {
			"c", "c" 		}
		, {
			"d", "d" 		}
		,
		{
			"e", "e" 		}
		, {
			"f", "f" 		}
		, {
			"g", "g" 		}
		, {
			"h", "h" 		}
		,
		{
			"i", "i" 		}
		, {
			"j", "j" 		}
		, {
			"k", "k" 		}
		, {
			"l", "l" 		}
		,
		{
			"m", "m" 		}
		, {
			"n", "n" 		}
		, {
			"o", "o" 		}
		, {
			"p", "p" 		}
		,
		{
			"q", "q" 		}
		, {
			"r", "r" 		}
		, {
			"s", "s" 		}
		, {
			"t", "t" 		}
		,
		{
			"u", "u" 		}
		, {
			"v", "v" 		}
		, {
			"w", "w" 		}
		, {
			"x", "x" 		}
		,
		{
			"y", "y" 		}
		, {
			"z", "z" 		}
		, {
			",", "," 		}
		, {
			".", "." 		}
		,
		{
			";", ";" 		}
		, {
			":", ":" 		}
		, {
			"(", "(" 		}
		, {
			")", ")" 		}
		,
		{
			")", ")" 		}
		, {
			"-", "-" 		}
		, {
			"!", "!" 		}
		, {
			"?", "?" 		}
		,
		{
			"1", "1" 		}
		, {
			"2", "2" 		}
		, {
			"3", "3" 		}
		, {
			"4", "4" 		}
		,
		{
			"5", "5" 		}
		, {
			"6", "6" 		}
		, {
			"7", "7" 		}
		, {
			"8", "8" 		}
		,
		{
			"9", "9" 		}
		, {
			"0", "0" 		}
		, {
			"%", "%" 		}
		, {
			"",  "" 		}
	};
	buf[0]	= '\0';

	if ( argument[0] == '\0' ) return argument;

	for ( pName = argument; *pName != '\0'; pName += length )
	{
		for ( iSyl = 0; (length = strlen(spk_table[iSyl].old)) != 0; iSyl++ )
		{
			if ( !str_prefix( spk_table[iSyl].old, pName ) )
			{
				strcat( buf, spk_table[iSyl].new );
				break;
			}
		}


		if ( length == 0 )
			length = 1;
	}

	argument[0] = '\0';
	strcpy(argument,buf);
	argument[0] = UPPER(argument[0]);

	return argument;
}

char *socialv( CHAR_DATA *ch, char *argument, char *you, char *them )
{
	char buf  [MAX_STRING_LENGTH];
	char *pName;
	int iSyl;
	int length;

	struct spk_type
	    {
		char *	old;
		char *	new;
	};

	static const struct spk_type spk_table[] =
	    {
		{
			" ",		" "				}
		,
		{
			" his",	" $s"				}
		,
		{
			"his ",	"$s "				}
		,
		{
			" her",	" $s"				}
		,
		{
			"her ",	"$s "				}
		,
		{
			" him",	" $m"				}
		,
		{
			"him ",	"$m "				}
		,
		{
			" he",	" $e"				}
		,
		{
			"he ",	"$e "				}
		,
		{
			" she",	" $e"				}
		,
		{
			"she ",	"$e "				}
		,
		{
			"a", "a" 		}
		, {
			"b", "b" 		}
		, {
			"c", "c" 		}
		, {
			"d", "d" 		}
		,
		{
			"e", "e" 		}
		, {
			"f", "f" 		}
		, {
			"g", "g" 		}
		, {
			"h", "h" 		}
		,
		{
			"i", "i" 		}
		, {
			"j", "j" 		}
		, {
			"k", "k" 		}
		, {
			"l", "l" 		}
		,
		{
			"m", "m" 		}
		, {
			"n", "n" 		}
		, {
			"o", "o" 		}
		, {
			"p", "p" 		}
		,
		{
			"q", "q" 		}
		, {
			"r", "r" 		}
		, {
			"s", "s" 		}
		, {
			"t", "t" 		}
		,
		{
			"u", "u" 		}
		, {
			"v", "v" 		}
		, {
			"w", "w" 		}
		, {
			"x", "x" 		}
		,
		{
			"y", "y" 		}
		, {
			"z", "z" 		}
		, {
			",", "," 		}
		, {
			".", "." 		}
		,
		{
			";", ";" 		}
		, {
			":", ":" 		}
		, {
			"(", "(" 		}
		, {
			")", ")" 		}
		,
		{
			")", ")" 		}
		, {
			"-", "-" 		}
		, {
			"!", "!" 		}
		, {
			"?", "?" 		}
		,
		{
			"1", "1" 		}
		, {
			"2", "2" 		}
		, {
			"3", "3" 		}
		, {
			"4", "4" 		}
		,
		{
			"5", "5" 		}
		, {
			"6", "6" 		}
		, {
			"7", "7" 		}
		, {
			"8", "8" 		}
		,
		{
			"9", "9" 		}
		, {
			"0", "0" 		}
		, {
			"%", "%" 		}
		, {
			"",  "" 		}
	};
	buf[0]	= '\0';

	if ( argument[0] == '\0' ) return argument;

	for ( pName = argument; *pName != '\0'; pName += length )
	{
		for ( iSyl = 0; (length = strlen(spk_table[iSyl].old)) != 0; iSyl++ )
		{
			if ( !str_prefix( spk_table[iSyl].old, pName ) )
			{
				strcat( buf, spk_table[iSyl].new );
				break;
			}
		}

		if ( length == 0 )
			length = 1;
	}

	argument[0] = '\0';
	strcpy(argument,buf);
	argument[0] = UPPER(argument[0]);

	return argument;
}

char *socialn( CHAR_DATA *ch, char *argument, char *you, char *them )
{
	char buf  [MAX_STRING_LENGTH];
	char *pName;
	int iSyl;
	int length;

	struct spk_type
	    {
		char *	old;
		char *	new;
	};

	static const struct spk_type spk_table[] =
	    {
		{
			" ",		" "				}
		,
		{
			"you are",	"$N is"				}
		,
		{
			"you.",	"$N."				}
		,
		{
			"you,",	"$N,"				}
		,
		{
			"you ",	"$N "				}
		,
		{
			" you",	" $N"				}
		,
		{
			"your.",	"$N's."				}
		,
		{
			"your,",	"$N's,"				}
		,
		{
			"your ",	"$N's "				}
		,
		{
			" your",	" $N's"				}
		,
		{
			"yourself",	"$Mself"			}
		,
		{
			" his",	" $s"				}
		,
		{
			"his ",	"$s "				}
		,
		{
			" her",	" $s"				}
		,
		{
			"her ",	"$s "				}
		,
		{
			" him",	" $m"				}
		,
		{
			"him ",	"$m "				}
		,
		{
			" he",	" $e"				}
		,
		{
			"he ",	"$e "				}
		,
		{
			" she",	" $e"				}
		,
		{
			"she ",	"$e "				}
		,
		{
			"a", "a" 		}
		, {
			"b", "b" 		}
		, {
			"c", "c" 		}
		, {
			"d", "d" 		}
		,
		{
			"e", "e" 		}
		, {
			"f", "f" 		}
		, {
			"g", "g" 		}
		, {
			"h", "h" 		}
		,
		{
			"i", "i" 		}
		, {
			"j", "j" 		}
		, {
			"k", "k" 		}
		, {
			"l", "l" 		}
		,
		{
			"m", "m" 		}
		, {
			"n", "n" 		}
		, {
			"o", "o" 		}
		, {
			"p", "p" 		}
		,
		{
			"q", "q" 		}
		, {
			"r", "r" 		}
		, {
			"s", "s" 		}
		, {
			"t", "t" 		}
		,
		{
			"u", "u" 		}
		, {
			"v", "v" 		}
		, {
			"w", "w" 		}
		, {
			"x", "x" 		}
		,
		{
			"y", "y" 		}
		, {
			"z", "z" 		}
		, {
			",", "," 		}
		, {
			".", "." 		}
		,
		{
			";", ";" 		}
		, {
			":", ":" 		}
		, {
			"(", "(" 		}
		, {
			")", ")" 		}
		,
		{
			")", ")" 		}
		, {
			"-", "-" 		}
		, {
			"!", "!" 		}
		, {
			"?", "?" 		}
		,
		{
			"1", "1" 		}
		, {
			"2", "2" 		}
		, {
			"3", "3" 		}
		, {
			"4", "4" 		}
		,
		{
			"5", "5" 		}
		, {
			"6", "6" 		}
		, {
			"7", "7" 		}
		, {
			"8", "8" 		}
		,
		{
			"9", "9" 		}
		, {
			"0", "0" 		}
		, {
			"%", "%" 		}
		, {
			"",  "" 		}
	};
	buf[0]	= '\0';

	if ( argument[0] == '\0' ) return argument;

	for ( pName = argument; *pName != '\0'; pName += length )
	{
		for ( iSyl = 0; (length = strlen(spk_table[iSyl].old)) != 0; iSyl++ )
		{
			if ( !str_prefix( spk_table[iSyl].old, pName ) )
			{
				strcat( buf, spk_table[iSyl].new );
				break;
			}
		}

		if ( length == 0 )
			length = 1;
	}

	argument[0] = '\0';
	strcpy(argument,buf);
	argument[0] = UPPER(argument[0]);

	return argument;
}


void do_ignore(CHAR_DATA *ch, char *argument)
{
	CHAR_DATA *rch;
	char arg[MAX_INPUT_LENGTH],buf[MAX_STRING_LENGTH];
	DESCRIPTOR_DATA *d;
	int pos;
	bool found = FALSE;


	if (ch->desc == NULL)
		rch = ch;
	else
		rch = ch->desc->original ? ch->desc->original : ch;

	if (IS_NPC(rch))
		return;

	smash_tilde( argument );

	argument = one_argument(argument,arg);

	if (arg[0] == '\0')
	{
		if (rch->pcdata->forget[0] == NULL)
		{
			send_to_char("You are not ignoring anyone.\n\r",ch);
			return;
		}
		send_to_char("You are currently ignoring:\n\r",ch);

		for (pos = 0; pos < MAX_FORGET; pos++)
		{
			if (rch->pcdata->forget[pos] == NULL)
				break;

			sprintf(buf,"    %s\n\r",rch->pcdata->forget[pos]);
			send_to_char(buf,ch);
		}
		return;
	}

	for (pos = 0; pos < MAX_FORGET; pos++)
	{
		if (rch->pcdata->forget[pos] == NULL)
			break;

		if (!str_cmp(arg,rch->pcdata->forget[pos]))
		{
			send_to_char("You have already ignored that person.\n\r",ch);
			return;
		}
	}

	for (d = descriptor_list; d != NULL; d = d->next)
	{
		CHAR_DATA *wch;

		if (d->connected != CON_PLAYING || !can_see(ch,d->character))
			continue;

		wch = ( d->original != NULL ) ? d->original : d->character;

		if (!can_see(ch,wch))
			continue;

		if (!str_cmp(arg,wch->name))
		{
			found = TRUE;
			if (wch == ch)
			{
				send_to_char("You can't ignore yourself!\n\r", ch );
				return;
			}
			if (wch->level >= LEVEL_IMMORTAL)
			{
				send_to_char("That person is very hard to ignore.\n\r",ch);
				return;
			}
		}
	}

	if (!found)
	{
		send_to_char("No one by that name is playing.\n\r",ch);
		return;
	}

	for (pos = 0; pos < MAX_FORGET; pos++)
	{
		if (rch->pcdata->forget[pos] == NULL)
			break;
	}

	if (pos >= MAX_FORGET)
	{
		send_to_char("Sorry, you have reached the ignore limit.\n\r",ch);
		return;
	}

	/* make a new forget */
	rch->pcdata->forget[pos]		= str_dup(arg);
	sprintf(buf,"You are now ignoring %s.\n\r",arg);
	send_to_char(buf,ch);
}

void do_unignore(CHAR_DATA *ch, char *argument)
{
	CHAR_DATA *rch;
	char arg[MAX_INPUT_LENGTH],buf[MAX_STRING_LENGTH];
	int pos;
	bool found = FALSE;

	if (ch->desc == NULL)
		rch = ch;
	else
		rch = ch->desc->original ? ch->desc->original : ch;

	if (IS_NPC(rch))
		return;

	argument = one_argument(argument,arg);

	if (arg[0] == '\0')
	{
		if (rch->pcdata->forget[0] == NULL)
		{
			send_to_char("You are not ignoring anyone.\n\r",ch);
			return;
		}
		send_to_char("You are currently ignoring:\n\r",ch);

		for (pos = 0; pos < MAX_FORGET; pos++)
		{
			if (rch->pcdata->forget[pos] == NULL)
				break;

			sprintf(buf,"    %s\n\r",rch->pcdata->forget[pos]);
			send_to_char(buf,ch);
		}
		return;
	}

	for (pos = 0; pos < MAX_FORGET; pos++)
	{
		if (rch->pcdata->forget[pos] == NULL)
			break;

		if (found)
		{
			rch->pcdata->forget[pos-1]		= rch->pcdata->forget[pos];
			rch->pcdata->forget[pos]		= NULL;
			continue;
		}

		if(!strcmp(arg,rch->pcdata->forget[pos]))
		{
			send_to_char("Ignore removed.\n\r",ch);
			free_string(rch->pcdata->forget[pos]);
			rch->pcdata->forget[pos] = NULL;
			found = TRUE;
		}
	}

	if (!found)
		send_to_char("No one by that name is ignored.\n\r",ch);
}


void do_notag(CHAR_DATA *ch, char *argument) /*Removes a players TAG flag if set... */
{
	if (IS_SET (ch->act, PLR_NOTAG ) )
	{
		send_to_char("You now allow people to tag you. (YAY!)\n\r", ch);
		REMOVE_BIT( ch->act, PLR_NOTAG );
		return;
	}
	else
	    {
		send_to_char("You nolonger let people tag you... (Spoil Sport!)\n\r", ch);
		SET_BIT( ch->act, PLR_NOTAG );
		return;
	}

}

/********************************************************************/

void game_in_play(CHAR_DATA *ch, char *name)
{
	CHAR_DATA       *on_it;
	DESCRIPTOR_DATA	*d;

	for ( d = descriptor_list; d; d = d->next )
	{
		if ( d->connected == CON_PLAYING && IS_SET(d->character->act, PLR_TAG) )
		{
			on_it = d->character;
			strcpy(name, d->character->name);
		}
	}
	return;
}

void do_telepath( CHAR_DATA *ch, char *argument )
{
	if (IS_NPC( ch ) || (!IS_IMMORTAL(ch) && !IS_CLASS(ch,CLASS_SHAPESHIFTER) ))
	{
                do_rand_typo(ch,"");
		return;
	}
	talk_channel( ch, argument, CHANNEL_TELEPATH, "telepaths" );
	return;
}

void do_communicate( CHAR_DATA *ch, char *argument )
{
	if (IS_NPC(ch) || (!IS_IMMORTAL(ch)&&!IS_CLASS(ch,CLASS_CYBORG)))
	{
                do_rand_typo(ch,"");
		return;
	}
	talk_channel(ch,argument,CHANNEL_COMMUNICATE,"communicate");
	return;
}
