/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these copyright notices.                                               *
 *                                                                         *
 *  Much time and thought has gone into this software and you are          *
 *  benefitting.  We hope that you share your changes too.  What goes      *
 *  around, comes around.                                                  *
 ***************************************************************************/


#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"

void save_config args(( void ));
void load_config args(( void ));
void check_class args(( CHAR_DATA *ch ));

void check_class( CHAR_DATA *ch )
{
    if ( IS_CLASS(ch, CLASS_VAMPIRE) )
    {
      if ( (config_info->drow + config_info->demons + config_info->ninjas + config_info->monks) / 3 < config_info->vampires )
      {
	stc("Sorry. There are too many Vampires at the moment.\n",ch);
	stc("Try another class, or select None for now.\n\r",ch);
	ch->class = 0;
	ch->generation = 1;
      }
    }

    else if ( IS_CLASS(ch, CLASS_DROW) )
    {
      if ( (config_info->vampires + config_info->demons + config_info->ninjas + config_info->monks) / 3 < config_info->drow )
      {
        stc("Sorry. There are too many Drow at the moment.\n\r",ch);
        stc("Try another class, or select None for now.\n\r",ch);
        ch->class = 0;
        ch->generation = 1;
      }
    }

    else if ( IS_CLASS(ch, CLASS_DEMON) )
    {
      if ( (config_info->vampires + config_info->drow + config_info->ninjas + config_info->monks) / 3 < config_info->demons )
      {
	stc("Sorry. There are too many Demons at the moment.\n\r",ch);
	stc("Try another class, or select None for now.\n\r",ch);
	ch->class = 0;
	ch->generation = 1;
      }
    }

     else if ( IS_CLASS(ch, CLASS_NINJA) )
    {
      if ( (config_info->vampires + config_info->drow + config_info->demons + config_info->monks) / 3 < config_info->ninjas )
      {
        stc("Sorry. There are too many Ninjas at the moment.\n\r",ch);
        stc("Try another class, or select None for now.\n\r",ch);
        ch->class = 0;
        ch->generation = 1;
      }
    }

    else if ( IS_CLASS(ch, CLASS_MONK) )
    {
      if ( (config_info->vampires + config_info->drow + config_info->ninjas + config_info->demons) / 3 < config_info->monks )
      {
	stc("Sorry. There are too many Monks at the moment.\n\r",ch);
	stc("Try another class, or select None for now.\n\r",ch);
	ch->class = 0;
	ch->generation = 1;
      }
    }
  
    else return;

  return;

}

void initialise_config()
{
    if (config_info == NULL)
	config_info = alloc_perm( sizeof(*config_info) );

    config_info->demons		= 0;
    config_info->mages		= 0;
    config_info->vampires	= 0;
    config_info->werewolves	= 0;
    config_info->drow		= 0;
    config_info->monks		= 0;
    config_info->ninjas		= 0;
    load_config();
}

void load_config()
{
    FILE *fp;

    if ((fp = fopen("config.sys","r")) == NULL)
    {
	bug("Creating config.sys",0);
	save_config();
	return;
    }

    fread_to_eol( fp );
	fread_word(fp);
    config_info->demons		= fread_number( fp ); 
	fread_word(fp);
    config_info->mages		= fread_number( fp ); 
	fread_word(fp);
    config_info->vampires	= fread_number( fp ); 
	fread_word(fp);
    config_info->werewolves	= fread_number( fp ); 
	fread_word(fp);
    config_info->drow		= fread_number( fp ); 
	fread_word(fp);
    config_info->monks		= fread_number( fp ); 
        fread_word(fp);
    config_info->ninjas         = fread_number( fp );
    fclose( fp );
}


void save_config()
{
    FILE *fp;

    if ((fp = fopen("config.sys","w")) == NULL)
    {
	bug("Error saving to config.sys",0);
	return;
    }

    fprintf( fp, "Config.sys - Stuff for Classes, etc.\n");
    fprintf( fp, "Demons	%d\n",config_info->demons    );
    fprintf( fp, "Mages		%d\n",config_info->mages     );
    fprintf( fp, "Vampires      %d\n",config_info->vampires  );
    fprintf( fp, "Werewolves	%d\n",config_info->werewolves);
    fprintf( fp, "Drow		%d\n",config_info->drow	     );
    fprintf( fp, "Monks		%d\n",config_info->monks     );
    fprintf( fp, "Ninjas        %d\n",config_info->ninjas    );
    fclose( fp );
}

