#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"
#include "player.h"

int find_dam( CHAR_DATA *ch, CHAR_DATA *victim, int dam, bool foot )
{
  OBJ_DATA *boots;
  int stance;
  int dambonus args((CHAR_DATA *ch, CHAR_DATA *victim, int dam, int stance ));

  dam += char_damroll(ch);

  if (dam == 0) dam = 1;
  if (IS_AFFECTED(victim, AFF_SANCTUARY))
    dam = dam/2;
  if (!IS_AWAKE(victim))
    dam *= 2;
  if ( !IS_NPC(ch) && IS_CLASS(ch, CLASS_VAMPIRE) && ch->power[DISC_VAMP_POTE] > 0) dam *= (ch->power[DISC_VAMP_POTE] * .4);
  else if (ch->power[DISC_DAEM_ATTA] > 0) dam *= ch->power[DISC_DAEM_ATTA] * .5;
  if (!IS_NPC(ch) && IS_CLASS(ch, CLASS_MONK) )
  {
    if (ch->chi[CURRENT] > 0 && ch->chi[CURRENT] < 3) dam *= 1.2;
    if (ch->chi[CURRENT] > 2) dam *= ( ch->chi[CURRENT] / 2 );
  }
  if ( !IS_NPC(victim) && IS_CLASS(victim, CLASS_WEREWOLF) )
  {
    if (IS_SET(victim->special, SPC_WOLFMAN)) dam *= 0.3;
    if (victim->power[DISC_WERE_BOAR] > 2 ) dam *= 0.3;
    if (foot == TRUE)
    {
      if ((boots = get_eq_char( ch, WEAR_FEET )) != NULL && IS_SET(boots->spectype, SITEM_SILVER))
        dam *= 2;
    }
    if (foot == FALSE)
    {
      if ((boots = get_eq_char(ch, WEAR_HANDS)) != NULL && IS_SET(boots->spectype, SITEM_SILVER))
        dam *= 2;
    }
  }
  if ( !IS_NPC(ch) && IS_CLASS(ch, CLASS_WEREWOLF))
  {
    if (ch->power[DISC_WERE_LUNA] > 6)
    {
      if (weather_info.sunlight == SUN_DARK)
        dam *= 1.6;
    }
  }
  if ( !IS_NPC(ch) && IS_CLASS(ch, CLASS_VAMPIRE) )
  {
    if (weather_info.sunlight == SUN_LIGHT && dam > 1) dam /= 1.5;
    else if (weather_info.sunlight == SUN_DARK) dam *= 1.5;
  }
  if ( !IS_NPC(ch) ) dam = dam + (dam * ((ch->wpn[0]+1) / 100));
  if ( !IS_NPC(ch) )
  {
    stance = ch->stance[0];
    if ( IS_STANCE(ch, STANCE_NORMAL) ) dam *= 1.25;
    else dam = dambonus(ch,victim,dam,stance);
  }
  if (!IS_NPC(victim) && dam > 1000) dam = number_range( 940, 1020 );
  if (dam <= 0) dam = 2;
  return dam;
}


void do_monkarmor( CHAR_DATA *ch, char *argument )
{
  OBJ_INDEX_DATA *pObjIndex;
  OBJ_DATA *obj;
  char arg[MAX_INPUT_LENGTH];
  int vnum = 0;

  argument = one_argument( argument, arg );
  if (IS_NPC(ch)) return;
 	if(!IS_IMMORTAL(ch))
	{
    if (!IS_CLASS(ch, CLASS_MONK))
    {
      send_to_char("What?\n\r",ch);
      return;
    }
	}
  if (arg[0] == '\0')
  {
    send_to_char("Please specify which piece of monk armor you wish to make: Ring Collar Robe
Helmet Shorts Boots Gloves Sleeves Cloak Belt Bracer Mask.\n\r",ch);
    return;
  }
  if ( ch->practice <60 )
  {
    send_to_char("It costs 60 points of primal to create monk equipment.\n\r",ch);
    return;
  }
  if      (!str_cmp(arg,"bracer"     )) vnum = 33029;
  else if (!str_cmp(arg,"cloak"   )) vnum = 33027;
  else if (!str_cmp(arg,"gloves"    )) vnum = 33025;
  else if (!str_cmp(arg,"ring"    )) vnum = 33020;
  else if (!str_cmp(arg,"collar"    )) vnum = 33021;
  else if (!str_cmp(arg,"robe"    )) vnum = 33022;
  else if (!str_cmp(arg,"helmet"    )) vnum = 33024;
  else if (!str_cmp(arg,"boots"    )) vnum = 33031;
  else if (!str_cmp(arg,"shorts"    )) vnum = 33023;
  else if (!str_cmp(arg,"sleeves"    )) vnum = 33026;
  else if (!str_cmp(arg,"belt"    )) vnum = 33028;
  else if (!str_cmp(arg,"mask"    )) vnum = 33030;
  else
  {
    do_monkarmor(ch,"");
    return;
  }
  if ( vnum == 0 || (pObjIndex = get_obj_index( vnum )) == NULL)
  {
    send_to_char("Missing object, please inform a God.\n\r",ch);
    return;
  }
  obj = create_object(pObjIndex, 50);
  obj->questowner = str_dup(ch->pcdata->switchname);
  obj_to_char(obj, ch);
  ch->practice -= 60;
  act("$p appears in your hands.",ch,obj,NULL,TO_CHAR);
  act("$p appears in $n's hands.",ch,obj,NULL,TO_ROOM);
  return;
}

void do_deathtouch( CHAR_DATA *ch, char *argument )
{
  CHAR_DATA *victim;
  char arg[MAX_INPUT_LENGTH];

  argument = one_argument( argument, arg );

  if (IS_NPC(ch)) return;
  if ( !IS_CLASS(ch, CLASS_MONK) )
  {
    stc("Huh?\n\r",ch);
    return;
  }
  if ( ch->monkab[SPIRIT] < 4 )
  {
    stc("You need to obtain level 4 spirit to use Death touch.\n\r",ch);
    return;
  }
  if ( ( victim = get_char_room( ch, arg ) ) == NULL )
  {
    send_to_char("They are not here.\n\r", ch);
    return;
  }
  if (IS_NPC(victim))
  {
    send_to_char("Not on mobiles.\n\r",ch);
    return;
  }
  if (is_safe(ch,victim) ) return;
  if ( victim == ch )
  {
    stc("That doesn't seem like a good idea.\n\r",ch);
    return;
  }
  WAIT_STATE(ch, 12);
  act("You place your hands on $N's head and channel negative energy into $m.",ch,NULL,victim,TO_CHAR);
  act("$n places $s hands on your head, and you scream in utter pain.",ch,NULL,victim,TO_VICT);
  act("$n places $s hands on $N's head and $N screams in pain.",ch,NULL,victim,TO_ROOM);
  SET_BIT(victim->monkstuff, MONK_DEATH);
  return;
}

void do_healingtouch( CHAR_DATA *ch, char *argument )
{
  CHAR_DATA *victim;
  char arg[MAX_INPUT_LENGTH];

  argument = one_argument( argument, arg );

  if (IS_NPC(ch)) return;
  if ( !IS_CLASS(ch, CLASS_MONK) )
  {
    stc("Huh?\n\r",ch);
    return;
  }
  if ( ch->monkab[SPIRIT] < 3 )
  {
    stc("You need to obtain level 3 spirit to use Healing touch.\n\r",ch);
    return;
  }
  if ( ( victim = get_char_room( ch, arg ) ) == NULL )
  {
    send_to_char("They are not here.\n\r", ch);
    return;
  }
  if (IS_NPC(victim))
  {
    send_to_char("Not on mobiles.\n\r",ch);
    return;
  }
  WAIT_STATE(ch, 12);
  
  if ( victim == ch )
  {
    stc("You focus your energy, and magical sparks leap out of your body.\n\r",ch);
    act("$n concentrates, and magical sparks leap out of $s body.",ch,NULL,NULL,TO_ROOM);
    SET_BIT(ch->monkstuff, MONK_HEAL);
    return;
  }
  act("You place your hands on $N's head and focus your energy on $M.",ch,NULL,victim,TO_CHAR);
  act("$n places $s hands on your head and you feel warmer.",ch,NULL,victim,TO_VICT);
  act("$n places $s hands on $N's head and concentrates.",ch,NULL,victim,TO_ROOM);
  SET_BIT(victim->monkstuff, MONK_HEAL);
  return;
}

void do_spiritpower( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_MONK) || ch->monkab[BODY] < 3)
  {
    stc("Huh?\n\r",ch);
    return;
  }
  if ( IS_SET(ch->newbits, NEW_POWER) )
  {
    stc("Your spiritual power fades.\n\r",ch);
    ch->damroll -= 200;
    ch->hitroll -= 200;
    REMOVE_BIT(ch->newbits, NEW_POWER);
    return;
  }
  if ( ch->move < 100 )
  {
    stc("You are too exhausted.\n\r",ch);
    return;
  }
  SET_BIT(ch->newbits, NEW_POWER);
  ch->damroll += 200;
  ch->hitroll += 200;
  ch->move -= 25;
  stc("Your body pulses with spiritual energy.\n\r",ch);
  return;
}
    
void do_relax( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch) ) return;
  if ( !IS_CLASS(ch, CLASS_MONK) )
  {
    stc("Huh?\n\r",ch);
    return;
  }
  if ( ch->chi[CURRENT] < 1 )
  {
    stc("You are already totally relaxed.\n\r",ch);
    return;
  }
  if ( ch->position == POS_FIGHTING )
  {
    stc("You cannot relax your ch'i while fighting!\n\r",ch);
    return;
  }
  ch->chi[CURRENT]--;
  WAIT_STATE(ch, 12);
  stc("You breathe deeply and relax your focus.\n\r",ch);
  act("$n looks more relaxed.",ch,NULL,NULL,TO_ROOM);
  return;
}

void do_chi( CHAR_DATA *ch, char *argument )
{
  char buf[MAX_STRING_LENGTH];

  if (IS_NPC(ch) ) return;
  if (!IS_CLASS(ch, CLASS_MONK) )
  {
    stc("Huh?\n\r",ch);
    return;
  }
  if ( ch->fighting == NULL )
  {
    stc("You must be fighting to focus your ch'i.\n\r",ch);
    return;
  }

  if ( ch->chi[CURRENT] >= ch->chi[MAXIMUM] )
  {
    if (ch->chi[MAXIMUM] == 0) stc("You have not gained any control of your ch'i.\n\r",ch);
    else
    {
      sprintf(buf,"You cannot focus your ch'i past a level of %d.",ch->chi[MAXIMUM]);
      stc(buf,ch);
    }
    return;
  }
  if ( ch->move < 500 + ((ch->chi[CURRENT]+1) * 20) )
  {
    stc("You are too exhausted.\n\r",ch);
    return;
  }
  if ( ch->chi[CURRENT] == 0 )
  {
    stc("Your body flickers with energy.\n\r",ch);
    act("$n's body flickers with energy.",ch,NULL,NULL,TO_ROOM);
  }
  if ( ch->chi[CURRENT] == 1 )
  {
    stc("Your body pulses with energy.\n\r",ch);
    act("$n's body pulses with energy.",ch,NULL,NULL,TO_ROOM);
  }
  if ( ch->chi[CURRENT] == 2 )
  {
    stc("Your body glows with blue energy.\n\r",ch);
    act("$n's body glows with blue energy.",ch,NULL,NULL,TO_ROOM);
  }
  if ( ch->chi[CURRENT] == 3 )
  {
    stc("Your body glows bright red.\n\r",ch);
    act("$n's body glows bright red.",ch,NULL,NULL,TO_ROOM);
  }
  if ( ch->chi[CURRENT] == 4 )
  {
    stc("Your body flashes with power.\n\r",ch);
    act("$n's body flashes with power.",ch,NULL,NULL,TO_ROOM);
  }
  if ( ch->chi[CURRENT] == 5 )
  {
    stc("Your body emits sparks of energy as you fully focus your ch'i.\n\r",ch);
    act("$n's body emits sparks of energy.",ch,NULL,NULL,TO_ROOM);
  }
  WAIT_STATE(ch, 12);
  ch->chi[CURRENT]++;
  ch->move -= ((ch->chi[CURRENT] * 20));
  return;
}

void do_chands(CHAR_DATA *ch, char *argument )
{
  if(IS_NPC(ch)) return;
  if(!IS_CLASS(ch, CLASS_MONK))
  {
    stc("Huh?\n\r", ch);
    return;
  }
  
  if ( ch->pcdata->powers[PMONK] < 9 )
  {
    stc("You do not yet have this ability\n\r", ch);
    return;
  }

  if(IS_ITEMAFF(ch, ITEMA_CHAOSHANDS))
  {
    if(IS_ITEMAFF(ch, ITEMA_FIRESHIELD))
      REMOVE_BIT(ch->itemaffect, ITEMA_FIRESHIELD); 
    if(IS_ITEMAFF(ch, ITEMA_ACIDSHIELD))
      REMOVE_BIT(ch->itemaffect, ITEMA_ACIDSHIELD); 
    if(IS_ITEMAFF(ch, ITEMA_SHOCKSHIELD))
      REMOVE_BIT(ch->itemaffect, ITEMA_SHOCKSHIELD);  
    if(IS_ITEMAFF(ch, ITEMA_ICESHIELD))
      REMOVE_BIT(ch->itemaffect, ITEMA_ICESHIELD);  
    if(IS_ITEMAFF(ch, ITEMA_CHAOSSHIELD))
      REMOVE_BIT(ch->itemaffect, ITEMA_CHAOSSHIELD);  
    REMOVE_BIT(ch->itemaffect, ITEMA_CHAOSHANDS);
    act("The swirling colors around your hands disappear.",ch,NULL,NULL,TO_CHAR);
    act("The swirling colors around $n's hands disappear.",ch,NULL,NULL,TO_ROOM);
    return;
  }
  else
  {
    if(!IS_ITEMAFF(ch, ITEMA_FIRESHIELD))
      SET_BIT(ch->itemaffect, ITEMA_FIRESHIELD);  
    if(!IS_ITEMAFF(ch, ITEMA_ACIDSHIELD))
      SET_BIT(ch->itemaffect, ITEMA_ACIDSHIELD);  
    if(!IS_ITEMAFF(ch, ITEMA_SHOCKSHIELD))
      SET_BIT(ch->itemaffect, ITEMA_SHOCKSHIELD); 
    if(!IS_ITEMAFF(ch, ITEMA_ICESHIELD))
      SET_BIT(ch->itemaffect, ITEMA_ICESHIELD); 
    if(!IS_ITEMAFF(ch, ITEMA_CHAOSSHIELD))
      SET_BIT(ch->itemaffect, ITEMA_CHAOSSHIELD); 
    SET_BIT(ch->itemaffect, ITEMA_CHAOSHANDS);
    act("Swirling colors appear around your hands bringing up shields.",ch,NULL,NULL,TO_CHAR);
    act("Swirling colors appear around $n's hands.",ch,NULL,NULL,TO_ROOM);
    return;
  }
}

void do_guide( CHAR_DATA *ch, char *argument )
{
  CHAR_DATA *victim;
  char arg [MAX_INPUT_LENGTH];

  argument = one_argument( argument, arg );

  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_MONK) )
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if ( arg[0] == '\0' )
  {
    send_to_char( "Guide whom?\n\r", ch );
    return;
  }
  if ((victim = get_char_room(ch, arg)) == NULL)
  {
    send_to_char( "They aren't here.\n\r", ch );
    return;
  }
  if (IS_NPC(victim))
  {
    send_to_char( "Not on NPC's.\n\r", ch );
    return;
  }
  if (IS_IMMORTAL(victim))
  {
    send_to_char( "Not on Immortals's.\n\r", ch );
    return;
  }
  if (ch == victim)
  {
    send_to_char( "You cannot guide yourself.\n\r", ch );
    return;
  }

  if (IS_CLASS(victim, CLASS_MONK))
  {
    send_to_char( "They are already guided.\n\r", ch );
    return;
  }

  if (victim->level != LEVEL_AVATAR)
  {
    send_to_char( "You can only guide avatars.\n\r", ch );
    return;
  }
  if (victim->class != 0)
  {
    send_to_char("They already have a class.\n\r",ch);
    return;
  }
  if (!IS_IMMUNE(victim,IMM_VAMPIRE))
  {
    send_to_char( "You cannot guide an unwilling person.\n\r", ch );
    return;
  }
  if (ch->exp < 50000)
  {
    send_to_char("You cannot afford the 50000 exp required to guide them.\n\r",ch);
    return;
  }
  if (victim->exp < 50000)
  {
    send_to_char("They cannot afford the 50000 exp required to be guided from you.\n\r",ch);
    return;
  }
  
  ch->exp -= 50000;
  victim->exp -= 50000;

  act("You guide $N in the ways of god.", ch, NULL, victim, TO_CHAR);
  act("$n guide $N in the ways of god.", ch, NULL, victim, TO_NOTVICT);
  act("$n guide you in the way of god.", ch, NULL, victim, TO_VICT);
  victim->level = LEVEL_AVATAR;
  if (victim->trust > 3)
  victim->trust = victim->trust;
  else
  victim->trust = LEVEL_AVATAR;
  send_to_char( "You are now a monk.\n\r", victim );
  free_string(victim->lord);
  victim->lord = str_dup(ch->name);
  victim->class = CLASS_MONK;
  save_char_obj(ch);
  save_char_obj(victim);
  return;
}

void do_mantra( CHAR_DATA *ch, char *argument )
{
  char arg1[MAX_INPUT_LENGTH];
  char arg2[MAX_INPUT_LENGTH];
  char buf[MAX_STRING_LENGTH];
  argument = one_argument( argument, arg1 );
  argument = one_argument( argument, arg2 );

  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if (arg1[0] == '\0' && arg2[0] == '\0')
  {
    sprintf(buf,"Mantras Learned (%d).\n\r", ch->pcdata->powers[PMONK]);
    send_to_char(buf,ch);
    send_to_char("Powers you have:\n\r", ch);
    if ( ch->pcdata->powers[PMONK] < 1 )
     send_to_char("You have no knowledge of any Mantras.\n\r", ch);
    if ( ch->pcdata->powers[PMONK] >= 1 )
     send_to_char("Eyes of God.\n\r", ch);
    if ( ch->pcdata->powers[PMONK] >= 2 )
     send_to_char("Shield/Read Aura/Scry\n\r", ch);
    if ( ch->pcdata->powers[PMONK] >= 3 )
     send_to_char("Sacred Invisibility\n\r", ch);
    if ( ch->pcdata->powers[PMONK] >= 4 )
     send_to_char("Wrath of God\n\r", ch);
    if ( ch->pcdata->powers[PMONK] >= 5 )
     send_to_char("Adamantium Hands\n\r", ch);
    if ( ch->pcdata->powers[PMONK] >= 6 )
     send_to_char("Skin of Steel\n\r", ch);
    if ( ch->pcdata->powers[PMONK] >= 7 )
     send_to_char("The Almighty Favor\n\r", ch);
    if ( ch->pcdata->powers[PMONK] >= 8 )
     send_to_char("Dark Blaze\n\r", ch);
    if ( ch->pcdata->powers[PMONK] >= 9 )
     send_to_char("Chaos Hands\n\r", ch);
    if ( ch->pcdata->powers[PMONK] >= 10 )
     send_to_char("Prayer of the Ages\n\r", ch);
    if ( ch->pcdata->powers[PMONK] >= 11 )
     send_to_char("Cloak of Life\n\r", ch);
    if ( ch->pcdata->powers[PMONK] >= 12 )
     send_to_char("Gods Heal.\n\r", ch);
    if ( ch->pcdata->powers[PMONK] >= 13 )
     send_to_char("Gods Hold.\n\r", ch);
    if ( ch->pcdata->powers[PMONK] >= 14 )
     send_to_char("You have completed your Mantra training.\n\r", ch);
  return;
  }
  if (!str_cmp(arg2,"improve"))
  {
    int improve;
    int cost;
    int max;

    if (!str_cmp(arg1,"power"   )) 
    {
      improve = PMONK;   
      max=14;
    }
    else
    {
      send_to_char("________________________________\n\r",ch);
      send_to_char("|                               |\n\r",ch);
      send_to_char("|             Mantras           |\n\r",ch);
      send_to_char("|_______________________________|\n\r",ch);
      send_to_char("| 1.        Eye of God          |\n\r",ch);
      send_to_char("| 2.   Shield/Read Aura/Scry    |\n\r",ch);
      send_to_char("| 3.    Sacred Invisibility     |\n\r",ch);
      send_to_char("| 4.       Wrath of God         |\n\r",ch);
      send_to_char("| 5.     Adamantium Hands       |\n\r",ch);
      send_to_char("| 6.       Flaming Hands        |\n\r",ch);
      send_to_char("| 7.       Skin of Steel        |\n\r",ch);
      send_to_char("| 8.    The Almighty's Favor    |\n\r",ch);
      send_to_char("| 9.        Dark Blaze          |\n\r",ch);
      send_to_char("| 10.     Celestial Path        |\n\r",ch);
      send_to_char("| 11.   Pray of the Ages        |\n\r",ch);
      send_to_char("| 12.     Cloak of Life         |\n\r",ch);
      send_to_char("| 13.      God's heal           |\n\r",ch);
      send_to_char("| 14.      God's hold           |\n\r",ch);
      send_to_char("|_______________________________|\n\r",ch);
      return;
    }             

    cost = (ch->pcdata->powers[improve]+1) * 10;
    arg1[0] = UPPER(arg1[0]);
    if ( ch->pcdata->powers[improve] >= max )
    {
      sprintf(buf,"You have already gained all the known Mantras.\n\r");
      send_to_char(buf,ch);
      return;
    }
    if ( cost > ch->practice )
    {
      sprintf(buf,"It costs you %d primal learn the Mantra.\n\r", cost);
      send_to_char(buf,ch);
      return;
    }

    ch->pcdata->powers[improve] += 1;
    ch->practice -= cost;
    sprintf(buf,"You learn a Mantra.\n\r");
    send_to_char(buf,ch);
  }
  else send_to_char("To learn a Mantra, type: Mantra power improve.\n\r",ch);
  return;
}

void do_cloak( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if (ch->pcdata->powers[PMONK] < 11 )
  {
    send_to_char("You do not have the mantra of the Cloak of Life.\n\r",ch);
    return;
  }
  if (ch->move < 1000)
  {
    send_to_char("You do not have enough vitality to do that.\n\r",ch);
    return;
  }
  if (IS_SET(ch->newbits, NEW_MONKCLOAK))
  {
    REMOVE_BIT(ch->newbits, NEW_MONKCLOAK);
    send_to_char("You are no longer protected by the Almighty's cloak.\n\r",ch);
    act("$n is no longer protected by the Almighty's cloak of life.\n\r",ch,NULL,NULL,TO_ROOM);
    return;
  }
  if (!IS_SET(ch->newbits,NEW_MONKCLOAK))
  {
    SET_BIT(ch->newbits, NEW_MONKCLOAK);
    send_to_char("You are protected by the Almighty's cloak.\n\r",ch);
    act("$n is protected by the Almighty's cloak of life.\n\r",ch,NULL,NULL,TO_ROOM);
    ch->move = ch->move - 1000;
    return;
  }
}

void do_prayofages( CHAR_DATA *ch, char *argument )
{
  char arg [MAX_INPUT_LENGTH];

  argument = one_argument( argument, arg );
/*    
  ***            Useless                     ***
  ** Used to be some sort of teleport command **
  ***                                        ***
*/  
  return;
}

void do_sacredinvis( CHAR_DATA *ch, char *argument)
{
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if (ch->pcdata->powers[PMONK] < 3)
  {
    send_to_char("You do not have the mantra of Sacred Invisibility.\n\r",ch);
    return;
  }
  if (ch->fight_timer >0) {
    send_to_char("Not until your fight timer expires.\n\r", ch );
    return;
  }
  if ( IS_SET(ch->act, AFF_HIDE) )
  {
    REMOVE_BIT(ch->act, AFF_HIDE);
    send_to_char( "You emerge from your cloak of invisibility.\n\r", ch );
    act("$n slowly emerges from a cloak of holy invisibility.",ch,NULL,NULL,TO_ROOM);
  }
  else
  {
    if (ch->move < 500) 
    {
      send_to_char("You do not have enough movement to do this.\n\r", ch );
      return;
    }
    send_to_char( "You slowly fade into a cloak of invisibility.\n\r", ch );
    act("$n slowly fades into a cloak of holy invisibility..",ch,NULL,NULL,TO_ROOM);
    SET_BIT(ch->act, AFF_HIDE);
    ch->move -= 500;
  }
  return;
}

void do_flaminghands( CHAR_DATA *ch, char *argument)
{
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if (ch->pcdata->powers[PMONK] <5)
  {
    send_to_char("You do not have the mantra of Flaming Hands.\n\r",ch);
    return;
  }
  if (IS_SET(ch->newbits, NEW_MONKFLAME))
  {
    REMOVE_BIT(ch->newbits, NEW_MONKFLAME);
    send_to_char("Your hands are no longer engulfed by flames.\n\r",ch);
    act("$n's hands are no longer engulfed by flames.\n\r",ch,NULL,NULL,TO_ROOM);
    return;
  }
  if (!IS_SET(ch->newbits, NEW_MONKFLAME))
  {
    SET_BIT(ch->newbits, NEW_MONKFLAME);
    send_to_char("Your hands are engulfed by flames!\n\r",ch);
    act("$n's hands are engulfed by flames!\n\r",ch,NULL,NULL,TO_ROOM);
    return;
  }
}

void do_adamantium( CHAR_DATA *ch, char *argument)
{
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if (ch->monkab[BODY] < 1)
  {
    send_to_char("You have not learned this ability yet.\n\r",ch);
    return;
  }
  if (IS_SET(ch->newbits, NEW_MONKADAM))
  {
    REMOVE_BIT(ch->newbits, NEW_MONKADAM);
    send_to_char("Your hands resume their normal toughness.\n\r",ch);
    act("$n's hands resume their normal toughness.\n\r",ch,NULL,NULL,TO_ROOM);
    return;
  }
  if (!IS_SET(ch->newbits, NEW_MONKADAM))
  {
    SET_BIT(ch->newbits, NEW_MONKADAM);
    send_to_char("Your hands turn as hard as adamantium!\n\r",ch);
    act("$n's hands turn as hard as adamantium!\n\r",ch,NULL,NULL,TO_ROOM);
    return;
  }
}


void do_celestial( CHAR_DATA *ch, char *argument)
{
  CHAR_DATA *victim;
  char buf[MAX_STRING_LENGTH];
  char arg[MAX_INPUT_LENGTH];
  argument = one_argument(argument, arg);

  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if (ch->pcdata->powers[PMONK] < 10)
  {
    send_to_char("You must obtain level 10 in mantras to use Celestial Path.\n\r",ch);
    return;
  }
  if (ch->move < 2000)
  {
    stc("You do not have enough vitality to do that!\n\r",ch);
    return;
  }
  if (arg[0] == '\0')
  {
    send_to_char( "Open a celestial path to who?\n\r", ch );
    return;
  }
  if ( ( victim = get_char_world( ch, arg ) ) == NULL )
  {
    send_to_char( "They aren't here.\n\r", ch );
    return;
  }
  if( victim == ch )
  {
    stc ( "Not to yourself.\n\r",ch);
    return;
  }
  if( IS_SET(victim->in_room->room_flags, ROOM_ASTRAL))
  {
    stc( "You can't find it's room.\n\r",ch);
    return;
  }
  if( IS_SET(ch->in_room->room_flags, ROOM_ASTRAL))
  {
    stc( "Your room is not connected to the astral plane.\n\r",ch);
    return;
  }
  if (ch == victim)
  {
    send_to_char("But you're already at yourself!\n\r",ch);
    return;
  }
  if (victim->in_room->vnum == ch->in_room->vnum)
  {
    send_to_char("But you're already there!\n\r",ch);
    return;
  }

  char_from_room(ch);
  char_to_room(ch,victim->in_room);
  if (IS_NPC(victim))
  {
    sprintf(buf,"You concentrate and open a Celestial path to %s!\n\r",victim->short_descr);
    send_to_char(buf, ch);
  }
  if (!IS_NPC(victim))
  {
    sprintf(buf,"You concentrate and open a Celestial path to %s!\n\r",victim->name);
    send_to_char(buf, ch);
  }
  act("$n appears before you through a Celestial portal!\n\r",ch,NULL,NULL,TO_ROOM);
  do_look(ch, "auto");
  ch->move -= 2000;
  return;
}

void do_godseye( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch)) return;
  if ( !IS_CLASS(ch, CLASS_MONK) )
  {
    send_to_char("Huh?\n\r", ch);
    return;
  }
  if ( ch->pcdata->powers[PMONK] < 1 )
  {
    send_to_char("You have not learned the Eyes of God Mantra.\n\r", ch);
    return;
  }
  if ( IS_SET(ch->act, PLR_HOLYLIGHT) )
  {
    REMOVE_BIT(ch->act, PLR_HOLYLIGHT);
    send_to_char( "Your view shimmers into mortal vision.\n\r", ch );
  }
  else
  {
    send_to_char( "God answers your prayers and gives you his vision.\n\r", ch );
    SET_BIT(ch->act, PLR_HOLYLIGHT);
  }
  return;
}

void do_steelskin( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_MONK))
  {
    send_to_char("Huh?\n\r", ch);
    return;
  }
  if (ch->pcdata->powers[PMONK] < 6)
  {
    send_to_char("You have not learned the Steel of Skin Mantra.\n\r", ch);
    return;
  }
  if ( IS_SET(ch->newbits, NEW_MONKSKIN) )
  {
    REMOVE_BIT( ch->newbits, NEW_MONKSKIN );
    send_to_char( "Your steel shield disappears.\n\r", ch );
  }
  else
  {
    send_to_char( "You are surrounded by a steel shield\n\r", ch );
    SET_BIT(ch->newbits, NEW_MONKSKIN);
  }
  return;
}

void do_godsbless( CHAR_DATA *ch, char *argument )
{
  int sn;
  int level;
  int spelltype;

  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_MONK))
  {
    do_rand_typo(ch,"");
    return;
  }
  if ( IS_CLASS(ch, CLASS_MONK) && ch->pcdata->powers[PMONK] < 7 )
  {
    send_to_char("You have not learned the Almighty Favor Mantra.\n\r", ch);
    return;
  }
  if (ch->mana < 2500) 
  {
    send_to_char("You don't have enough mana.\n\r", ch );
    return;
  }
  if ( ( sn = skill_lookup( "godbless" ) ) < 0 ) return;
  spelltype = skill_table[sn].target;
  level = 500;
  (*skill_table[sn].spell_fun) ( sn, level, ch, ch );
  WAIT_STATE( ch, 12 );
  ch->mana = ch->mana - 2500;
  return;
}


void do_wrathofgod( CHAR_DATA *ch, char *argument )
{
  CHAR_DATA *victim;

  if (IS_NPC(ch)) return; 
  if (!IS_CLASS(ch, CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if ( IS_CLASS(ch, CLASS_MONK) && ch->pcdata->powers[PMONK] < 4 )
  {
    send_to_char("You have not learned to call on the wrath of god yet.\n\r", ch);
    return;
  }
  if (ch->fighting != NULL) victim = ch->fighting;
  else return;
  if (!IS_NPC(victim)) return;
  one_hit(ch,victim,gsn_wrathofgod,1);
  one_hit(ch,victim,gsn_wrathofgod,1);
  one_hit(ch,victim,gsn_wrathofgod,1);
  one_hit(ch,victim,gsn_wrathofgod,1);
  WAIT_STATE(ch,8);
  return;
}


void do_godsfavor( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch)) return; 
  if (!IS_CLASS(ch, CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if ( IS_CLASS(ch, CLASS_MONK) && ch->pcdata->powers[PMONK] < 8 )
  {
    send_to_char("You have not learned the Almighty's Favor Mantra.\n\r", ch);
    return;
  }
  if (ch->move < 1500)
  {
    send_to_char("You do not have the vitality to do that!\n\r",ch);
    return;
  }
  if (!IS_SET(ch->newbits, NEW_MONKFAVOR))
  {
    SET_BIT(ch->newbits, NEW_MONKFAVOR);
    send_to_char("God smiles upon you and you feel strengthened.\n\r",ch);
    act("$n is blessed by the Almighty.",ch,NULL,NULL,TO_ROOM);
    ch->move = ch->move - 1500;
    WAIT_STATE(ch, 4);
    return;
  }
  if (IS_SET(ch->newbits, NEW_MONKFAVOR))
  {
    REMOVE_BIT(ch->newbits, NEW_MONKFAVOR);
    send_to_char("You feel weaker as The Almighty's favor leaves you.\n\r",ch);
    act("$n no longer looks so holy.",ch,NULL,NULL,TO_ROOM);
    return;
  }
}

void do_darkblaze( CHAR_DATA *ch, char *argument )
{
  CHAR_DATA *victim;
  AFFECT_DATA af;  

  
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_MONK))
  {
    send_to_char("Huh?\n\r", ch);
    return;
  }
  if ( IS_CLASS(ch, CLASS_MONK) && ch->pcdata->powers[PMONK] < 8 )
  {
    send_to_char("You have not learned the Dark Blaze Mantra.\n\r", ch);
    return;
  }
  if (ch->fighting != NULL) victim = ch->fighting;
  else return;
  if (IS_SET(victim->act,PLR_HOLYLIGHT))
  {
    REMOVE_BIT(victim->act, PLR_HOLYLIGHT);
  }
  if (IS_SET(victim->affected_by, AFF_DETECT_HIDDEN))
    REMOVE_BIT(victim->affected_by, AFF_DETECT_HIDDEN);
  if (IS_SET(victim->affected_by, AFF_DETECT_INVIS))
    REMOVE_BIT(victim->affected_by, AFF_DETECT_INVIS);
  af.type      = skill_lookup("blindness");
  af.location  = APPLY_HITROLL;
  af.modifier  = -4; 
  af.duration  = 60;
  af.bitvector = AFF_BLIND;
  affect_to_char( victim, &af );
  send_to_char("Your hands blaze up, blinding your opponent.\n\r",ch);
  send_to_char("Your opponents hands flashes with a blinding light.\n\r",victim);
  WAIT_STATE(ch,18);
  return;
} 


void do_godsheal( CHAR_DATA *ch, char *argument )
{
  if (IS_NPC(ch)) return;
  if( !IS_CLASS(ch, CLASS_MONK) )
  {
    stc( "Huh?\n\r",ch);
    return;
  }
  if ( IS_CLASS(ch, CLASS_MONK) && ch->pcdata->powers[PMONK] < 12 )
  {
    send_to_char("You need to obtain heal to use heal.\n\r",ch);
    return;
  }
  if (ch->mana < 300)
  {
    send_to_char("You don't have enough energy to use heal.\n\r",ch);
    return;
  }
  if (ch->fighting != NULL)
  {
    send_to_char("You are surrounded in a glowing halo of energy.\n\r",ch);
    act("$n is surrounded by a glowing halo, and looks very relaxed.\n\r",ch,NULL,NULL,TO_ROOM);
    ch->hit += 150;
    ch->mana -= 400;
    WAIT_STATE(ch,12);
    return;
  }
  if (ch->fighting == NULL)
  {
    send_to_char("You feel a mighty force lay his hands on you.\n\r",ch);
    act("$n is surrounded by a glowing halo, and looks very relaxed.\n\r",ch,NULL,NULL,TO_ROOM);
    ch->hit += 500;
    ch->mana -= 400;
    WAIT_STATE(ch,8);
    return;
  }
}

void do_ghold( CHAR_DATA *ch,char *argument )
{
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch,CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if ( IS_CLASS(ch, CLASS_MONK) && ch->pcdata->powers[PMONK] < 13 )
  {
    send_to_char("You need Mantra 13 to use gods hold.\n\r",ch);
    return;
  }
  if (!IS_SET(ch->newbits, NEW_JAWLOCK))
  {
    send_to_char("God joins you at your side to hold your foe.\n\r",ch);
    SET_BIT(ch->newbits, NEW_JAWLOCK);
    return;
  }
  else if (IS_SET(ch->newbits, NEW_JAWLOCK))
  { 
    send_to_char("God leaves your side.\n\r",ch);
    REMOVE_BIT(ch->newbits,NEW_JAWLOCK);
    return;
  }
}

void do_shinkick( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    bool foot = TRUE;
    int dam;

  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch,CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if ( ( victim = ch->fighting ) == NULL )
  {
    send_to_char( "You aren't fighting anyone.\n\r", ch );
    return;
  }

  WAIT_STATE(ch, 12);
  dam = number_range(1,6);
  dam = find_dam( ch, victim, dam, foot );

  if ( ch->monkcrap == 0 )
  {
    stc("Your aura glows light blue for a moment.\n\r",ch);
    act("$n's aura glows a light blue for a moment.",ch,NULL,victim,TO_VICT);
    SET_BIT(ch->monkcrap, COMB_SHIN);
  }
  else if ( ch->monkcrap > 0 )
  {
    stc("Your aura fades away.\n\r",ch);
    act("$n's aura fades away.",ch,NULL,victim,TO_VICT);
    ch->monkcrap = 0;
  }
  act("You deliver a powerful blow to $N's shin.",ch,NULL,victim,TO_CHAR);
  act("$n delivers a powerful blow to your shin.",ch,NULL,victim,TO_VICT);
  act("$n delivers a powerful blow to $N's shin.",ch,NULL,victim,TO_NOTVICT);
  damage( ch, victim, dam, gsn_shinkick );
  if ( number_range(1, (7 - ch->chi[CURRENT]) ) == 1 )
  victim->position = POS_STUNNED;
  return;
}

void do_palmstrike( CHAR_DATA *ch, char *argument )
{
  char arg [MAX_INPUT_LENGTH];
  CHAR_DATA *victim;
  int dam;
  bool foot = FALSE;

  one_argument(argument,arg);

  if ( IS_NPC(ch) ) return;
  if (!IS_CLASS(ch,CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if ( ( victim = get_char_room( ch, arg ) ) == NULL )
  {
    send_to_char( "You aren't fighting anyone.\n\r", ch );
    return;
  }
  if ( ch == victim )
  {
    send_to_char( "You cannot palm strike yourself!\n\r", ch );
    return;
  }

  if (is_safe(ch,victim)) return;

  if ( victim->position < POS_FIGHTING )
  {
    send_to_char( "You can only palm strike someone who is standing.\n\r", ch );
    return;
  }

  act("You slam your palm into $N's chest.",ch,NULL,victim,TO_CHAR);
  act("$n slams $s palm into your chest.",ch,NULL,victim,TO_VICT);
  act("$n slams $s palm into $N's chest.",ch,NULL,victim,TO_NOTVICT);

  WAIT_STATE(ch, 11);
  dam = number_range(1,4);

  find_dam( ch, victim, dam, foot );
  dam /= 2;

  damage(ch, victim, dam, gsn_palmstrike);
  if (victim == NULL || victim->position == POS_DEAD || dam < 1) return;
  if (victim->position == POS_FIGHTING) stop_fighting(victim,TRUE);
  act("You fall to the ground stunned!",victim,NULL,NULL,TO_CHAR);
  act("$n falls to the ground stunned!",victim,NULL,NULL,TO_ROOM);
  victim->position = POS_STUNNED;
  return;
}

void do_knee( CHAR_DATA *ch, char *argument )
{
  CHAR_DATA *victim;
  bool foot = TRUE;
  int dam;

  if (!IS_CLASS(ch,CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if ( !IS_FS(ch, TECH_KNEE) )
  {
    stc("You haven't learned that technique.\n\r",ch);
    return;
  }

  if ( ( victim = ch->fighting ) == NULL )
  {
    send_to_char( "You aren't fighting anyone.\n\r", ch );
    return;
  }

  WAIT_STATE(ch, 11);
  dam = number_range(1,6);
  dam = find_dam( ch, victim, dam, foot );

  if ( IS_SET(ch->monkcrap, COMB_SHIN) && !IS_SET(ch->monkcrap, COMB_KNEE ) )
  {
    stc("Your aura glows dark blue.\n\r",ch);
    act("$n's aura glows dark blue.",ch,NULL,victim,TO_VICT);
    SET_BIT(ch->monkcrap, COMB_KNEE);
  }
  else if ( ch->monkcrap > 0 )
  {
    stc("Your aura slowly fades away.\n\r",ch);
    act("$n's aura slowly fades away.\n\r",ch,NULL,victim,TO_VICT);
    ch->monkcrap = 0;
  }
  act("You leap up and slam your knee into $N's chin.",ch,NULL,victim,TO_CHAR);
  act("$n leaps up and slams $s knee into your chin.",ch,NULL,victim,TO_VICT);
  act("$n leaps up and slams $s knee into $N's chin.",ch,NULL,victim,TO_NOTVICT);
  damage( ch, victim, dam, gsn_knee );
  return;
}

void do_reverse( CHAR_DATA *ch, char *argument )
{
  CHAR_DATA *victim;
  bool foot = TRUE;
  int dam;
  int move = 0;

  if (!IS_CLASS(ch,CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if ( !IS_FS(ch, TECH_SWEEP) )
  {
    stc("You haven't learned that technique.\n\r",ch);
    return;
  }
  if ( ( victim = ch->fighting ) == NULL )
  {
    send_to_char( "You aren't fighting anyone.\n\r", ch );
    return;
  }
  WAIT_STATE( ch, skill_table[gsn_monksweep].beats );
  if ( ch->monkcrap == 0 )
  {
    stc("Your aura glows a light blue for a moment.\n\r",ch);
    SET_BIT(ch->monkcrap, COMB_REV1);
  }
  else if ( IS_SET(ch->monkcrap, COMB_REV1) && IS_SET(ch->monkcrap, COMB_SWEEP) )
  {
    act("You spin around and kick $N viciously in the head.",ch,NULL,victim,TO_CHAR);
    act("You place your hands on $N's head.",ch,NULL,victim,TO_CHAR);
    act("You feel revitalized.",ch,NULL,victim,TO_CHAR);
    act("$n's choyoken **- PULVERISES -** you!",ch,NULL,victim,TO_VICT);
    act("$n's choyoken **- PULVERISES -** $N!",ch,NULL,victim,TO_NOTVICT);
    move = (victim->move / 2);
    victim->move -= move;
    ch->move += UMIN(10000,move);
    ch->hit += UMIN(10000,move);
    ch->mana += UMIN(10000,move);
    ch->monkcrap = 0;
    return;
  }

  dam = number_range(1,4);
  dam = find_dam( ch, victim, dam, foot );

  act("You crouch down and sweep $N's legs out from under $M.",ch,NULL,victim,TO_CHAR);
  act("$n crouches down and sweeps your legs out from under you",ch,NULL,victim,TO_VICT);
  act("$n crouches down and sweeps $N's legs out from under $M",ch,NULL,victim,TO_NOTVICT);
  damage( ch, victim, dam, gsn_monksweep );
  return;
}

void do_sweep( CHAR_DATA *ch, char *argument )
{
  CHAR_DATA *victim;
  bool foot = TRUE;
  int dam;

  if (!IS_CLASS(ch,CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if ( !IS_FS(ch, TECH_SWEEP) )
  {
    stc("You haven't learned that technique.\n\r",ch);
    return;
  }
  if ( ( victim = ch->fighting ) == NULL )
  {
    send_to_char( "You aren't fighting anyone.\n\r", ch );
    return;
  }

  WAIT_STATE(ch, 11);
  dam = number_range(1,4);
  dam = find_dam( ch, victim, dam, foot );

  if ( IS_SET(ch->monkcrap, COMB_REV1) )
  {
    stc("Your aura glows a light blue for a moment.\n\r",ch);
    SET_BIT(ch->monkcrap, COMB_SWEEP);
  }
  act("You crouch down and sweep $N's legs out from under $M.",ch,NULL,victim,TO_CHAR);
  act("$n crouches down and sweeps your legs out from under you",ch,NULL,victim,TO_VICT);
  act("$n crouches down and sweeps $N's legs out from under $M",ch,NULL,victim,TO_NOTVICT);
  damage( ch, victim, dam, gsn_monksweep );
  return;
}

void do_elbow( CHAR_DATA *ch, char *argument )
{
  CHAR_DATA *victim;
  bool foot = FALSE;
  int dam;

  if (!IS_CLASS(ch,CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if ( !IS_FS(ch, TECH_ELBOW) )
  {
    stc("You haven't learned that technique.\n\r",ch);
    return;
  }

  if ( ( victim = ch->fighting ) == NULL )
  {
    send_to_char( "You aren't fighting anyone.\n\r", ch );
    return;
  }

  WAIT_STATE(ch, 11);
  dam = number_range(1,6);
  dam = find_dam( ch, victim, dam, foot );
  act("You ram your elbow into $N's face.",ch,NULL,victim,TO_CHAR);
  act("$n rams $s elbow into your face.",ch,NULL,victim,TO_VICT);
  act("$n rams $s elbow into $N's face.",ch,NULL,victim,TO_NOTVICT);
  damage( ch, victim, dam, gsn_elbow );
  return;
}

void do_thrustkick( CHAR_DATA *ch, char *argument )
{
  CHAR_DATA *victim;
  bool foot = TRUE;
  int dam;

  if (!IS_CLASS(ch,CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if ( !IS_FS(ch, TECH_THRUST) )
  {
    stc("You haven't learned that technique.\n\r",ch);
    return;
  }

  if ( ( victim = ch->fighting ) == NULL )
  {
    send_to_char( "You aren't fighting anyone.\n\r", ch );
    return;
  }

  WAIT_STATE(ch, 11);
  dam = number_range(1,5);
  dam = find_dam( ch, victim, dam, foot );

  if ( ch->monkcrap == 0 && !IS_SET(ch->monkcrap, COMB_THRUST1) )
  {
    stc("Your aura glows dark blue for a moment.\n\r",ch);
    act("$n's aura glows dark blue for a moment.",ch,NULL,victim,TO_VICT);
    act("$n's aura glows dark blue for a moment.",ch,NULL,victim,TO_NOTVICT);
    SET_BIT(ch->monkcrap, COMB_THRUST1);
  }
  else if ( IS_SET(ch->monkcrap, COMB_THRUST1) && !IS_SET(ch->monkcrap,COMB_THRUST2) )
  {
    stc("Your aura flashes bright blue.\n\r",ch);
    act("$n's aura flashes bright blue.",ch,NULL,victim,TO_VICT);
    act("$n's aura flashes bright blue.",ch,NULL,victim,TO_NOTVICT);
    SET_BIT(ch->monkcrap, COMB_THRUST2);
  }
  else if ( ch->monkcrap != 0 )
  {
    stc("Your aura fades.\n\r",ch);
    act("$n's aura fades.",ch,NULL,victim,TO_VICT);
    act("$n's aura fades.",ch,NULL,victim,TO_NOTVICT);
    ch->monkcrap = 0;
  }

  act("You deliver a thrust kick to $N's chest.",ch,NULL,victim,TO_CHAR);
  act("$n delivers a powerful thrust kick to your chest.",ch,NULL,victim,TO_VICT);
  act("$n delivers a powerful thrust kick to $N's chest.",ch,NULL,victim,TO_NOTVICT);
  damage( ch, victim, dam, gsn_thrustkick );
  return;
}

void do_spinkick( CHAR_DATA *ch, char *argument )
{
  CHAR_DATA *victim;
  bool foot = TRUE;
  int dam;

  if (!IS_CLASS(ch,CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if ( !IS_FS(ch, TECH_SPIN) )
  {
    stc("You haven't learned that technique.\n\r",ch);
    return;
  }

  if ( ( victim = ch->fighting ) == NULL )
  {
    send_to_char( "You aren't fighting anyone.\n\r", ch );
    return;
  }

  WAIT_STATE(ch, 11);
  dam = number_range(1,4);

  dam = find_dam( ch, victim, dam, foot );

  if ( IS_COMB(ch, COMB_THRUST1) && IS_COMB(ch, COMB_THRUST2) )
  {
    act("Your aura pulsates and channels energy into your attack.",ch,NULL,NULL,TO_CHAR);
    act("$n's aura pulsates and channels energy into $s attack.",ch,NULL,victim,TO_VICT);
    act("$n's aura pulsates and channels energy into $s attack.",ch,NULL,victim,TO_NOTVICT);
    ch->monkcrap = 0;
    dam /= 1.2;
    damage( ch, victim, dam, gsn_lightningkick );
    if ( ch->chi[CURRENT] > 1 )
    {
      dam /= 1.2;
      damage( ch, victim, dam, gsn_lightningkick );
    }
    if ( ch->chi[CURRENT] > 2 )
    {
      dam /= 1.2;
      damage( ch, victim, dam, gsn_lightningkick );
    }
    if ( ch->chi[CURRENT] > 3 )
    {
      dam /= 1.2;
      damage( ch, victim, dam, gsn_lightningkick );
    }
    if ( ch->chi[CURRENT] > 4 )
    {
      dam /= 1.2;
      damage( ch, victim, dam, gsn_lightningkick );
    }
    if ( ch->chi[CURRENT] > 5 )
    {
      dam /= 1.2;
      damage( ch, victim, dam, gsn_lightningkick );
    }
    return;
  }
  else if ( IS_SET(ch->monkcrap, COMB_SHIN) && IS_SET(ch->monkcrap, COMB_KNEE ) )
  {
    CHAR_DATA *vch;
    CHAR_DATA *vch_next;
    CHAR_DATA *mount;
    int number_hit = 0;

    ch->monkcrap = 0;
    stc("You spin around and around, going berserk.\n\r",ch);
    act("$n body speeds up, and $e spins around rapidly.",ch,NULL,victim,TO_ROOM);
    for ( vch = char_list; vch != NULL; vch = vch_next )
    {
      vch_next  = vch->next;
      if (number_hit > (ch->chi[CURRENT] + 1)) continue;
      if ( vch->in_room == NULL )
        continue;
      if ( !IS_NPC(vch) && vch->pcdata->chobj != NULL )
        continue;
      if ( ch == vch )
        continue;
      if ( vch->in_room == ch->in_room )
      {
        if ( ( mount = ch->mount ) != NULL ) {if ( mount == vch ) continue;}
        if (can_see(ch,vch))
        {
          one_hit( ch, vch, gsn_tornadokick, 0 );
          number_hit++;
        }
      }
    }
    return;
  }
  act("You spin around and deliver a blow to $N's head.",ch,NULL,victim,TO_CHAR);
  act("$n spins around and delivers a blow to your head.",ch,NULL,victim,TO_VICT);
  act("$n spins around and delivers a devastating blow to $N's head.",ch,NULL,victim,TO_NOTVICT);
  damage( ch, victim, dam, gsn_spinkick );
  return;
}

void do_backfist( CHAR_DATA *ch, char *argument )
{
  CHAR_DATA *victim;
  bool foot = FALSE;
  int dam;

  if (!IS_CLASS(ch,CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
  if ( !IS_FS(ch, TECH_BACK) )
  {
    stc("You haven't learned that technique.\n\r",ch);
    return;
  }
  if ( ( victim = ch->fighting ) == NULL )
  {
    send_to_char( "You aren't fighting anyone.\n\r", ch );
    return;
  }

  WAIT_STATE(ch, 11);
  dam = number_range(1,5);
  dam = find_dam( ch, victim, dam, foot );

  act("You spin around and slam $N's jaw with your fist.",ch,NULL,victim,TO_CHAR);
  act("$n spins around and slams you in the jaw with $s fist.",ch,NULL,victim,TO_VICT);
  act("$n spins around and slams $N in the jaw with $s fist.",ch,NULL,victim,TO_NOTVICT);
  damage( ch, victim, dam, gsn_backfist );
  return;
}

void do_learn( CHAR_DATA *ch, char *argument )
{
  char arg[MAX_INPUT_LENGTH];
  char arg1[MAX_INPUT_LENGTH];
  char buf[MAX_STRING_LENGTH];
  char lin[MAX_STRING_LENGTH];
  int inpart = 0;
  int cost = 50000;

  argument = one_argument( argument, arg1 );
  argument = one_argument( argument, arg );

  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_MONK))
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }


  sprintf(lin,"===========================================================================\n\r");
  if ( arg[0] == '\0' )
  {
    stc(" Syntax: Learn <fight|techniques|abilities|chi> <power|chi>\n\r",ch);
    stc("=============================|Fight Styles|==============================\n\r",ch);
    sprintf(buf,"       Trip     [%s] Kick      [%s] Bash     [%s] Elbow    [%s] Knee     [%s]   \n\r",
      IS_FS(ch, FS_TRIP) ? "*" : " ",
      IS_FS(ch, FS_KICK) ? "*" : " ",
      IS_FS(ch, FS_BASH) ? "*" : " ",
      IS_FS(ch, FS_ELBOW) ? "*" : " ",
      IS_FS(ch, FS_KNEE) ? "*" : " ");
    stc(buf,ch);
    sprintf(buf,"       Disarm   [%s] Bite      [%s] Dirt     [%s] Grapple  [%s] Punch    [%s]   \n\r",
      IS_FS(ch, FS_DISARM) ? "*" : " ",
      IS_FS(ch, FS_BITE) ? "*" : " ",
      IS_FS(ch, FS_DIRT) ? "*" : " ",
      IS_FS(ch, FS_GRAPPLE) ? "*" : " ",
      IS_FS(ch, FS_PUNCH) ? "*" : " ");
    stc(buf,ch);
    sprintf(buf,"       Rip      [%s] Stamp     [%s] Backfist [%s] Jumpkick [%s] Spinkick [%s]   \n\r",
      IS_FS(ch, FS_RIP) ? "*" : " ",
      IS_FS(ch, FS_STAMP) ? "*" : " ",
      IS_FS(ch, FS_BACKFIST) ? "*" : " ",
      IS_FS(ch, FS_JUMPKICK) ? "*" : " ",
      IS_FS(ch, FS_SPINKICK) ? "*" : " ");
    stc(buf,ch);
    sprintf(buf,"       Sweep    [%s] Charge    [%s] Hurl     [%s] Gouge    [%s] Headbutt [%s]   \n\r",
      IS_FS(ch, FS_SWEEP) ? "*" : " ",
      IS_FS(ch, FS_CHARGE) ? "*" : " ",
      IS_FS(ch, FS_HURL) ? "*" : " ",
      IS_FS(ch, FS_GOUGE) ? "*" : " ",
      IS_FS(ch, FS_HEADBUTT) ? "*" : " ");
    stc(buf,ch);
    stc("===========================================================================\n\r",ch);
    stc("                                   Techniques                                  \n\r",ch);
    stc(lin,ch);
    sprintf(buf,"    Thrust Kick [%s]   Spin Kick   [%s]   Backfist    [%s]   Palm Strike [%s]   \n\r",
      IS_FS(ch, TECH_THRUST) ? "*" : " ",
      IS_FS(ch, TECH_SPIN)   ? "*" : " ",
      IS_FS(ch, TECH_BACK)   ? "*" : " ",
      IS_FS(ch, TECH_PALM)   ? "*" : " ");
    stc(buf,ch);
    sprintf(buf,"    Elbow       [%s]   Sweep       [%s]   Shin Kick   [%s]   Knee        [%s]   \n\r",
      IS_FS(ch, TECH_ELBOW)  ? "*" : " ",
      IS_FS(ch, TECH_SWEEP)  ? "*" : " ",
      IS_FS(ch, TECH_SHIN)   ? "*" : " ",
      IS_FS(ch, TECH_KNEE)   ? "*" : " ");
    stc(buf,ch);
    stc(lin,ch);
    stc("                                   Abilities                                   \n\r",ch);
    stc(lin,ch);
    sprintf(buf,"                 Awareness [%s%s%s%s]               Body     [%s%s%s%s]\n\r",
      ch->monkab[AWARE] > 0 ? "*" : " ",
      ch->monkab[AWARE] > 1 ? "*" : " ",
      ch->monkab[AWARE] > 2 ? "*" : " ",
      ch->monkab[AWARE] > 3 ? "*" : " ",
      ch->monkab[BODY]  > 0 ? "*" : " ",
      ch->monkab[BODY]  > 1 ? "*" : " ",
      ch->monkab[BODY]  > 2 ? "*" : " ",
      ch->monkab[BODY]  > 3 ? "*" : " ");
    stc(buf, ch);
    sprintf(buf,"     Combat   [%s%s%s%s]              Spirit    [%s%s%s%s]\n\r",
      ch->monkab[COMBAT] > 0 ? "*" : " ",
      ch->monkab[COMBAT] > 1 ? "*" : " ",
      ch->monkab[COMBAT] > 2 ? "*" : " ",
      ch->monkab[COMBAT] > 3 ? "*" : " ",
      ch->monkab[SPIRIT] > 0 ? "*" : " ",
      ch->monkab[SPIRIT] > 1 ? "*" : " ",
      ch->monkab[SPIRIT] > 2 ? "*" : " ",
      ch->monkab[SPIRIT] > 3 ? "*" : " ");
    stc(buf, ch);
    stc(lin,ch);
    stc("                                      Chi\n\r",ch);
    stc(lin,ch);
    sprintf(buf,"                 You have attained a level %d mastery of your Ch'i.\n\r",ch->chi[MAXIMUM]);
    stc(buf,ch);
    if ( ch->chi[CURRENT] > 0 )
    {
      sprintf(buf,"                     Your ch'i is currently active at level %d\n\r",ch->chi[CURRENT]);
      stc(buf,ch);
    }
    else stc("         You are currently not focusing your ch'i\n\r",ch);
    stc(lin,ch);
    return;
  }
  if ( !str_cmp(arg1, "fight" ) )
  {
    if (!str_cmp(arg,"trip"))
    inpart = FS_TRIP;
    else if (!str_cmp(arg,"kick")) inpart = FS_KICK;
    else if (!str_cmp(arg,"bash")) inpart = FS_BASH;
    else if (!str_cmp(arg,"elbow")) inpart = FS_ELBOW;
    else if (!str_cmp(arg,"knee")) inpart = FS_KNEE;
    else if (!str_cmp(arg,"headbutt")) inpart = FS_HEADBUTT;
    else if (!str_cmp(arg,"disarm")) inpart = FS_DISARM;
    else if (!str_cmp(arg,"bite")) inpart = FS_BITE;
    else if (!str_cmp(arg,"dirt")) inpart = FS_DIRT;
    else if (!str_cmp(arg,"grapple")) inpart = FS_GRAPPLE;
    else if (!str_cmp(arg,"punch"))inpart = FS_PUNCH;
    else if (!str_cmp(arg,"gouge"))inpart = FS_GOUGE;
    else if (!str_cmp(arg,"rip")) inpart = FS_RIP;
    else if (!str_cmp(arg,"stamp")) inpart = FS_STAMP;
    else if (!str_cmp(arg,"backfist")) inpart = FS_BACKFIST;
    else if (!str_cmp(arg,"jumpkick")) inpart = FS_JUMPKICK;
    else if (!str_cmp(arg,"spinkick")) inpart = FS_SPINKICK;
    else if (!str_cmp(arg,"hurl")) inpart = FS_HURL;
    else if (!str_cmp(arg,"sweep")) inpart = FS_SWEEP;
    else if (!str_cmp(arg,"charge")) inpart = FS_CHARGE;
    else
    {
      do_learn(ch,"");
      return;
    }
  }
  else if ( !strcmp(arg1, "techniques") )
  {
    if (!str_cmp(arg,"knee")) {inpart = TECH_KNEE; cost = 200000;}
    else if (!str_cmp(arg,"spin")) {inpart = TECH_SPIN; cost = 200000;}
    else if (!str_cmp(arg,"backfist")) {inpart = TECH_BACK; cost = 200000;}
    else if (!str_cmp(arg,"elbow")) {inpart = TECH_ELBOW; cost = 200000;}
    else if (!str_cmp(arg,"palm")) {inpart = TECH_PALM; cost = 200000;}
    else if (!str_cmp(arg,"shin")) {inpart = TECH_SHIN; cost = 200000;}
    else if (!str_cmp(arg,"sweep")){inpart = TECH_SWEEP; cost = 200000;}
    else if (!str_cmp(arg, "thrust")) {inpart = TECH_THRUST; cost = 200000;}
    else
    {
      do_learn(ch,"");
      return;
    }
  }
  else if (!str_cmp(arg1, "abilities"))
  {
    if (!str_cmp( arg, "body" )) {inpart = BODY; cost = 500000;}
    else if (!str_cmp( arg, "combat")) {inpart = COMBAT; cost = 500000;}
    else if (!str_cmp( arg, "spirit")) {inpart = SPIRIT; cost = 500000;}
    else if (!str_cmp( arg, "awareness")) {inpart = AWARE; cost = 500000;}
    else
    {
      do_learn(ch,"");
      return;
    }
  }
  else if ( !str_cmp(arg1, "chi" ) )
  {
    inpart = MAXIMUM;
    cost = (ch->chi[inpart]+1) * 1000000;
  }
  else
  {
    do_learn(ch,"");
    return;
  }
  if ( !str_cmp(arg1, "abilities" ) )
  {
    if (ch->monkab[inpart] >= 4)
    {
      stc("You have already learned all you can in this ability.\n\r",ch);
      return;
    }
    if ( ch->exp < cost )
    {
      send_to_char("You do not have enough experience to learn that power.\n\r",ch);
      return;
    }
    ch->monkab[inpart]++;
    ch->exp -= cost;
    send_to_char("Ok.\n\r",ch);
    save_char_obj(ch);
    return;
  }
  else if ( !str_cmp( arg1, "chi" ) )
  {
    if ( ch->chi[MAXIMUM] >= 6 )
    {
      stc("You have already mastered your ch'i.\n\r",ch);
      return;
    }
    if ( ch->exp < cost)
    {
      sprintf(buf,"You need %d experience to gain the next level of mastery of your ch'i.",cost);
      return;
    }
    ch->exp -= cost;
    ch->chi[MAXIMUM]++;
    save_char_obj(ch);
    stc("You gain more control over your ch'i.\n\r",ch);
    return;
  }
  else
  {
    if (IS_FS(ch, inpart))
    {
      send_to_char("You have already got that power.\n\r",ch);
      return;
    }
    if ( ch->exp < cost )
    {
      send_to_char("You do not have enough experience to learn that power.\n\r",ch);
      return;
    }
    SET_BIT(ch->monkstuff, inpart);
    ch->exp -= cost;
    send_to_char("Ok.\n\r",ch);
    save_char_obj(ch);
    return;
  }
}

