/***********************************
 *  ShadowGames: Unisol Class File *
 *  By Wolfman, (C) 2001           *
 ***********************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"
#include "player.h"
#include "unisol.h" 

void do_universal( CHAR_DATA *ch, char *argument ) 
{
    char arg1[MAX_INPUT_LENGTH];
    char arg2[MAX_INPUT_LENGTH];
    char buf[MAX_STRING_LENGTH];

    argument = one_argument( argument, arg1 );
    argument = one_argument( argument, arg2 );

    if (IS_NPC(ch)) return;

    if (!IS_CLASS(ch, CLASS_UNISOL))
    {
	send_to_char("Huh?\n\r",ch);
	return;
    }

    if (arg1[0] == '\0' && arg2[0] == '\0')
    {
	sprintf(buf,"Abilities: Stealth (%d), Combat (%d), Armorment (%d).\n\r",
	ch->pcdata->powers[UNIPOWER_STEALTH], ch->pcdata->powers[UNIPOWER_COMBAT],
	ch->pcdata->powers[UNIPOWER_ARMORMENT]);
	send_to_char(buf,ch);
	return;
    }
    if (arg2[0] == '\0')
    {
	if (!str_cmp(arg1,"stealth"))
	{
	    send_to_char("Stealth - All the abilities for gaining an advantage over your target.\n\r\n\r",ch);
	    if (ch->pcdata->powers[UNIPOWER_STEALTH] < 1) 
		send_to_char("You don't have any Stealth abilities!\n\r",ch);
	    if (ch->pcdata->powers[UNIPOWER_STEALTH] > 0) 
		send_to_char("Blend - Hide from enemies.\n\r",ch);
	    if (ch->pcdata->powers[UNIPOWER_STEALTH] > 1) 
		send_to_char("Binoculars - See everything.\n\r",ch);
	    if (ch->pcdata->powers[UNIPOWER_STEALTH] > 2) 
		send_to_char("Commando -Totally disappear from sight.\n\r",ch);
	    if (ch->pcdata->powers[UNIPOWER_STEALTH] > 3) 
		send_to_char("Tracker -Track your opponent down with ease.\n\r",ch);
	    return;
	}
	else if (!str_cmp(arg1,"combat"))
	{
	    send_to_char("Combat - The Abilities that Prepare you for battle.\n\r\n\r",ch);
	    if (ch->pcdata->powers[UNIPOWER_COMBAT] < 1) 
		send_to_char("You have no combat abilities.\n\r",ch);
	    if (ch->pcdata->powers[UNIPOWER_COMBAT] > 0) 
		send_to_char("Retreat- Escape from an enemy during combat.\n\r",ch);
	    if (ch->pcdata->powers[UNIPOWER_COMBAT] > 1) 
		send_to_char("Stungrenade -Stun your opponent!\n\r",ch);
	    if (ch->pcdata->powers[UNIPOWER_COMBAT] > 2) 
		send_to_char("Landmine -Set up a landmine + blow 'em up!\n\r",ch);
	    if (ch->pcdata->powers[UNIPOWER_COMBAT] > 3) 
		send_to_char("Mortarfire -Shoot and destroy your target!\n\r",ch);
		if (ch->pcdata->powers[UNIPOWER_COMBAT] > 4)
		send_to_char("Smash -Smash into 'em during combat!\n\r", ch);
	    if (ch->pcdata->powers[UNIPOWER_COMBAT] > 5)
		send_to_char("Forearm -Bash 'em with a forearm in combat.\n\r",ch );
	    return;
	}
	else if (!str_cmp(arg1,"armorment"))
	{
	    send_to_char("Armorment - The Abilities that aid you in surviving a fight.\n\r\n\r",ch);
	    if (ch->pcdata->powers[UNIPOWER_ARMORMENT] < 1) 
		send_to_char("You have no Armorment skills!\n\r",ch);
	    if (ch->pcdata->powers[UNIPOWER_ARMORMENT] > 0) 
		send_to_char("Bulletproof -Absorb less damage.\n\r",ch);
	    if (ch->pcdata->powers[UNIPOWER_ARMORMENT] > 1) 
		send_to_char("Cooldown -Heal your wounds quickly.\n\r",ch);
	    if (ch->pcdata->powers[UNIPOWER_ARMORMENT] > 2) 
		send_to_char("Coldpower -Turbo protection from damage.\n\r",ch);

	    return;
	}
	sprintf(buf,"Abilities: Stealth (%d), Combat (%d), Armorment (%d).\n\r",
	ch->pcdata->powers[UNIPOWER_STEALTH], ch->pcdata->powers[UNIPOWER_COMBAT],
	ch->pcdata->powers[UNIPOWER_ARMORMENT]);
	send_to_char(buf,ch);
	return;
    }
    if (!str_cmp(arg2,"improve"))
    {
	int improve;
	int cost;
	int max;

	     if (!str_cmp(arg1,"stealth"   )) {improve = UNIPOWER_STEALTH; max=6;}
	else if (!str_cmp(arg1,"combat"   )) {improve = UNIPOWER_COMBAT; max=6;}
	else if (!str_cmp(arg1,"armorment"   )) {improve = UNIPOWER_ARMORMENT; max=6;}
	else
	{
	    send_to_char("Abilities: Stealth, Combat, Armorment.\n\r",ch);
	    return;
	}							
	cost = (ch->pcdata->powers[improve]+1) * 10;
	arg1[0] = UPPER(arg1[0]);
	if ( ch->pcdata->powers[improve] >= max )
	{
	    sprintf(buf,"The 5-Star Generals have declared that you have completed your training in the %s abilities!\n\r", arg1);
	    send_to_char(buf,ch);
	    return;
	}
	if ( cost > ch->practice )
	{
	    sprintf(buf,"It costs you %d primal to improve your %s ability.\n\r", cost, arg1);
	    send_to_char(buf,ch);
	    return;
	}
	ch->pcdata->powers[improve] += 1;
	ch->practice -= cost;
	sprintf(buf,"Your training of the %s ability has paid off, and you rise to the next level.\n\r", arg1);
	send_to_char(buf,ch);
    }
    else send_to_char("To improve an ability, type: Universal <ability type> improve.\n\r",ch);
	return;
}

void do_tracker( CHAR_DATA *ch, char *argument)
{
  CHAR_DATA *victim;
  char arg[MAX_INPUT_LENGTH];
    
  if ( IS_NPC(ch) )
    return;

  argument = one_argument (argument, arg);

  if (!IS_CLASS(ch, CLASS_UNISOL) )
  {
    send_to_char("Huh?\n\r",ch);
    return;
  }
	
	if (IS_CLASS(ch, CLASS_UNISOL) && ch->pcdata->powers[UNIPOWER_STEALTH] < 3 )
	{
	  send_to_char("You have not yet learned how to blend into the background.\n\r", ch);
	  return;
	}
  if ( arg[0] == '\0' )
  {
    send_to_char( "Track to who?\n\r", ch );
    return;
  }

  if ( ( victim = get_char_world( ch, arg ) ) == NULL )
  {
    send_to_char( "You cannot find them.\n\r", ch );
    return;
  }
    
  if( ch->move < 1000) 
  {
    stc( "You don't have enough movement points to track to them.\n\r",ch);
    return;
  }

  if( IS_SET(victim->in_room->room_flags, ROOM_ASTRAL))
  { 
    stc( "You can't find the room they are in.\n\r",ch);
    return; 
  } 
  
  if( IS_SET(ch->in_room->room_flags, ROOM_ASTRAL))
  {
    stc( "For some reason, you are unable to go there.\n\r",ch);
    return;
  }

  if (ch == victim)
  {
    send_to_char("But you're already at yourself!\n\r",ch);
    return;
  }
    
  if ( room_is_private(victim->in_room ) )
  {
    send_to_char( "That room is private right now.\n\r", ch );
    return;
  }
  if ( !IS_NPC(victim) && !IS_IMMUNE(victim, IMM_SUMMON) )
  { 
    send_to_char( "They are hiding from you.\n\r", ch );
    return;
  }
  if (victim->in_room == ch->in_room)
  {
    send_to_char("But you're already there!\n\r",ch);
    return;
  }

  act("You pick up the trail of $N, and quickly find them.", ch, NULL, victim, TO_CHAR);
  act("$n walks up from behind.", ch, NULL, victim, TO_ROOM);
  char_from_room(ch);
  char_to_room(ch,victim->in_room);
  ch->move -= 1000;
  act("$n walks out of nowhere behind $N.", ch, NULL, victim, TO_NOTVICT);
  act("$n walks out of nowhere from behind.", ch, NULL, victim, TO_VICT);
  do_look(ch,"auto");
  return;
}

void do_blend( CHAR_DATA *ch, char *argument )
{
    if (IS_NPC(ch)) return;
	
	if (!IS_CLASS(ch, CLASS_UNISOL) )
	{
		send_to_char("Huh?\n\r", ch);
		return;
	}
	
	if (IS_CLASS(ch, CLASS_UNISOL) && ch->pcdata->powers[UNIPOWER_STEALTH] < 0 )
	{
	  send_to_char("You have not yet learned how to blend into the background.\n\r", ch);
	  return;
	}
	
	if (ch->move < 500)
	{
		send_to_char("You don't have 500 move to activate your power.\n\r", ch);
		return;
	} 

        if (ch->fight_timer >0) {
          send_to_char("Not until your fight timer expires.\n\r", ch );
          return;
        }

    if ( IS_SET(ch->act, AFF_HIDE) )
    {
	REMOVE_BIT(ch->act, AFF_HIDE);
	act( "$n drops camoflage and is now visible.", ch, NULL, NULL, TO_ROOM );
	send_to_char( "You drop your camoflage.\n\r", ch );
    }
    else
    {
	act( "$n grabs some leaves and stuff and blends in with the trees.", ch, NULL, NULL, TO_ROOM );
	send_to_char( "You blend in with the trees.\n\r", ch );
	ch->move -= 500;
        SET_BIT(ch->act, AFF_HIDE);
    }
    return;
}

void do_binoculars( CHAR_DATA *ch, char *argument )
{
    if (IS_NPC(ch)) return;
	
	if (!IS_CLASS(ch, CLASS_UNISOL) )
	{
		send_to_char("Huh?\n\r", ch);
		return;
	}
	
    if (IS_CLASS(ch, CLASS_UNISOL) && ch->pcdata->powers[UNIPOWER_STEALTH] < 1 )
	{
	  send_to_char("You have not learned how to use that ability.\n\r", ch);
	  return;
	}
	
	else if (ch->move < 500)
	{
		send_to_char("You know how to use em, but where are they?\n\r", ch);
		return;
	} 

    if ( IS_SET(ch->act, PLR_HOLYLIGHT) )
    {
	REMOVE_BIT(ch->act, PLR_HOLYLIGHT);
	send_to_char( "You put your binoculars back in your pack.\n\r", ch );
    }
    else
    {
	SET_BIT(ch->act, PLR_HOLYLIGHT);
	send_to_char( "You hold your binoculars up to your eyes and see everything.\n\r", ch );
	ch->move -= 500; 
    }

    return;
}

void do_retreat( CHAR_DATA *ch, char *argument )
{
    ROOM_INDEX_DATA *was_in;
    ROOM_INDEX_DATA *now_in;
    CHAR_DATA *victim;
    int attempt;


	if (IS_CLASS(ch, CLASS_UNISOL) && ch->pcdata->powers[UNIPOWER_COMBAT] < 0 )
	{
	send_to_char("You have not learned how to properly retreat.\n\r", ch);
	return;
	}
	else if (!IS_CLASS(ch, CLASS_UNISOL) )
	{
	send_to_char("Huh?\n\r", ch);
	return;
	}
	
	if ( IS_NPC(ch) ) return;

    if ( ( victim = ch->fighting ) == NULL )
    {
	if ( ch->position == POS_FIGHTING )
	    ch->position = POS_STANDING;
	send_to_char( "You aren't fighting anyone.\n\r", ch );
	return;
    }
	if (ch->move < 200)
	{
	send_to_char("You don't have enough movement points to flee.\n\r", ch);
	return;
	} 
    if (IS_AFFECTED(ch, AFF_WEBBED))
    {
	send_to_char("You are webbed into place... AUGH!!\n\r",ch);
	return;
    }
  
    was_in = ch->in_room;
    
{
	EXIT_DATA *pexit;
	int door;

	send_to_char("You attempt to retreat from combat!\n\r", ch );

for ( attempt =  0; attempt < 6; attempt++ ) 
	{
	door = number_door( );
	if ( ( pexit = was_in->exit[door] ) == 0
	||   pexit->to_room == NULL
	||   IS_SET(pexit->exit_info, EX_CLOSED)
	|| ( IS_NPC(ch)
	&&   IS_SET(pexit->to_room->room_flags, ROOM_NO_MOB) ) )
	      continue;


	move_char( ch, door );
	if ( ( now_in = ch->in_room ) == was_in )
	      continue;

	ch->in_room = was_in;
	act( "$n has escaped!", ch, NULL, NULL, TO_ROOM );
	ch->in_room = now_in;
	
	if ( !IS_NPC(ch) )
	    send_to_char( "You retreat from combat!\n\r", ch ); 

ch->move -= 200;
	stop_fighting( ch, TRUE );
	return;
   }
   
}
    return;
}

void do_stungrenade( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    char      arg1 [MAX_INPUT_LENGTH];
    argument = one_argument( argument, arg1 );
        
    if (IS_NPC(ch)) return;
	
	if (!IS_CLASS(ch, CLASS_UNISOL))
	{
		send_to_char("Huh?\n\r", ch);
		return;
	}
	else if ( ch->pcdata->powers[UNIPOWER_COMBAT] < 1 )
	{
	    send_to_char("You need to learn the proper method for using your stun grenade throwing ability.\n\r", ch);
	    return;
	}
	
    if ( arg1[0] == '\0' )
    {
	send_to_char( "Toss a stun grenade at who?\n\r", ch );
	return;
    }

    if ( ( victim = get_char_room( ch, arg1 ) ) == NULL )
    {
	send_to_char( "They aren't here.\n\r", ch );
	return;
    }

    if ( ch == victim )
    {
	send_to_char( "DUH!! Not at yourself!\n\r", ch );
	return;
    }
	
    if ( ch->position == POS_SLEEPING )
    {
	send_to_char( "You have to be AWAKE first!\n\r", ch );
	return;
    }
    
	if (ch->move < 500)
	{
	send_to_char("You don't have enough movement points.\n\r", ch);
	return;
	}     
	  
    if ( victim->in_room == ch->in_room )
	{
	act("You activate the stun grenade and toss it at $N!!",ch,NULL,victim,TO_CHAR);
	act("$n activates a stun grenade, tosses it, and it EXPLODES!!",ch,NULL,victim,TO_VICT);
	victim->position = POS_STUNNED;
	ch->move -= 500;
	WAIT_STATE(ch, 1);
	return;
	}
	
	return;
}

void do_bulletproof( CHAR_DATA *ch, char *argument )
{
    if ( IS_NPC(ch) ) return;

    if ( !IS_CLASS(ch, CLASS_UNISOL) )
    {
	stc("Huh?\n\r",ch);
	return;
    }

    if ( ch->power[UNIPOWER_ARMORMENT] < 0 )
    {
      stc("You need to train in the use of a bulletproof jacket.\n\r",ch);
      return;
    }


    if ( IS_GAR1(ch, WOLF_COCOON) )
    {
      stc("You pull off your bulletproof jacket.\n\r",ch);
      act("$n pulls off a bulletproof jacket and puts it away.",ch,NULL,NULL,TO_ROOM);
      REMOVE_BIT(ch->garou1, WOLF_COCOON);
      return;
    } 
    else
    {
      stc("You put on your bulletproof jacket.\n\r",ch);
      act("$n puts on a bulletproof jacket.",ch,NULL,NULL,TO_ROOM);
      SET_BIT(ch->garou1, WOLF_COCOON);
      return;
    }
  return;
}

void do_commando( CHAR_DATA *ch, char *argument )
{
    if (IS_NPC(ch)) return;
	
        if (!IS_CLASS(ch, CLASS_UNISOL) )
	{
		send_to_char("Huh?\n\r", ch);
		return;
	}
	
        if (IS_CLASS(ch, CLASS_UNISOL) && (ch->pcdata->powers[UNIPOWER_STEALTH] < 2))
	{
          send_to_char("You need to learn the commando ability.\n\r", ch);
	  return;
	}
        if ((IS_CLASS(ch,CLASS_UNISOL)) && (ch->move < 500)) {
         send_to_char("You don't have enough movement to do that",ch);
         return;
        }

    if ( IS_SET(ch->act, PLR_WIZINVIS) )
    {
	REMOVE_BIT(ch->act, PLR_WIZINVIS);
        send_to_char( "You step out of the background and into view.\n\r", ch );
        act( "$n steps out of the background and into view.", ch, NULL, NULL, TO_ROOM );
    }
    else
    {   

        send_to_char( "You step into the background, vanishing from sight.\n\r", ch );
        act( "$n steps into the background, vanishing from sight.", ch, NULL, NULL, TO_ROOM );
	SET_BIT(ch->act, PLR_WIZINVIS);
	ch->move -= 500; 
    }
    return;
}
void do_landmine(CHAR_DATA *ch, char *argument)
{
    OBJ_DATA *obj;

    if (ch->power[UNIPOWER_COMBAT] < 2)
    {
	stc("You must learn how to properly use a landmine first.\n\r",ch);
	return;
    }

    if ( IS_SET(ch->in_room->room_flags,ROOM_SAFE) )
    {
	stc("The ground isnt right for setting up a landmine.\n\r",ch);
	return;
    }

obj = create_object(get_obj_index(OBJ_VNUM_LANDMINE),0 );
SET_BIT(obj->extra_flags2, ITEM_DAEMONSEED);
obj_to_char(obj, ch);
obj->timer = ch->generation / 2 + dice(5,7);
    act("$p clicks as $n sets it up.", ch, obj, NULL, TO_CHAR);
    act("$n sets up $p and gets ready to place it.", ch, obj, NULL, TO_ROOM);

}

void do_mortarfire( CHAR_DATA *ch, char *argument )
{

    CHAR_DATA *victim;
    char arg1 [MAX_INPUT_LENGTH];

 
    argument = one_argument( argument, arg1 );
  
 
    if ( IS_NPC(ch) )
    	return;
 
 
    if (!IS_CLASS(ch, CLASS_UNISOL))
    {
	send_to_char("Huh?\n\r",ch);
      return;
    }
 
    if (ch->power[UNIPOWER_COMBAT] < 3 )
    {
	send_to_char("You need to learn how to use mortarfire first.\n\r",ch);
    	return;
    }
 

    if (ch->mana < 500)
    {
	send_to_char("You do not have enough strength to lift the mortar cannon.\n\r",ch);
	return;
    }
 
    if ( arg1[0] == '\0' )
    {
	send_to_char( "Who do you wish to strike?\n\r", ch );
      return;
    }

    if ( ( victim = get_char_room( ch, arg1 ) ) == NULL )
    {
   	 send_to_char( "They aren't here.\n\r", ch );
	 return;
    }
    if (ch == victim) return;
    if (is_safe(ch,victim) == TRUE) return;
  
    	act("$N is struck by a massive blast of mortarfire.", ch, NULL, victim,TO_CHAR);
	act("$N is struck by a massive blast of mortarfire by $n.", ch, NULL, victim,TO_NOTVICT);
	act("You are struck by a massive blast of mortarfire!", ch, NULL, victim,TO_VICT);
    if (IS_GOOD(victim))
	hurt_person(ch,victim, 1000);
    if (IS_EVIL(victim))
        hurt_person(ch,victim, 1000);  
    if (IS_NEUTRAL(victim))
        hurt_person(ch,victim, 1000);  
	ch->mana -= 500;
    if (ch->fighting == NULL)
 	set_fighting(ch,victim);
	update_pos(victim);
	WAIT_STATE(ch,10);
	return;
    
}

void do_cooldown( CHAR_DATA *ch, char *argument )
{
    CHAR_DATA *victim;
    char arg1 [MAX_INPUT_LENGTH];
 
    argument = one_argument( argument, arg1 );

    if (IS_NPC(ch))
	return;

    if (ch->power[UNIPOWER_ARMORMENT] < 1 )
    {
	send_to_char("You need to gain this ability to use it.\n\r",ch);
	return;
    }

    if ( arg1[0] == '\0' )
    {
      send_to_char( "So, you need to cool down and heal? Cooldown yourself!\n\r", ch );
      return;
    }

    if ( ( victim = get_char_room( ch, arg1 ) ) == NULL )
    {
   	send_to_char( "They aren't here.\n\r", ch );
	return;
    }
  
    if (ch->mana < 50 && ch->fighting != NULL)
    {
	send_to_char("You are too weak to cool yourself down!\n\r",ch);
	return;
    }

    if (ch->fighting != NULL)
    {
    	act("You cool down and begin to heal.", ch, NULL, victim,TO_CHAR);
	act("$N cools down and begins to heal.", ch, NULL, victim,TO_NOTVICT);
	act("As your body temp goes lower and lower, you continue to heal more and more.", ch, NULL, victim,TO_VICT);
        victim->hit += 3500;
        ch->mana -= 50;
        update_pos(victim);
	WAIT_STATE(ch,10);
	return;
    }

    if (ch->mana < 250 && ch->fighting == NULL)
    {
	send_to_char("You are too weak to cool yourself down!\n\r",ch);
	return;
    }


    if (ch->fighting == NULL)
    {
    	act("You cool down and begin to heal.", ch, NULL, victim,TO_CHAR);
	act("$N cools down and begins to heal.", ch, NULL, victim,TO_NOTVICT);
	act("As your body temp goes lower and lower, you continue to heal more and more.", ch, NULL, victim,TO_VICT);
	victim->hit += 3500;
	ch->mana -= 100;
        update_pos(victim);
	WAIT_STATE(ch,8);
	return;
    }

}

void do_coldpower(CHAR_DATA *ch,char *argument)
{
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch,CLASS_UNISOL))
  {
  send_to_char("Huh?\n\r",ch);
  return;
  }
  if (ch->power[UNIPOWER_ARMORMENT] < 2)
  {
  send_to_char("You need to learn more about armorment.\n\r",ch);
  return;
  }
  if (!IS_SET(ch->newbits, NEW_SKIN))
  {
  send_to_char("You grab an ice pack, and strap it to you, making your skin a little tougher.\n\r",ch);
  ch->armor -= 100 ;
  SET_BIT(ch->newbits, NEW_SKIN);
  return;
  }
  else if (IS_SET(ch->newbits, NEW_SKIN))
  { 
  send_to_char("Your old ice pack melts, and your skin softens as it warms up.\n\r",ch);
  ch->armor += 100;
  REMOVE_BIT(ch->newbits,NEW_SKIN);
  return;
  }
return;
}

void do_smash(CHAR_DATA *ch,char *argument)
{
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch,CLASS_UNISOL))
  {
  send_to_char("Huh?\n\r",ch);
  return;
  }
  if (ch->power[UNIPOWER_COMBAT] < 4)
  {
  send_to_char("You need to learn how to smash into your opponent.\n\r",ch);
  return;
  }
  if (!IS_SET(ch->newbits, NEW_SLAM))
  {
  send_to_char("You can now smash into your opponent in battle.\n\r",ch);
  SET_BIT(ch->newbits, NEW_SLAM);
  return;
  }
  else if (IS_SET(ch->newbits, NEW_SLAM))
  { 
  send_to_char("You have grown too tired to smash in battle.\n\r",ch);
  REMOVE_BIT(ch->newbits,NEW_SLAM);
  return;
  }
return;
}
 
void do_forearm( CHAR_DATA *ch, char *argument )
{
CHAR_DATA *victim;
 
char buf[MAX_STRING_LENGTH];
 
int dam;
if (IS_NPC(ch)) return;
 
if (!IS_CLASS(ch,CLASS_UNISOL))
{
send_to_char("Huh?\n\r",ch);
return;
}
if (ch->power[UNIPOWER_COMBAT] < 5)
{
send_to_char("You have not trained for the forearm ability.\n\r",ch);
    return;
}

if ( ( victim = ch->fighting ) == NULL )
{
send_to_char( "You aren't fighting anyone.\n\r", ch );
      return;
 
}
WAIT_STATE( ch, 12 );
if (!IS_NPC(victim))
{
dam = 1500;
}
else if (IS_NPC(victim))
{
dam = 3000;
}
if ( !IS_NPC(victim) && IS_CLASS(victim, CLASS_UNISOL) )
{
    if (victim->power[UNIPOWER_COMBAT] > 4 ) dam *= 0.5;
}
 
dam += number_range(1,30);
if ( dam <= 0 )
   dam = 1;
sprintf(buf,"You bash $N with your forearm incredibly hard! [%d]\n\r",dam);
act(buf,ch,NULL,victim,TO_CHAR);
sprintf(buf,"$n bashes you with a forearm incredibly hard! [%d]\n\r",dam);
act(buf,ch,NULL,victim,TO_VICT);
sprintf(buf,"$n's forearm strikes $N incredibly hard! [%d]\n\r",dam);
act(buf,ch,NULL,victim,TO_NOTVICT);
 
 
hurt_person(ch,victim, dam);
return;

}

