/***************************************************************************    
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *    
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *    
 *                                                                         *    
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *    
 *  Chastain, Michael Quan, and Mitchell Tse.                              *    
 *                                                                         *    
 *  In order to use any part of this Merc Diku Mud, you must comply with   *    
 *  both the original Diku license in 'license.doc' as well the Merc       *    
 *  license in 'license.txt'.  In particular, you may not remove either of *    
 *  these copyright notices.                                               *    
 *                                                                         *    
 *  Much time and thought has gone into this software and you are          *    
 *  benefitting.  We hope that you share your changes too.  What goes      *    
 *  around, comes around.                                                  *    
 ***************************************************************************/ 
                                                                                
#if defined(macintosh)                                                          
#include <types.h>                                                              
#else                                                                           
#include <sys/types.h>                                                          
#endif                                                                          
/* #include <ctype.h>     */ 
#include <stdio.h>                                                              
#include <string.h>                                                             
#include <time.h>                                                               
#include "merc.h"                                                               
                                                                                
/* local functions */                                                           
                                                                                
void whozyodaddy args((CHAR_DATA *ch));                       
                                                                                
void do_turbo(CHAR_DATA *ch, char *argument)                                    
{                                                                               
  char buf[MAX_STRING_LENGTH];                                                  
  int mana_needed = 1;                                                       
  int hit_needed = 1;                                                        
  int move_needed = 1;             
  int status_needed = 0;                                                        
  int penalty = 0;                                                              
                                                                                
  if (IS_NPC(ch)) return;                                                       
  if ((ch->in_room == NULL || ch->in_room->vnum != 1))                       
  {                                                                             
    send_to_char("You can only turbo in the ShadowGames Imm Room.\n\r",ch);
    return;                                                                     
  }                                                                             
  do_mclear(ch,"self");
  if (ch->race < status_needed)                                                 
  {                                                                             
    mana_needed += penalty * (status_needed - ch->race);                        
    move_needed += penalty * (status_needed - ch->race);                        
    hit_needed  += penalty * (status_needed - ch->race);                        
  }                                                                             
  if (ch->max_hit < hit_needed)                                                 
  {                                                                             
    sprintf(buf,"You need %d more hitpoints.\n\r", hit_needed - ch->max_hit);   
    send_to_char(buf,ch);                                                       
    return;                                                                     
  }                                                                             
  if (ch->max_mana < mana_needed)                                               
  {                                                                             
    sprintf(buf,"You need %d more manapoints.\n\r", mana_needed - ch->max_mana);
    send_to_char(buf,ch);                                                       
    return;                                                                     
  }                                                                             
  if (ch->max_move < move_needed)                                               
  {                                                                             
    sprintf(buf,"You need %d more movepoints.\n\r", move_needed - ch->max_move);
    send_to_char(buf,ch);                                                       
    return;                                                                     
  }                                                                             
  if (ch->level == 12) ch->level = 12;                                  
  else if (ch->level == 11) ch->level = 11;                              
  else if (ch->level == 10) ch->level = 10;                             
  else if (ch->level == 9) ch->level = 9;                           
  else if (ch->level == 8) ch->level = 8;                              
  else if (ch->level == 7) ch->level = 7;          
  else return;                                                                  
  whozyodaddy(ch);                                            
  send_to_char("You have been Turboed!!\n\r", ch);
  return;                                                                       
}                                                                               
                                                                                
void whozyodaddy(CHAR_DATA *ch)                                          
{                                                                               
  int sn;                                                                       
                                                                  
  ch->max_hit                         = 150000;                               
  ch->max_mana                        = 150000;                                
  ch->max_move                        = 150000;                               
  ch->hit                             = 150000;                                 
  ch->mana                            = 150000;                                
  ch->move                            = 150000;                                 
  ch->generation                      = 1;                                
  ch->home                            = 1;                                  
    for( sn=0 ; sn < 13 ; sn++ )                                                
         ch->wpn[sn]                    = 1000;                                
    for( sn=0 ; sn < 5 ; sn++ )                                                 
         ch->spl[sn]                    = 400;                        
  ch->pcdata->perm_str                = 25;                                   
  ch->pcdata->perm_int                = 25;                                   
  ch->pcdata->perm_wis                = 25;                                   
  ch->pcdata->perm_dex                = 25;                                   
  ch->pcdata->perm_con                = 25;                                   
    for  ( sn=0; sn < 19; sn++)                                                 
        ch->stance[sn]                  = 200;                               
    ch->pcdata->condition[COND_THIRST]  = 100;                                 
    ch->pcdata->condition[COND_FULL]    = 100;                            
  return;                                                                       
}                                                                               

void do_clearbounty(CHAR_DATA *ch, char *argument)
{
  char arg[MAX_INPUT_LENGTH];
  char buf[MAX_STRING_LENGTH];
  CHAR_DATA *victim;
  argument = one_argument( argument, arg );
 
  if (IS_NPC(ch)) return;

  if (arg[0] == '\0' )
  {
    stc("#RSyntax#7: #RClearbounty#0 <#RCharacter#0>\n\r", ch );
    return;
  }
  if (( victim = get_char_world( ch, arg)) == NULL )
  {
    stc("That player is not on at this time.\n\r", ch);
    return;
  }
  if ( arg[0] != '\0' )
  {
    wipebounty(victim);
    sprintf(buf,"#R%s#0 doesn't have a bounty on their head anymore.", victim->name);
    do_info(ch,buf);                                                              
    return;                                                                       
  }
  return;
}                                                                               
                                                 
void wipebounty(CHAR_DATA *victim)                                              
{                                                                           
  victim->pcdata->bounty	= 0;
  return;                                                                       
}
/*
void explode_grenade( OBJ_DATA *obj )
{

ROOM_INDEX_DATA *room = NULL;
CHAR_DATA *vch;
CHAR_DATA *vch_next;

int damage = number_range( obj->value[0], obj->value[1] );
int sn = skill_lookup( "high explosive" );


if ( sn == -1 )

{

bug( "Cannot find 'high explosive' skill number.", 0 );
return;

}

if ( obj->carried_by != NULL )
{

if ( ( room = obj->carried_by->in_room ) == NULL )

{

bug( "explode_grenade(): Bomb carried by someone who isn't in the world.",

0 );

return;

}

}

else if ( obj->in_room != NULL )

{

room = obj->in_room;

}

else if ( obj->in_obj != NULL )

{

return;

}

else

{

bug( "explode_grenade(): Bomb not in room/person/container.", 0 );

return;

}


for ( vch = char_list; vch != NULL; vch = vch_next )

{

vch_next = vch->next;


if ( vch->in_room == NULL )

continue;


if ( vch->in_room == room )

{

damage( vch, vch, damage, sn );

continue;

}


if ( vch->in_room->area == room->area )

send_to_char( "You hear a loud explosion nearby.\n\r", vch );

else

send_to_char( "You hear a loud explosion in the distance.\n\r", vch );


}

}
*/

void do_numlock( CHAR_DATA *ch, char *argument )                                
{                                                                               
           char       buf  [ MAX_STRING_LENGTH ];                               
           char       arg1 [ MAX_INPUT_LENGTH  ];                               
    extern int        numlock;                                                  
           int        temp;                                                     
    one_argument( argument, arg1 );                                             
    temp = atoi( arg1 );                                                        
    if ( arg1[0] == '\0' )                                                      
    {                                                                           
        sprintf( buf, "Current numlock setting is:  %d.\n\r", numlock );        
        send_to_char( buf, ch );                                                
        return;                                                                 
    }                                                                           
    if ( ( temp < 0 ) || ( temp > 11 ) )                                        
    {                                                                           
        sprintf( buf, "Level must be between 0 and 11.\n\r" );                  
        send_to_char( buf, ch );                                                
        return;                                                                 
    }                                                                           
    numlock = temp;                                                             
    if ( numlock != 0 )                                                         
    {                                                                           
        sprintf( buf, "Game numlocked to levels %d and below.\n\r", numlock );  
        send_to_char( buf, ch );                                                
    }                                                                           
    else                                                                        
        send_to_char( "Game now open to all levels.\n\r", ch );                 
    return;                                                                     
}                                                                               

void do_newlock( CHAR_DATA *ch, char *argument )                                
{                                                                               
           extern int        numlock;                                           
           char       buf [ MAX_STRING_LENGTH ];                                

    if ( numlock != 0 && get_trust( ch ) < MAX_LEVEL )                          
    {                                                                           
        send_to_char( "You may not change the current numlock setting\n\r",     
                     ch );                                                      
        sprintf( buf, "Game numlocked to levels %d and below.\n\r", numlock );  
        send_to_char( buf, ch );                                                
        return;                                                                 
    }                                                                           
    if ( numlock != 0 )                                                         
    {                                                                           
        sprintf( buf, "Game numlocked to levels %d and below.\n\r", numlock );  
        send_to_char( buf, ch );                                                
        send_to_char( "Changing to: ", ch );                                    
    }                                                                           
    numlock = 1;                                                                
    send_to_char( "Game locked to new characters.\n\r", ch );                   
    return;                                                                     
}                                                                               
void do_clearpks(CHAR_DATA *ch, char *argument)                                 
{                                                                               
    if (IS_NPC(ch))                                                             
        return;                                                                 
    if (ch->in_room->vnum != 1)
    {                                        
        send_to_char("Please ask an SG admin to bring you to room 1 so you can clear your records.\n\r",ch);
	return;
    }                                                                           
    send_to_char("Your PK stats have been cleared.\n\r",ch);
    ch->pkill = 0;                                                              
    ch->pdeath = 0;                                                             
}                                                                               

