/***************************************************************************
 *  Original Diku Mud copyright (C) 1990, 1991 by Sebastian Hammer,        *
 *  Michael Seifert, Hans Henrik St{rfeldt, Tom Madsen, and Katja Nyboe.   *
 *                                                                         *
 *  Merc Diku Mud improvments copyright (C) 1992, 1993 by Michael          *
 *  Chastain, Michael Quan, and Mitchell Tse.                              *
 *                                                                         *
 *  In order to use any part of this Merc Diku Mud, you must comply with   *
 *  both the original Diku license in 'license.doc' as well the Merc       *
 *  license in 'license.txt'.  In particular, you may not remove either of *
 *  these...                                                               *
 ***************************************************************************
 *                 Xombi Class By Wolfman, (C) 1999,2000,2001              *
 ***************************************************************************/

#if defined(macintosh)
#include <types.h>
#else
#include <sys/types.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "merc.h"
#include "player.h"
#include "xombi.h"

void do_xsniff( CHAR_DATA *ch, char *argument )
{
	char arg1[MAX_INPUT_LENGTH];
	char buf[MAX_INPUT_LENGTH];
	CHAR_DATA *victim;

	argument = one_argument( argument, arg1 );

	if ( IS_NPC( ch ) ) return;
	if ( !IS_CLASS( ch, CLASS_XOMBI ) )
	{
		send_to_char( "Huh?\n\r", ch );
		return;
	}
	else if ( ch->pcdata->powers[XPOWER_MIND] < 7 )
	{
		send_to_char( "You need Mind level 7 to use this skill.\n\r", ch );
		return;
	}

	if ( arg1[0] == '\0' )
	{
		send_to_char("Who do you wish to sniff?\n\r",ch);
		return;
	}

	victim = get_char_room(ch, arg1);
	if ( ( victim = get_char_room( ch, arg1) ) == NULL )
	{
		send_to_char("They aren't here.\n\r",ch);
		return;
	}

	sprintf( buf, "%s has %d of %d hitpoints.\n\r", victim->name, victim->hit, victim->max_hit );
	send_to_char( "You sniff them and find that:\n\r", ch );
	send_to_char( buf, ch );
	sprintf( buf, "%s sniffs you hungrily- I wouldn't hang around too long!\n\r", ch->name );
	send_to_char( buf, victim );
}

void do_xombu( CHAR_DATA *ch, char *argument )
{
	char arg1[MAX_INPUT_LENGTH];
	char arg2[MAX_INPUT_LENGTH];
	char buf[MAX_STRING_LENGTH];

	argument = one_argument( argument, arg1 );
	argument = one_argument( argument, arg2 );

	if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_XOMBI))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}

	if (arg1[0] == '\0' && arg2[0] == '\0')
	{
		sprintf(buf,"Xombu: Flesh (%d), Mind (%d), Body (%d).\n\r",
			ch->pcdata->powers[XPOWER_FLESH], ch->pcdata->powers[XPOWER_MIND],
			ch->pcdata->powers[XPOWER_BODY]);
		send_to_char(buf,ch);
		return;
	}
	if (arg2[0] == '\0')
	{
		if (!str_cmp(arg1,"flesh"))
		{
			send_to_char("Flesh - The Power of the Dead skills.\n\r\n\r",ch);
			if (ch->pcdata->powers[XPOWER_FLESH] < 1)
				send_to_char("You have none of the Flesh skills.\n\r",ch);
			if (ch->pcdata->powers[XPOWER_FLESH] > 0)
				send_to_char("xskin -Flesh Removal- Use the skin of dead mobs to replace your own.\n\r",ch);
			if (ch->pcdata->powers[XPOWER_FLESH] > 1)
				send_to_char("xfeed -Cure Hunger- Rip off your enemies' limbs and eat them for hp gain.\n\r",ch);
			if (ch->pcdata->powers[XPOWER_FLESH] > 2)
				send_to_char("Rip -Cause Damage- Rip off bits of your enemy's skin to reduce their hp.\n\r",ch);
			if (ch->pcdata->powers[XPOWER_FLESH] > 3)
				send_to_char("Gouge -Blindness- You rip out your opponent's eyes and eat em leaving them blind.\n\r",ch);
			if (ch->pcdata->powers[XPOWER_FLESH] > 4)
				send_to_char("Fillet -Makes foe bleed to death- You skin off your enemy's flesh and let em bleed.\n\r", ch);
			if (ch->pcdata->powers[XPOWER_FLESH] > 5)
				send_to_char("StrongFlesh -Toughness- Makes your skin very strong.\n\r", ch);
			if (ch->pcdata->powers[XPOWER_FLESH] > 6)
				send_to_char("Decompose - Shape Change- Rip off your flesh and fight as a Skeleton!\n\r", ch);
 			if (ch->pcdata->powers[XPOWER_FLESH] > 7)
				send_to_char("Detongue - Rips out your opponent's tongue for hp gain and some quiet!!\n\r",ch); 
			return; 
		}
		else if (!str_cmp(arg1,"Mind"))
		{
			send_to_char("Mind - The powers of the brain skills.\n\r\n\r",ch);
			if (ch->pcdata->powers[XPOWER_MIND] < 1)
				send_to_char("You have none of the Mind skills.\n\r",ch);
			if (ch->pcdata->powers[XPOWER_MIND] > 0)
				send_to_char("Brainless -Brain Removal- A Darkheart like skill that removes your brain freeing you from brain attack.\n\r",ch);
			if (ch->pcdata->powers[XPOWER_MIND] > 1)
				send_to_char("Lobotomy -Enhanced Brain Removal- Remove and eat an opponent's brain for hp gain.\n\r",ch);
			if (ch->pcdata->powers[XPOWER_MIND] > 2)
				send_to_char("Genius -Stats Remover- Kills your opponent's str, dex, con, wis, int, etc.\n\r",ch);
			if (ch->pcdata->powers[XPOWER_MIND] > 3)
				send_to_char("Stoneeyes -Nightsight- See in the dark.\n\r",ch);
			if (ch->pcdata->powers[XPOWER_MIND] > 4)
				send_to_char("Coldeyes -Shadowsight- See into the umbra.\n\r", ch);
			if (ch->pcdata->powers[XPOWER_MIND] > 5)
				send_to_char("Deadeyes -Truesight- See all the unseen.\n\r", ch );
			if (ch->pcdata->powers[XPOWER_MIND] > 6)
				send_to_char("xsniff -Info- See how much hp victim has.\n\r", ch );
			return;
		}
		else if (!str_cmp(arg1,"Body"))
		{
			send_to_char("Body - The battle and attack skills.\n\r\n\r",ch);
			if (ch->pcdata->powers[XPOWER_BODY] < 1)
				send_to_char("You have none of the Body skills.\n\r",ch);
			if (ch->pcdata->powers[XPOWER_BODY] > 0)
				send_to_char("Denerve -Removes pain- Lessens damage.\n\r",ch);
			if (ch->pcdata->powers[XPOWER_BODY] > 1)
				send_to_char("Pulp -Undead Strength- Giant strength to beat your opponent senseless.\n\r",ch);
			if (ch->pcdata->powers[XPOWER_BODY] > 2)
				send_to_char("Bonerip -Weapon Creation- Rip out one of your ribs for a weapon.\n\r",ch);
			if (ch->pcdata->powers[XPOWER_BODY] > 3)
				send_to_char("Enamel -Biting Strength- Makes teeth strong enough to bite off flesh when fighting.\n\r",ch);
			if (ch->pcdata->powers[XPOWER_BODY] > 4)
				send_to_char("Nails -Nail Strength- Makes fingernails strong enough to rip flesh to the bone.\n\r", ch);
			if (ch->pcdata->powers[XPOWER_BODY] > 5)
				send_to_char("Chew -Bondage Breaker- Eat through ropes, webs, etc.\n\r", ch );
			if (ch->pcdata->powers[XPOWER_BODY] > 6)
				send_to_char("Brainhunt -Hunt for some brains!!!\n\r", ch);
			return;
		}
		sprintf(buf,"Xombu: Flesh (%d), Mind (%d), Body (%d).\n\r",
			ch->pcdata->powers[XPOWER_FLESH], ch->pcdata->powers[XPOWER_MIND],
			ch->pcdata->powers[XPOWER_BODY]);
		send_to_char(buf,ch);
		return;
	}
	if (!str_cmp(arg2,"improve"))
	{
		int improve;
		int cost;
		int max;

		if 		(!str_cmp(arg1,"flesh"  )) {
			improve = XPOWER_FLESH;
			max=8;
		}
		else if 	(!str_cmp(arg1,"mind"   )) {
			improve = XPOWER_MIND;
			max=7;
		}
		else if 	(!str_cmp(arg1,"body"   )) {
			improve = XPOWER_BODY;
			max=7;
		}
		else
		{
			send_to_char("Xombu: Flesh, Mind, Body.\n\r",ch);
			return;
		}
		cost = (ch->pcdata->powers[improve]+1) * 10;
		arg1[0] = UPPER(arg1[0]);
		if ( ch->pcdata->powers[improve] >= max )
		{
			sprintf(buf,"You have already gained all the powers of the %s skills.\n\r", arg1);
			send_to_char(buf,ch);
			return;
		}
		if ( cost > ch->practice )
		{
			sprintf(buf,"It costs you %d primal to improve your %s skill.\n\r", cost, arg1);
			send_to_char(buf,ch);
			return;
		}
		ch->pcdata->powers[improve] += 1;
		ch->practice -= cost;
		sprintf(buf,"You improve your ability in the %s skill.\n\r", arg1);
		send_to_char(buf,ch);
	}
	else send_to_char("To improve a skill, type: Xombu <xombu type> improve.\n\r",ch);
	return;
}

void do_xskin( CHAR_DATA *ch, char *argument ) 
{
	char arg[MAX_INPUT_LENGTH];
	OBJ_DATA *obj;
	int hpgain;
        int gain;
	argument = one_argument( argument, arg );

	if (IS_NPC(ch)) return;
	if (!IS_CLASS(ch, CLASS_XOMBI))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}
	if (ch->pcdata->powers[XPOWER_FLESH] < 1)
	{
		send_to_char("You need level 1 Flesh to use Skin.\n\r",ch);
		return;
	}

	if ( arg[0] == '\0' )
	{
		send_to_char("Which corpse do you want to skin?\n\r",ch);
		return;
	}

	obj = get_obj_list( ch, arg, ch->in_room->contents );
	if ( obj == NULL )
	{
		send_to_char( "You can't find it.\n\r", ch );
		return;
	}

	if (obj->item_type != ITEM_CORPSE_NPC)
	{
		act( "The skin of $p is too tough to slice off.", ch, obj, 0, TO_CHAR);
		return;
	}
	else if (obj->chobj != NULL && !IS_NPC(obj->chobj)
		    && obj->chobj->pcdata->obj_vnum != 0)
	{
		act( "The skin of $p is too tough to slice off.", ch, obj, 0, TO_CHAR);
		return;
	}

	hpgain = number_range(450,525);
	gain = number_range(1500,2500); 
	ch->hit += hpgain; 
	if (ch->hit > ch->max_hit)
		ch->hit = ch->max_hit;
	act( "You slice off the skin of $p and add it to your own.", ch, obj, NULL, TO_CHAR );
	act( "$p is totally skinned by $n.", ch, obj, NULL, TO_ROOM );
	extract_obj( obj );
	WAIT_STATE(ch, 4);
	ch->pcdata->powers[XOMBI_SKIN] += gain; 
	return; 
}

void do_xfeed (CHAR_DATA *ch, char *argument)
{
	CHAR_DATA *victim;
	OBJ_DATA *obj;
	char arg [MAX_INPUT_LENGTH];
	char buf [MAX_STRING_LENGTH];

	argument = one_argument (argument, arg);

	if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_XOMBI))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}

	if (ch->pcdata->powers[XPOWER_FLESH] < 2)
	{
		send_to_char("You need level 2 Flesh to use Feed.\n\r",ch);
		return;
	}

	if ( arg[0] == '\0' )
	{
		send_to_char("Who do you wish to feed on?\n\r",ch);
		return;
	}

	victim = get_char_room(ch, arg);
	if ( ( victim = get_char_room( ch, arg) ) == NULL )
	{
		send_to_char("They arent here.\n\r",ch);
		return;
	}

	if (IS_SET(victim->in_room->room_flags, ROOM_SAFE))
	{
		send_to_char("You cannot attack them here.\n\r",ch);
		return;
	}

	if (is_safe(ch,victim) == TRUE)
		return;

	if (IS_ARM_R(victim,LOST_ARM) && IS_ARM_L(victim,LOST_ARM) &&
		    IS_LEG_R(victim,LOST_LEG) && IS_LEG_L(victim,LOST_LEG))
	{
		send_to_char("All of their limbs are severed already!\n\r",ch);
		return;
	}

	if (number_percent ( ) < 45 )
	{
		if (!IS_ARM_R(victim,LOST_ARM))
		{
			SET_BIT(victim->loc_hp[3],LOST_ARM);
			if ((obj = get_eq_char( victim, WEAR_HOLD )) != NULL )
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_HANDS )) != NULL)
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_WRIST_R )) != NULL)
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_FINGER_R )) != NULL)
				take_item(victim,obj);
			make_part(victim,"arm");
			sprintf(buf, "%s tears %s's arm off!",ch->name, victim->name);
			send_to_char(buf,ch);
			act(buf,ch,NULL,NULL,TO_ROOM);
			do_get(ch,"arm");
			do_eat(ch,"arm");
			if (victim->hit >= 300)
			{
				sh_int power;
				sh_int dam;
				power = 100;
				dam = dice(power, power + 2);
				if (dam < 0) dam = 0;
				if (dam > ch->max_hit) dam = (ch->max_hit / 2);
				if (dam > 1500) dam = 1500;
				victim->hit -= dam;
				ch->hit += dam / 2;
				if (ch->hit >= ch->max_hit + 250)
					ch->hit = ch->max_hit + 250;
				sprintf(buf,"#1You absorb %d hitpoints from your meal.#n\n\r",dam);
				send_to_char(buf,ch);
				return;
			}
		}

		if (!IS_ARM_L(victim,LOST_ARM))
		{
			SET_BIT(victim->loc_hp[2],LOST_ARM);
			if ((obj = get_eq_char( victim, WEAR_HOLD )) != NULL )
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_HANDS )) != NULL)
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_WRIST_L )) != NULL)
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_FINGER_L )) != NULL)
				take_item(victim,obj);
			make_part(victim,"arm");
			sprintf(buf, "%s tears %s's arm off!",ch->name, victim->name);
			act(buf,ch,NULL,NULL,TO_ROOM);
			send_to_char(buf,ch);
			do_get(ch,"arm");
			do_eat(ch,"arm");
			if (victim->hit >= 300)
			{
				sh_int power;
				sh_int dam;
				power = 100;
				dam = dice(power, power + 2);
				if (dam < 0) dam = 0;
				if (dam > ch->max_hit) dam = (ch->max_hit / 2);
				if (dam > 1500) dam = 1500;
				victim->hit -= dam;
				ch->hit += dam / 2;
				if (ch->hit >= ch->max_hit + 250)
					ch->hit = ch->max_hit + 250;
				sprintf(buf,"#1You absorb %d hitpoints from your meal.#n\n\r",dam);
				send_to_char(buf,ch);
				return;
			}
		}
		if (!IS_LEG_R(victim,LOST_LEG))
		{
			SET_BIT(victim->loc_hp[5],LOST_LEG);
			if ((obj = get_eq_char( victim, WEAR_FEET )) != NULL )
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_LEGS )) != NULL)
				take_item(victim,obj);
			make_part(victim,"leg");
			sprintf(buf, "%s tears %s's leg off!",ch->name, victim->name);
			act(buf,ch,NULL,NULL,TO_ROOM);
			send_to_char(buf,ch);
			do_get(ch,"leg");
			do_eat(ch,"leg");
			if (victim->hit >= 300)
			{
				sh_int power;
				sh_int dam;
				power = 100;
				dam = dice(power, power + 2);
				if (dam < 0) dam = 0;
				if (dam > ch->max_hit) dam = (ch->max_hit / 2);
				if (dam > 1500) dam = 1500;
				victim->hit -= dam;
				ch->hit += dam / 2;
				if (ch->hit >= ch->max_hit + 250)
					ch->hit = ch->max_hit + 250;
				sprintf(buf,"#1You absorb %d hitpoints from your meal.#n\n\r",dam);
				send_to_char(buf,ch);
				return;
			}
		}
		if (!IS_LEG_L(victim,LOST_LEG))
		{
			SET_BIT(victim->loc_hp[4],LOST_LEG);
			if ((obj = get_eq_char( victim, WEAR_FEET )) != NULL )
				take_item(victim,obj);
			if ((obj = get_eq_char( victim, WEAR_LEGS )) != NULL)
				take_item(victim,obj);
			make_part(victim,"leg");
			sprintf(buf, "%s tears %s's leg off!",ch->name, victim->name);
			act(buf,ch,NULL,NULL,TO_ROOM);
			send_to_char(buf,ch);
			do_get(ch,"leg");
			do_eat(ch,"leg");
			if (victim->hit >= 300)
			{
				sh_int power;
				sh_int dam;
				power = 100;
				dam = dice(power, power + 2);
				if (dam < 0) dam = 0;
				if (dam > ch->max_hit)
					dam = (ch->max_hit / 2);
				if (dam > 1500) dam = 1500;
				victim->hit -= dam;
				ch->hit += dam / 2;
				if (ch->hit >= ch->max_hit + 250)
					ch->hit = ch->max_hit + 250;
				sprintf(buf,"#1You absorb %d hitpoints from your meal.#n\n\r",dam);
				send_to_char(buf,ch);
				return;
			}
		}
		else send_to_char("You failed to feast on them.\n\r",ch);
		return;
	}
}
void do_gouge (CHAR_DATA *ch,char *argument)
{
	CHAR_DATA *victim;
	OBJ_DATA *obj;
	char arg [MAX_INPUT_LENGTH];
	char buf [MAX_STRING_LENGTH];
	AFFECT_DATA af;
	argument = one_argument (argument, arg);


	if (IS_NPC(ch)) return;
	if (!IS_CLASS(ch, CLASS_XOMBI))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}
	if (ch->pcdata->powers[XPOWER_FLESH] < 4)
	{
		send_to_char("You need level 4 Flesh to use Gouge.\n\r",ch);
		return;
	}

	if( arg[0] == '\0' )
	{
		send_to_char("Who's eyes do you wish to gouge out?\n\r",ch);
		return;
	}
	victim = get_char_room(ch, arg);
	if ( victim == NULL )
	{
		send_to_char("They arent here.\n\r",ch);
		return;
	}

	if (IS_SET(victim->in_room->room_flags, ROOM_SAFE))
	{
		send_to_char("You cannot attack them here.\n\r",ch);
		return;
	}

	if (is_safe(ch,victim) == TRUE)
		return;

	if ( IS_SET(victim->loc_hp[0],LOST_EYE_L) && IS_SET(victim->loc_hp[0],LOST_EYE_R) )
	{
		send_to_char("Both of their eyes are already removed!\n\r",ch);
		return;
	}
	if (number_percent ( ) < 45 )
	{
		if ( !IS_SET(victim->loc_hp[0],LOST_EYE_L) )
		{
			SET_BIT(victim->loc_hp[0],LOST_EYE_L);
			if ((obj = get_eq_char( victim, WEAR_FACE )) != NULL )
				take_item(victim,obj);
			make_part(victim,"eye");
			sprintf(buf, "%s gouges %s's eye out!", ch->name, victim->name);
			send_to_char(buf,ch);
			act(buf,ch,NULL,NULL,TO_ROOM);
			do_get(ch,"eye");
			do_eat(ch,"eye");
			if (victim->hit >= 300)
			{
				sh_int power;
				sh_int dam;
				power = 100;
				dam = dice(power, power + 2);
				if (dam < 0) dam = 0;
				if (dam > ch->max_hit) dam = (ch->max_hit / 2);
				if (dam > 1500) dam = 1500;
				victim->hit -= dam;
				ch->hit += dam / 2;
				if (ch->hit >= ch->max_hit + 250)
					ch->hit = ch->max_hit + 250;
				sprintf(buf,"#1You absorb %d hitpoints from your meal.#n\n\r",dam);
				send_to_char(buf,ch);
				return; 
		}
		} 
		if ( !IS_SET(victim->loc_hp[0],LOST_EYE_R) ) 
		{
			SET_BIT(victim->loc_hp[0],LOST_EYE_R);
			if ((obj = get_eq_char( victim, WEAR_FACE )) != NULL )
				take_item(victim,obj);
			make_part(victim,"eye");
			sprintf(buf, "%s gouges %s's eye out!", ch->name, victim->name);
			act(buf,ch,NULL,NULL,TO_ROOM);
			send_to_char(buf,ch);
			do_get(ch,"eye");
			do_eat(ch,"eye");
			if (victim->hit >= 300)
			{
				sh_int power;
				sh_int dam;
				power = 100;
				dam = dice(power, power + 2);
				if (dam < 0) dam = 0;
				if (dam > ch->max_hit) dam = (ch->max_hit / 2);
				if (dam > 1500) dam = 1500;
				victim->hit -= dam;
				ch->hit += dam / 2;
				if (ch->hit >= ch->max_hit + 250)
					ch->hit = ch->max_hit + 250;
				sprintf(buf,"#1You absorb %d hitpoints from your meal.#n\n\r",dam);
				send_to_char(buf,ch);
				return;  
		}
	}
/*	else
	    {
		send_to_char( "They scrambled out of your grasp!\n\r", ch );
		send_to_char( "They lunge for your face but you quickly move away!\n\r", victim );
		return;
	} */
	if ( IS_SET(victim->loc_hp[0],LOST_EYE_R) &&
	     IS_SET(victim->loc_hp[0],LOST_EYE_L))
	{
		REMOVE_BIT(victim->act, PLR_HOLYLIGHT);
		REMOVE_BIT(victim->affected_by, AFF_DETECT_HIDDEN);
		REMOVE_BIT(victim->affected_by, AFF_DETECT_INVIS);
		af.type      = skill_lookup("blindness");
		af.location  = APPLY_HITROLL;
		af.modifier  = -10000;
		af.duration  = 100;
		af.bitvector = AFF_BLIND;
		affect_to_char( victim, &af );
		WAIT_STATE(ch, 2);
		return;           
}
}
}  
void do_xoms( CHAR_DATA *ch, char *argument )  {
	char buf[MAX_STRING_LENGTH];
	char arg[MAX_INPUT_LENGTH];
	CHAR_DATA *gch;

	one_argument( argument, arg );

	if (IS_NPC(ch)) return;
	if (!IS_CLASS(ch, CLASS_XOMBI))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}

	send_to_char("Xombis Stalking:\n\r", ch );
	send_to_char("[    Name    ] [ Hits ] [ Mana ] [ Move ] [   Exp    ] [ SKINS ]\n\r",ch);
	for ( gch = char_list; gch != NULL; gch = gch->next )
	{
		if ( IS_NPC(gch) ) continue;
		if ( !IS_CLASS(gch, CLASS_XOMBI))
			continue;

		sprintf( buf,
			"[%-12s] [%-6d] [%-6d] [%-6d] [%-10d] [%-7d]\n\r",
			capitalize( gch->name ),
			gch->hit,gch->mana,gch->move, gch->exp,
			(gch->pcdata->powers[XOMBI_SKIN]));
		send_to_char( buf, ch );
	}
	return;
}

void do_fillet( CHAR_DATA *ch, char *argument )
{
	CHAR_DATA *victim;
	char arg [MAX_INPUT_LENGTH];
	int dam;
	char buf [MAX_STRING_LENGTH];

	argument = one_argument( argument, arg );

	if ( IS_NPC(ch) ) return;

	if (!IS_CLASS(ch, CLASS_XOMBI))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}

	if (ch->pcdata->powers[XPOWER_FLESH] < 5 )
	{
		send_to_char("You must obtain level 5 Flesh to use Fillet.\n\r",ch);
		return;
	}

	if ( ( victim = get_char_room( ch, arg ) ) == NULL )
	{
		send_to_char( "They aren't here.\n\r", ch );
		return;
	}
	if ((ch->fighting) != NULL) victim = ch->fighting;

	if ( arg[0] == '\0' )
	{
		send_to_char( "Whose skin do you want to fillet off?\n\r", ch );
		return;
	}

	if (victim->hit < 500)
	{
		send_to_char("They are far to hurt to do that!\n\r",ch);
		return;
	}

	if (is_safe(ch, victim))
	{
		send_to_char("Not while in a safe room!\n\r", ch);
		return;
	}

	if (IS_NPC(victim))
	{
		dam = ch->pcdata->powers[XPOWER_FLESH] * (75 * number_range(2,6)) + number_range(1,100);
		hurt_person(ch, victim, dam);
		ch->hit += dam / 2;
		if (ch->hit > ch->max_hit + 1000) ch->hit = ch->max_hit + 1000;
		sprintf( buf, "%s fillets your skin for [#r%d#n].\n\r", ch->name, dam );
		send_to_char( buf, victim );
		sprintf( buf, "You fillet %s's skin for [#r%d#n] [#L%d#n].\n\r", victim->name, dam, dam/2 );
		send_to_char( buf, ch );
		act("$n fillets off a bunch of skin from $N.", ch, NULL, victim, TO_NOTVICT);
		WAIT_STATE(ch,12);
		return;
	}

	if (!IS_NPC(victim))
	{
		dam = ch->pcdata->powers[XPOWER_FLESH] * (75 * number_range(2,6)) + number_range(1,100);
		hurt_person(ch, victim, dam);
		ch->hit += dam / 2;
		if (ch->hit > ch->max_hit + 1000) ch->hit = ch->max_hit + 1000;
		sprintf( buf, "%s fillets your skin for [#r%d#n].\n\r", ch->name, dam );
		send_to_char( buf, victim );
		sprintf( buf, "You fillet %s's skin for [#r%d#n].\n\r", victim->name, dam );
		send_to_char( buf, ch );
		act("$n fillets off a bunch of skin from $N.", ch, NULL, victim, TO_NOTVICT);
		WAIT_STATE(ch,12);
		return;
	}
}
/*
void do_brainless( CHAR_DATA *ch, char *argument )
{
CHAR_DATA *victim;
char      arg [MAX_INPUT_LENGTH];
int	dam;

argument = one_argument( argument, arg );

if (IS_NPC(ch)) return;
if (!IS_CLASS(ch, CLASS_XOMBI))
{
send_to_char("Huh?\n\r",ch);
return;
}

if ( ( victim = get_char_room( ch, arg ) ) == NULL )
{
send_to_char( "They aren't here.\n\r", ch );
return;
}

if ( arg[0] == '\0' )
{
send_to_char( "Do this to whom?\n\r", ch );
return;
}

if (is_safe(ch, victim))
{
send_to_char("Not while in a safe room!\n\r", ch);
return;
}

if (ch->pcdata->powers[XPOWER_MIND] < 1)
{
send_to_char("You need level 1 Mind to use brainless.\n\r",ch);
return;
}
if ( victim->hit > 0 )
{
send_to_char( "They must be mortally wounded for this!\n\r", ch );
return;
}
if (!IS_VAMPAFF(victim,VAM_SERPENTIS) )
{
if (IS_IMMUNE(victim,IMM_LOBOTOMY) )
{
send_to_char("But you've already pulled your brain out!\n\r",ch);
return;
}

SET_BIT(victim->immune, IMM_LOBOTOMY);
send_to_char("You rip the brain out of their head and toss it to the ground.\n\r",ch);
act("$n rips $s brain out and tosses it to the ground.", ch, NULL, NULL, TO_ROOM);
make_part( ch, "brain" );
dam = 500 * number_range(1,15) + number_range(1, 2000);
hurt_person(ch, victim, dam);
return;
}
}
*/

void do_stoneeyes( CHAR_DATA *ch, char *argument )
{
	char      arg [MAX_INPUT_LENGTH];
	argument = one_argument( argument, arg );

	if (IS_NPC(ch)) return;

	if ( !IS_CLASS(ch, CLASS_XOMBI))
	{
		stc("Huh?\n\r",ch);
		return;
	}

	if (IS_CLASS(ch, CLASS_XOMBI) && ch->pcdata->powers[XPOWER_MIND] < 4)
	{
		send_to_char("You need level 4 Mind to use stoneeyes.\n\r",ch);
		return;
	}

	if (IS_VAMPAFF(ch,VAM_NIGHTSIGHT) )
	{
		send_to_char("Your eyes change from stone to normal.\n\r",ch);
		act("$n's eyes change from stone to normal.", ch, NULL, NULL, TO_ROOM);
		REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_NIGHTSIGHT);
		return;
	}
	send_to_char("Your eyes change into stone.\n\r",ch);
	act("$n's eyes change into stone.", ch, NULL, NULL, TO_ROOM);
	SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_NIGHTSIGHT);
	return;
}

void do_coldeyes( CHAR_DATA *ch, char *argument )
{
	char      arg [MAX_INPUT_LENGTH];
	argument = one_argument( argument, arg );

	if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_XOMBI))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}

	if (IS_CLASS(ch, CLASS_XOMBI) && ch->pcdata->powers[XPOWER_MIND] < 5)
	{
		send_to_char("You need level 5 Mind to use coldeyes.\n\r",ch);
		return;
	}

	if (IS_AFFECTED(ch,AFF_SHADOWSIGHT) )
	{
		send_to_char("Your eyes warm up, and you can no longer see into the next realm.\n\r",ch);
		REMOVE_BIT(ch->affected_by, AFF_SHADOWSIGHT);
		return;
	}
	send_to_char("Your eyes cool, and you can now see into the next realm.\n\r",ch);
	SET_BIT(ch->affected_by, AFF_SHADOWSIGHT);
	return;
}

void do_deadeyes( CHAR_DATA *ch, char *argument )
{
	if ( IS_NPC(ch) )
		return;

	if (!IS_CLASS(ch, CLASS_XOMBI))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}

	if ( IS_CLASS(ch, CLASS_XOMBI) && ch->pcdata->powers[XPOWER_MIND] < 6)
	{
		send_to_char("You need level 6 Mind before you can use deadeyes.\n\r",ch);
		return;
	}

	if ( IS_SET(ch->act, PLR_HOLYLIGHT) )
	{
		REMOVE_BIT(ch->act, PLR_HOLYLIGHT);
		send_to_char( "Your view through the eyes of the dead has returned to normal.\n\r", ch );
	}
	else
	{
		SET_BIT(ch->act, PLR_HOLYLIGHT);
		send_to_char( "You now see through the eyes of the dead.\n\r", ch );
	}
	return;
}

void do_denerve( CHAR_DATA *ch, char *argument )
{ 
if (IS_NPC(ch)) return;
if (!IS_CLASS(ch, CLASS_XOMBI))
{
send_to_char("Huh?\n\r",ch);
return;
}
if (ch->pcdata->powers[XPOWER_BODY] < 1)
{
send_to_char("You need level 1 Body to use denerve.\n\r",ch);
return;
}
if ( IS_GAR1(ch, WOLF_COCOON) )
{
stc("Your ability to feel pain has returned.\n\r",ch);
act("$n can feel pain now.",ch,NULL,NULL,TO_ROOM);
REMOVE_BIT(ch->garou1, WOLF_COCOON);
return;
}
stc("You hit yourself in the neck and stop your ability to feel pain.\n\r",ch);
act("$n hits $s self in the neck and stops feeling pain.",ch,NULL,NULL,TO_ROOM);
SET_BIT(ch->garou1, WOLF_COCOON);
return;
}
 
void do_pulp( CHAR_DATA *ch, char *argument ) 
{
	char      arg [MAX_INPUT_LENGTH];
	argument = one_argument( argument, arg );

	if (IS_NPC(ch)) return;

	if ( !IS_CLASS(ch, CLASS_XOMBI))
	{
		stc("Huh?\n\r",ch);
		return;
	}
	if (IS_CLASS(ch, CLASS_XOMBI) && ch->pcdata->powers[XPOWER_BODY] < 2)
	{
		send_to_char("You need level 2 Body to use pulp.\n\r",ch);
		return;
	}

	if (IS_SET(ch->pcdata->stats[UNI_AFF],DEM_MIGHT) )
	{
		send_to_char("Your strength of the undead leaves you.\n\r",ch);
		act("$n's undead strength leaves $m.", ch, NULL, NULL, TO_ROOM);
		REMOVE_BIT(ch->pcdata->stats[UNI_AFF], DEM_MIGHT);
		return;
	}
        if (!IS_SET(ch->pcdata->stats[UNI_AFF],DEM_MIGHT))
        { 
	send_to_char("You gain the strength of the undead.\n\r",ch); 
	act("$n gains the strength of the undead.", ch, NULL, NULL, TO_ROOM);
	SET_BIT(ch->pcdata->stats[UNI_AFF], DEM_MIGHT);
	return;
}
}
void do_bonerip( CHAR_DATA *ch, char *argument )
{
	OBJ_INDEX_DATA *pObjIndex;
	OBJ_DATA *obj;
	char arg[MAX_INPUT_LENGTH];
	int vnum = 0;

	argument = one_argument( argument, arg );

	if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_XOMBI) || (ch->pcdata->stats[UNI_GEN] > 2) )
	{
		do_rand_typo(ch,"");
		return;
	}
	if (IS_CLASS(ch, CLASS_XOMBI) && ch->pcdata->powers[XPOWER_BODY] < 3)
	{
		send_to_char("You need level 3 Body to use bonerip.\n\r",ch);
		return;
	}
	if ( ch->practice < 100)
	{
		send_to_char("You need 100 primal to do a bonerip.\n\r", ch);
		return;
	}
	else ( vnum = 200013 );

	if ( vnum == 0 || (pObjIndex = get_obj_index( vnum )) == NULL)
	{
		send_to_char("Missing object, please inform Wolfman.\n\r",ch);
		return;
	}

	ch->practice   -= 100;
	obj = create_object(pObjIndex, 50);
	obj_to_char(obj, ch);
	SET_BIT(obj->spectype, SITEM_XOMBIWEAPON);
	obj->questowner = str_dup(ch->name);	//Set owner to Victim

	obj->questmaker = str_dup(ch->name);	//Set creator to CH

	act("You rip $p out of your ribcage.",ch,obj,NULL,TO_CHAR);
	act("$n rips $p out of $s ribcage.",ch,obj,NULL,TO_ROOM);
	return;
}


void do_skina( CHAR_DATA *ch, char *argument ) 
{
	char arg [MAX_INPUT_LENGTH];
	char buf [MAX_STRING_LENGTH]; 
	int cost; 
	OBJ_INDEX_DATA *pObjIndex;
	OBJ_DATA *obj;
	int vnum = 0;

	cost = 50000;

	argument = one_argument( argument, arg );

	if ( IS_NPC( ch ) )
	{
		send_to_char( "Huh?\n\r", ch );
		return;
	}

	if ( !IS_CLASS( ch, CLASS_XOMBI ) )
	{
		send_to_char( "You tug at your skin but it hurts too much!\n\r", ch );
		return;
	}

	if ( ch->practice < 100 )
	{
		send_to_char( "You do not have the required 100 primal!\n\r", ch );
		return;
	}
	
	if ( ch->pcdata->powers[XOMBI_SKIN] < cost )
	{
	sprintf( buf, "It costs 50,000 skins to make this armor, and you only have %d!\n\r", ch->pcdata->powers[XOMBI_SKIN] );
	send_to_char( buf, ch );
	return;
	}
	
	if ( !str_cmp( arg, "Finger") )	vnum = 200001;
	else if ( !str_cmp( arg, "Neck"  ) ) 	vnum = 200002;
	else if ( !str_cmp( arg, "Body"  ) ) 	vnum = 200008;
	else if ( !str_cmp( arg, "Head"  ) )	vnum = 200011;
	else if ( !str_cmp( arg, "Legs"  ) )	vnum = 200005;
	else if ( !str_cmp( arg, "hands" ) )	vnum = 200004;
	else if ( !str_cmp( arg, "arms"  ) )	vnum = 200012;
	else if ( !str_cmp( arg, "about" ) )	vnum = 200010;
	else if ( !str_cmp( arg, "waist" ) )	vnum = 200007;
	else if ( !str_cmp( arg, "wrist" ) )	vnum = 200003;
	else if ( !str_cmp( arg, "face"  ) )	vnum = 200009;
	else if ( !str_cmp( arg, "feet"  ) )	vnum = 200006;
	else
	    {
		send_to_char( "You must choose one of the armor types:\n\r", ch );
		send_to_char( "Finger, Neck, Body, Head, Legs, hands, Arms,\n\r", ch );
		send_to_char( "About, Waist, Wrist, Face, Feet.\n\r", ch );
		return;
	}

	if ( vnum == 0 || (pObjIndex = get_obj_index( vnum )) == NULL)
	{
		send_to_char("Missing object, please inform an SG admin.\n\r",ch);
		return;
	}

	ch->practice -= 100;
	ch->pcdata->powers[XOMBI_SKIN] -= cost;
	ch->pcdata->powers[XOMBI_AC] += 1;
	obj = create_object(pObjIndex, 50);
	obj_to_char(obj, ch);
	SET_BIT(obj->spectype, SITEM_XOMBIWEAPON);
	obj->questowner = str_dup(ch->name);    	//Set owner to Victim

	obj->questmaker = str_dup(ch->name);    	//Set creator to CH

	act("You peel $p from your skin.",ch,obj,NULL,TO_CHAR);
	act("$n peels $p from $s's skin.",ch,obj,NULL,TO_ROOM);
	return;
}


void do_enamel( CHAR_DATA *ch, char *argument )
{
	char      arg [MAX_INPUT_LENGTH];
	argument = one_argument( argument, arg );

	if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_XOMBI))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}
	if (IS_CLASS(ch, CLASS_XOMBI) && ch->pcdata->powers[XPOWER_BODY] < 4)
	{
		send_to_char("You need level 4 Body to use enamel.\n\r",ch);
		return;
	}

	if (IS_VAMPAFF(ch,VAM_FANGS) )
	{
		if (IS_CLASS(ch, CLASS_XOMBI))
		{
			send_to_char("Your teeth return to their normal whiteness.\n\r",ch);
			act("$n's teeth return to their normal whiteness.", ch, NULL, NULL, TO_ROOM);
		}
		REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_FANGS);
		return;
	}

	if (IS_CLASS(ch, CLASS_XOMBI))
	{
		send_to_char("Your teeth become dingy and yellow.\n\r",ch);
		act("$n's teeth become dingy and yellow.", ch, NULL, NULL, TO_ROOM);
	}
	SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_FANGS);
	return;
}

void do_nails( CHAR_DATA *ch, char *argument )
{
	char      arg [MAX_INPUT_LENGTH];
	argument = one_argument( argument, arg );

	if (IS_NPC(ch)) return;

	if (!IS_CLASS(ch, CLASS_XOMBI))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}

	if (IS_CLASS(ch, CLASS_XOMBI) && ch->pcdata->powers[XPOWER_BODY] < 5)
	{
		send_to_char("You need level 5 Body to use nails.\n\r",ch);
		return;
	}

	if (IS_VAMPAFF(ch,VAM_CLAWS) )
	{
		if (IS_CLASS(ch, CLASS_XOMBI))
		{
			send_to_char("Your finger nails return to normal.\n\r",ch);
			act("$n's finger nails return to normal.", ch, NULL, NULL, TO_ROOM);
		}
		REMOVE_BIT(ch->pcdata->stats[UNI_AFF], VAM_CLAWS);
		return;
	}

	if (IS_CLASS(ch, CLASS_XOMBI))
	{
		send_to_char("Your finger nails become much stronger.\n\r",ch);
		act("$n's finger nails become much stronger.", ch, NULL, NULL, TO_ROOM);
	}
	SET_BIT(ch->pcdata->stats[UNI_AFF], VAM_CLAWS);
	return;
}

void do_chew( CHAR_DATA *ch, char *argument )
{
	char	arg[MAX_INPUT_LENGTH];

	argument = one_argument (argument, arg);

	if (IS_NPC(ch)) return;
	if (!IS_CLASS(ch, CLASS_XOMBI))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}
	if (ch->pcdata->powers[XPOWER_BODY] < 6)
	{
		send_to_char("You need level 6 Body to use chew.\n\r",ch);
		return;
	}

	stc("You try to chew through your restraints.\n\r",ch);
	act("$n chews at $s restraints.",ch,NULL,NULL,TO_ROOM);

	if ( IS_EXTRA(ch, TIED_UP) )
	{
		act("The ropes restraining you snap.",ch,NULL,NULL,TO_CHAR);
		act("The ropes restraining $n snap.",ch,NULL,NULL,TO_ROOM);
		REMOVE_BIT(ch->extra, TIED_UP);
	}
	if (is_affected(ch, gsn_web))
	{
		act("The webbing entrapping $n breaks away.",ch,NULL,NULL,TO_ROOM);
		send_to_char("The webbing entrapping you breaks away.\n\r",ch);
		affect_strip(ch, gsn_web);
	}
	if (IS_AFFECTED(ch, AFF_WEBBED))
	{
		act("The webbing entrapping $n breaks away.",ch,NULL,NULL,TO_ROOM);
		send_to_char("The webbing entrapping you breaks away.\n\r",ch);
		REMOVE_BIT(ch->affected_by, AFF_WEBBED);
	}

	//    if (IS_AFFECTED(ch, AFF2_TENDRILS))
//    {
//      	act("The tendrils entrapping $n break away.",ch,NULL,NULL,TO_ROOM);
//      	send_to_char("The tendrils entrapping you break away.\n\r",ch);
//      	REMOVE_BIT(ch->affected_by, AFF2_TENDRILS);
//    }

	return;
}

void do_munch( CHAR_DATA *ch, char *argument )
{
	CHAR_DATA *victim;
	char      arg [MAX_INPUT_LENGTH];
	char      buf [MAX_INPUT_LENGTH];
	bool      can_sire = FALSE;

	argument = one_argument( argument, arg );

	if (IS_NPC(ch)) return;

	if ( !IS_CLASS( ch, CLASS_XOMBI ) ) return;

	if (IS_SET(ch->special,SPC_PRINCE)) can_sire = TRUE;
	if (IS_SET(ch->special,SPC_SIRE)) can_sire = FALSE;
	if (ch->pcdata->stats[UNI_GEN] <= 2) can_sire = TRUE;

	if (ch->pcdata->stats[UNI_GEN] > 3) can_sire = FALSE;
	else can_sire = FALSE;

	if (!can_sire)
	{
		send_to_char("Their flesh is unappealing.\n\r",ch);
		return;
	}

	if (ch->pcdata->stats[UNI_GEN] == 1 && ch->pcdata->stats[UNI_AFF] >= 4)
	{
		send_to_char("You have already created 4 xombi lords.\n\r",ch);
		return;
	}
	else if (ch->pcdata->stats[UNI_GEN] != 1 && ch->pcdata->stats[UNI_AFF] >= 2)
	{
		send_to_char("You have already created 2 undead.\n\r",ch);
		return;
	}

	if (strlen(ch->clan) < 2 && ch->pcdata->stats[UNI_GEN] != 1 )
	{
		send_to_char( "You need to first create a grouping of eaters of the flesh.\n\r", ch );
		return;
	}

	if ( arg[0] == '\0' )
	{
		send_to_char( "Turn whose flesh undead?\n\r", ch );
		return;
	}

	if ( ( victim = get_char_room( ch, arg ) ) == NULL )
	{
		send_to_char( "They aren't here.\n\r", ch );
		return;
	}

	if ( IS_NPC(victim) )
	{
		send_to_char( "Not on NPC's.\n\r", ch );
		return;
	}

	if ( IS_IMMORTAL(victim) )
	{
		send_to_char( "Not on Immortal's.\n\r", ch );
		return;
	}

	if ( ch == victim )
	{
		send_to_char( "Your flesh is already undead.\n\r", ch );
		return;
	}

	if (IS_CLASS(victim, CLASS_MONK))
	{
		send_to_char("You cannot make an undead monk.\n\r", ch);
		return;
	}

	if (IS_CLASS(victim, CLASS_MAGE))
	{
		send_to_char( "You cannot make an undead mage.\n\r", ch );
		return;
	}

	if ( victim->level != LEVEL_AVATAR && !IS_IMMORTAL(victim) )
	{
		send_to_char( "Avatar flesh is much better than mortal flesh.\n\r", ch );
		return;
	}

	if (IS_CLASS(victim, CLASS_DROW))
	{
		send_to_char( "You cannot make an undead drow.\n\r", ch );
		return;
	}

	if (IS_CLASS(victim, CLASS_VAMPIRE) || IS_SET(victim->pcdata->stats[UNI_AFF], VAM_MORTAL))
	{
		send_to_char( "Vamps are already undead!\n\r", ch );
		return;
	}

	if (IS_CLASS(victim, CLASS_DEMON) || IS_SET(victim->special, SPC_CHAMPION))
	{
		send_to_char( "No undead demons!\n\r", ch );
		return;
	}

	if (IS_CLASS(victim, CLASS_HIGHLANDER))
	{
		send_to_char( "Highlanders don't die, so don't bother.\n\r", ch );
		return;
	}

	if (IS_CLASS(victim, CLASS_NINJA) )
	{
		send_to_char("An undead ninja would be a dead ninja.\n\r", ch);
		return;
	}

	if (IS_CLASS(victim, CLASS_PALADIN))
	{
		send_to_char( "You cannot turn paladins into undead.\n\r", ch);
		return;
	}

	if (IS_CLASS(victim, CLASS_WEREWOLF))
	{
		send_to_char( "Werewolves wouldn't like being undead, their fur would smell bad.\n\r", ch );
		return;
	}

	if (!IS_IMMUNE(victim,IMM_VAMPIRE))
	{
		send_to_char( "Their flesh is unwilling.\n\r", ch );
		return;
	}

	if (IS_CLASS(victim, CLASS_XOMBI) && strlen(ch->clan) < 2 )
	{
		sprintf( buf, "You have been inducted into %s", ch->clan );
		send_to_char( buf, victim );
		sprintf(buf, "You have inducted %s into your clan!\n\r", victim->name );
		send_to_char( buf, ch );
		free_string(victim->lord);
		if (ch->pcdata->stats[UNI_GEN] == 1)
			victim->lord=str_dup(ch->name);
		else
		    {
			sprintf(buf,"%s %s",ch->lord,ch->name);
			victim->lord=str_dup(buf);
		}

		free_string(victim->clan);
		victim->clan = str_dup(ch->clan);
		victim->pcdata->stats[UNI_AFF] = 0;
		victim->pcdata->stats[UNI_CURRENT] = 0;
		save_char_obj(ch);
		save_char_obj(victim);
		return;
	}


	if (!IS_VAMPAFF(ch,VAM_FANGS))
	{
		send_to_char("Your teeth are not strong enough to break skin.\n\r",ch);
		return;
	}

	if (ch->exp < 250000)
	{
		send_to_char("You cannot afford the 250000 exp to turn flesh undead.\n\r",ch);
		return;
	}

	ch->exp -= 250000;

	if (ch->pcdata->stats[UNI_CURRENT] < 1) ch->pcdata->stats[UNI_CURRENT] = 1;
	else ch->pcdata->stats[UNI_CURRENT] += 1;

	if (IS_SET(ch->special,SPC_SIRE)) REMOVE_BIT(ch->special,SPC_SIRE);

	act("You sink your teeth into $N's pinkie finger and rip it off!", ch, NULL, victim, TO_CHAR);
	act("$n sinks $s teeth into $N's pinkie finger and rips it off!.", ch, NULL, victim, TO_NOTVICT);
	act("$n sinks $s teeth into your pinkie finger and rips it off!.", ch, NULL, victim, TO_VICT);

	victim->class=CLASS_XOMBI;
	SET_BIT(victim->loc_hp[64],LOST_FINGER_L);
	make_part(victim,"little finger");
	do_get(ch,"finger");
	do_eat(ch,"finger");

	send_to_char( "You are now one of the undead, a Xombi.\n\r", victim );
	victim->pcdata->stats[UNI_GEN] = ch->pcdata->stats[UNI_GEN] + 1;
	free_string(victim->lord);
	if (ch->pcdata->stats[UNI_GEN] == 1)
		victim->lord=str_dup(ch->name);
	else
	    {
		sprintf(buf,"%s %s",ch->lord,ch->name);
		victim->lord=str_dup(buf);
	}

	free_string(victim->clan);
	victim->clan = str_dup(ch->clan);
	victim->pcdata->stats[UNI_AFF] = 0;
	victim->pcdata->stats[UNI_CURRENT] = 0;
	save_char_obj(ch);
	save_char_obj(victim);
	return;
}

void do_brainhunt (CHAR_DATA *ch, char *argument)
{
	CHAR_DATA *victim;
	char arg[MAX_STRING_LENGTH];
	ROOM_INDEX_DATA *location;

	one_argument (argument, arg);

	if (IS_NPC(ch)) return;
	if (!IS_CLASS(ch, CLASS_XOMBI))
	{
		send_to_char("Huh?\n\r",ch);
		return;
	}
	else if (ch->pcdata->powers[XPOWER_BODY] < 7 )
	{
		send_to_char( "You need Body level 7 to use this skill.\n\r", ch);
		return;
	}
	if ((victim = get_char_world(ch, arg)) == NULL)
	{
		send_to_char("Who's brains look tasty?\n\r", ch );
		return;
	}
	location = victim->in_room;
	act("You sniff the air, smell FRESH BRAINS, and go chasing after them!!", ch, NULL, NULL, TO_CHAR);
	act("$n sniffs the air, yells MMMMmmmm FRESH BRAINS, and runs out of the room!!", ch, NULL, NULL, TO_ROOM);
	char_from_room(ch);
	char_to_room(ch, location);
	do_look(ch, "auto");
	act("Your keen sense of smell for fresh brains has paid off!!", ch, NULL, NULL, TO_CHAR);
	act("$n walks into the room and yells FRESH BRAINS!!!!", ch, NULL, NULL, TO_ROOM);
	WAIT_STATE(ch, 2);
	return;
}

void do_strongflesh( CHAR_DATA *ch, char *argument )
{
	char arg [MAX_INPUT_LENGTH]; 
	argument = one_argument( argument, arg );

	if (IS_NPC(ch)) return;
    
	if ( !IS_CLASS(ch, CLASS_XOMBI))
	{
		stc("Huh?\n\r",ch);
		return;
	}
	if (IS_CLASS(ch, CLASS_XOMBI) && ch->pcdata->powers[XPOWER_FLESH] < 6)
	{
		send_to_char("You need level 6 Flesh to use strongflesh.\n\r",ch);
		return;
	}
	if (IS_SET(ch->pcdata->stats[UNI_AFF],DEM_TOUGH))
	{
		send_to_char("Your skin begins to weaken and rot.\n\r",ch);
		act("$n's skin begins to rot.", ch, NULL, NULL, TO_ROOM);
		REMOVE_BIT(ch->pcdata->stats[UNI_AFF], DEM_TOUGH);
		return; 
	}
        if (!IS_SET(ch->pcdata->stats[UNI_AFF],DEM_TOUGH))
        {
	send_to_char("Your skin becomes extremely strong.\n\r",ch); 
	act("$n's skin heals up all signs of rot and looks new.", ch, NULL, NULL, TO_ROOM);
	SET_BIT(ch->pcdata->stats[UNI_AFF], DEM_TOUGH);
	return;
}
}
void do_genius (CHAR_DATA *ch, char *argument)
{
  char arg[MAX_STRING_LENGTH];                                  
  CHAR_DATA *victim;                                                            
  AFFECT_DATA af;                                                               
  int i, dam, count, sn;                                                        
  int red_magic = ch->spl[RED_MAGIC];                                           
  int blue_magic = ch->spl[BLUE_MAGIC];                                         
  int green_magic = ch->spl[GREEN_MAGIC];                                       
  int purple_magic = ch->spl[PURPLE_MAGIC];                                     
  int yellow_magic = ch->spl[YELLOW_MAGIC];                                     
  argument=one_argument(argument,arg);                                         

  if (IS_NPC(ch)) return;                                                       
  if (!IS_CLASS(ch, CLASS_XOMBI))             
  {                                                                             
    send_to_char("Huh?\n\r",ch);                                                
    return;                                                                     
  }
  if ( IS_CLASS(ch, CLASS_XOMBI) && ch->pcdata->powers[XPOWER_MIND] < 3 )
  {
  send_to_char("You need level 3 Mind to use this power.\n\r",ch);
  return;
  }    
    if (arg[0] == '\0')
    {
    send_to_char("Who do you wish to use Genius on?\n\r",ch);
    return;
    }     
    if ((victim = get_char_room(ch, arg)) == NULL) 
    {                                                                           
      send_to_char("They are not here.\n\r", ch );                              
      return;                                                                   
    }                                                                           
    if (ch->mana <25)                                                         
    {                                                                           
      send_to_char("You need 25 mana.\n\r",ch);                               
      return;                                                                   
    }                                                                           
    if (victim->position == POS_DEAD || ch->in_room != victim->in_room)         
      return;                                                                   
    count = 0;                                                                  
    for (i = 0;i<5;i++)                                                         
    {                                                                           
      if (i==0) {sn = skill_lookup("purple sorcery");dam=purple_magic;}         
      if (i==1) {sn = skill_lookup("yellow sorcery");dam=yellow_magic;}         
      if (i==2) {sn = skill_lookup("green sorcery");dam=green_magic;}           
      if (i==3) {sn = skill_lookup("red sorcery");dam=red_magic;}               
      if (i==4) {sn = skill_lookup("blue sorcery");dam=blue_magic;}             
      if (is_affected(victim, sn))                                              
        continue;                                                               

      count++;                                                                  

      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_HIT;                                                 
      af.modifier  = -dam*2;                                                    
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_AC;                                                  
      af.modifier  = dam/2;                                                     
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_MOVE;                                                
      af.modifier  = -dam*2;                                                    
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_MANA;                                                
      af.modifier  = -dam*2;                                                    
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_HITROLL;                                             
      af.modifier  = -dam/3;                                                    
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
      af.type      = sn;                                                        
      af.duration  = dam/4;                                                     
      af.location  = APPLY_DAMROLL;                                             
      af.modifier  = -dam/3;                                                    
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              
    }                                                                           
    ch->mana -= count * 5;                                                    
    WAIT_STATE(ch,2); 
    act("You snicker, then slap $N upside the head!!",ch,NULL,victim,TO_CHAR);
    act("$n snickers, then slaps you upside the head!!",ch,NULL,victim,TO_VICT);
    act("$n snickers, then slaps $N upside the head!!",ch,NULL,victim,TO_NOTVICT);
    return; 
  }                                                                             

void do_rip (CHAR_DATA *ch, char *argument)                                  
{                                                                               
  char arg[MAX_STRING_LENGTH];                                                  
  CHAR_DATA *victim;                                                            
  AFFECT_DATA af;                                                               
  int i, dam, count, sn;                                                        
  int red_magic = ch->spl[RED_MAGIC];                                           
  int blue_magic = ch->spl[BLUE_MAGIC];                                         
  int green_magic = ch->spl[GREEN_MAGIC];                                       
  int purple_magic = ch->spl[PURPLE_MAGIC];                                     
  int yellow_magic = ch->spl[YELLOW_MAGIC];                                     
  argument=one_argument(argument,arg);                                          
                                                                                
  if (IS_NPC(ch)) return;                                                       
  if (!IS_CLASS(ch, CLASS_XOMBI))                                               
  {                                                                             
    send_to_char("Huh?\n\r",ch);                                                
    return;                                                                     
  }                                                                             
  if ( IS_CLASS(ch, CLASS_XOMBI) && ch->pcdata->powers[XPOWER_FLESH] < 3 )    
  {                                                                             
  send_to_char("You need level 3 Flesh to use this power.\n\r",ch);         
  return;                                                                       
  }                                                                             
    if (arg[0] == '\0')                                                         
    {                                                                           
    send_to_char("Who's skin do you want to rip off in little pieces?\n\r",ch); 
    return;                                                                     
    }                                                                           
    if ((victim = get_char_room(ch, arg)) == NULL)                              
    {                                                                           
      send_to_char("They are not here.\n\r", ch );                              
      return;                                                                   
    }                                                                           
    if (ch->mana < 5000)                                                           
    {                                                                           
      send_to_char("You need 5000 mana.\n\r",ch);                                 
      return;                                                                   
    }                                                                           
    if (victim->position == POS_DEAD || ch->in_room != victim->in_room)         
      return;                                                                   
    count = 0;                                                                  
    for (i = 0;i<5;i++)                                                         
    {                                                                           
      if (i==0) {sn = skill_lookup("purple sorcery");dam=purple_magic;}         
      if (i==1) {sn = skill_lookup("yellow sorcery");dam=yellow_magic;}         
      if (i==2) {sn = skill_lookup("green sorcery");dam=green_magic;}           
      if (i==3) {sn = skill_lookup("red sorcery");dam=red_magic;}               
      if (i==4) {sn = skill_lookup("blue sorcery");dam=blue_magic;}
      if (is_affected(victim, sn))
        continue; 
                                                                                
      count++; 

      af.type      = sn; 
      af.duration  = 10;                                                     
      af.location  = APPLY_HITROLL;                                                 
      af.modifier  = -dam*2;
      af.bitvector = 0;                                                         
      affect_to_char(victim, &af);                                              

      af.type		= sn;
      af.duration	= 10;
      af.location 	= APPLY_DAMROLL;
      af.modifier	= -dam*2;
      af.bitvector	= 0;
      affect_to_char(victim, &af);

      af.type		= sn;
      af.duration	= 10;
      af.location	= APPLY_AC;
      af.modifier	= +dam*4;
      af.bitvector	= 0;
      affect_to_char(victim, &af);
    }
    ch->mana -= count * 1200;
    WAIT_STATE(ch,2);
    act("You grab hold of $N, and rip $S skin off in little pieces.",ch,NULL,victim,TO_CHAR);
    act("$n grabs hold of you, and rips off your skin in little pieces.",ch,NULL,victim,TO_VICT);
    act("$n grabs hold of $N, and rips off $N's skin in little pieces.",ch,NULL,victim,TO_NOTVICT);
    return; 
  }

void do_decompose (CHAR_DATA *ch, char *argument)
{
  char arg[MAX_INPUT_LENGTH];
  char buf[MAX_STRING_LENGTH];

  one_argument( argument, arg);
  if (IS_NPC(ch)) return;
  if (!IS_CLASS(ch, CLASS_XOMBI))
  {
    send_to_char("Huh.\n\r",ch);
    return;
  }
  else if (ch->pcdata->powers[XPOWER_FLESH] < 7 )
  {
    send_to_char( "You need Flesh level 7 to use this skill.\n\r", ch);
    return;
  }

  if (arg[0] == '\0')
  {
    send_to_char("What form do you want to shift to? [Skeleton/Xombi]\n\r",ch);
    return;
  }
  if (!str_cmp(arg,"skeleton"))
  {
    if (ch->pcdata->powers[XOMBI_FORM] != 0) do_shift(ch, "xombi");
    if (IS_SET(ch->affected_by, AFF_POLYMORPH))
    {
      send_to_char("Not while polymorphed.\n\r",ch);
      return;
    }
    act("You rip off all your flesh down to the bone.", ch, NULL, NULL, TO_CHAR);
    act("$n rips off all their flesh right down to their skeleton.", ch, NULL, NULL, TO_ROOM);
    ch->pcdata->powers[XOMBI_FORM]=SKELETON_FORM;
    SET_BIT(ch->affected_by, AFF_POLYMORPH);
    ch->damroll += 2500;
    ch->hitroll += 2500;
    ch->armor   -= 5000;
    {
    sprintf(buf,"%s the skeleton",ch->name);
    free_string(ch->morph);
    ch->morph = str_dup(buf);
    return;
    }
    }
    else if (!str_cmp(arg,"xombi")) 
    {
    if (ch->pcdata->powers[XOMBI_FORM] == 0 && !IS_SET(ch->affected_by, AFF_POLYMORPH))
    {
      send_to_char("Your all ready in Xombi form.\n\r",ch);
      return;
    }
    if (IS_SET(ch->pcdata->powers[XOMBI_FORM], SKELETON_FORM))
    {
      ch->damroll -= 2500;
      ch->hitroll -= 2500;
      ch->armor   += 5000;
    }
    ch->pcdata->powers[SHAPE_FORM]=0;
    REMOVE_BIT(ch->affected_by, AFF_POLYMORPH);
    send_to_char("Your return to your Xombi form.\n\r",ch);
    free_string(ch->morph);
    ch->morph=str_dup("");
    return;
  }
  else
  {
    send_to_char("That is not a valid form.\n\r",ch);
    return;
  }
}

void do_lobotomy (CHAR_DATA *ch, char *argument)                            
{                                                                               
        CHAR_DATA *victim;                                                      
        OBJ_DATA *obj;                                                          
        char arg [MAX_INPUT_LENGTH];                                            
        char buf [MAX_STRING_LENGTH];                                           
        argument = one_argument (argument, arg);                                
        if (IS_NPC(ch)) return;                                                 
        if (!IS_CLASS(ch, CLASS_XOMBI))                                         
        {                                                                       
                send_to_char("Huh?\n\r",ch);                                    
                return;                                                         
        }                                                                       
       if (ch->pcdata->powers[XPOWER_MIND] < 2)                               
        {                                                                       
                send_to_char("You need level 2 Mind to use Lobotomy.\n\r",ch);
                return;                                                         
        }                                                                       
        if ( arg[0] == '\0' )                                                   
        {                                                                       
                send_to_char("Who do you wish to feed on?\n\r",ch);             
                return;                                                         
        }                                                                       
        victim = get_char_room(ch, arg);                                        
        if ( ( victim = get_char_room( ch, arg) ) == NULL )                     
        {                                                                       
                send_to_char("They arent here.\n\r",ch);                        
                return;                                                         
        }                                                                       
        victim = get_char_room(ch, arg);                                        
        if ( ( victim = get_char_room( ch, arg) ) == NULL )                     
        {                                                                       
                send_to_char("They arent here.\n\r",ch);                        
                return;                                                         
        }                                                                       
        if (IS_SET(victim->in_room->room_flags, ROOM_SAFE))                     
        {                                                                       
                send_to_char("You cannot attack them here.\n\r",ch);            
                return;                                                         
        }                                                                       
        if (is_safe(ch,victim) == TRUE)                                         
                return;                             
        if (IS_SET(victim->loc_hp[9],LOST_BRAIN))     
        {                                                                       
                send_to_char("You pulled out their brains already!\n\r",ch); 
                return;                                                         
        }                                                                       
        if (number_percent ( ) < 45 )                                           
        {                                                                       
                if (!IS_SET(victim->loc_hp[9],LOST_BRAIN))                      
                {                                                               
                       SET_BIT(victim->loc_hp[9],LOST_BRAIN);               
                        if ((obj = get_eq_char( victim, WEAR_HEAD )) != NULL)
                                take_item(victim,obj);                          
                        make_part(victim,"brain");                             
                        sprintf(buf, "%s rips %s's brains out!",ch->name, victim->name);
                        send_to_char(buf,ch); 
                        act(buf,ch,NULL,NULL,TO_ROOM);                          
                        do_get(ch,"brain");                                     
                        do_eat(ch,"brain");                                   
                        if (victim->hit >= 300)                                 
                        {                                                       
                                sh_int power;                                   
                                sh_int dam;                                     
                                power = 100;                                    
                                dam = dice(power, power + 2);                   
                                if (dam < 0) dam = 0;                           
                                if (dam > ch->max_hit) dam = (ch->max_hit/ 2); 
                                if (dam > 1500) dam = 1500;                     
                                victim->hit -= dam;                             
                                ch->hit += dam / 2;                             
                                if (ch->hit >= ch->max_hit + 250)               
                                        ch->hit = ch->max_hit + 250;            
                                sprintf(buf,"#1You absorb %d hitpoints from your meal.#n\n\r",dam);
                                send_to_char(buf,ch); 
                                return;                                         
                                }
			       }
		      	      }

}

void do_detongue( CHAR_DATA *ch, char *argument )      
{                                                                               
    char arg[MAX_INPUT_LENGTH];  
    char buf[MAX_STRING_LENGTH];                               
    CHAR_DATA *victim; 
    OBJ_DATA *obj;
    one_argument( argument, arg );
                                              
    if (IS_NPC(ch)) return; 
    if (!IS_CLASS(ch, CLASS_XOMBI))
    {
           send_to_char( "Huh?\n\r", ch );
           return;
    }
    else if ( ch->pcdata->powers[XPOWER_FLESH] < 8 )
    {
            send_to_char( "You need Flesh level 8 to use this skill.\n\r",ch);
            return;
    } 
    if ( arg[0] == '\0' ) 
    {                                                                           
        send_to_char( "Rip who's tongue out?", ch );                     
        return;                                                                 
    }                                                                           
    if ( ( victim = get_char_room( ch, arg ) ) == NULL )                       
    {                                                                           
        send_to_char( "They aren't here.\n\r", ch );                            
        return;                                                                 
    }                                                                           
    if ( IS_NPC(victim) )                                                       
    {                                                                           
        send_to_char( "Not on NPC's.\n\r", ch );                                
        return;                                                                 
    }                                                                           
    if ( IS_HEAD(victim, LOST_TONGUE) || IS_HEAD(victim, LOST_HEAD))
    {                                                                           
        send_to_char( "Their tongue has already been ripped out!\n\r", ch);
    }                                                                           
    else if (!IS_HEAD(victim, LOST_TONGUE) || !IS_HEAD(victim, LOST_HEAD))
    {                                                                           
        act( "You reach deeply into $N's mouth, rip out their tongue, and eat it!\n\r",ch,NULL,victim,TO_CHAR);
        act( "$n reaches deeply into your mouth, rips out your tongue, and eats it!\n\r",ch,NULL,victim,TO_VICT);
        act( "$n reaches deeply into $N's mouth, rips out their tongue, and eats it!\n\r",ch,NULL,victim,TO_ROOM);
        SET_BIT(victim->loc_hp[LOC_HEAD],LOST_TONGUE);            
        if ((obj = get_eq_char( victim, WEAR_FACE )) != NULL )   
        take_item(victim,obj);                          
        make_part(victim,"tongue");                         
        do_get(ch,"tongue");                                  
	do_eat(ch,"tongue");
        if (victim->hit >= 300)
	{
          sh_int power;                                   
          sh_int dam;                                     
          power = 100;                                    
          dam = dice(power, power + 2);                   
          if (dam < 0) dam = 0;                           
          if (dam > ch->max_hit) dam = (ch->max_hit/2); 
          if (dam > 1500) dam = 1500;                     
          victim->hit -= dam;                             
          ch->hit += dam / 2;                             
          if (ch->hit >= ch->max_hit + 250)               
          ch->hit = ch->max_hit + 250;            
          sprintf(buf,"#1You absorb %d hitpoints from your meal.#n\n\r",dam);
          send_to_char(buf,ch);                           
          return;                                         
        }
    }
}

